#include <bits/stdc++.h>

using namespace std;

const int inf  = 0x3f3f3f3f;
const int maxn = 2605;
const double eps  = 1e-10;

pair <int, int> v[maxn * 2];

int n, ok;
double aux[maxn * 2];

void checkTangents(int x, int y) {
    for (int i = 1; i <= 2 * n; i++) {
        if (v[ i ].first == x)
            aux[ i ] = inf;
        else
            aux[ i ] = 1.0 * (v[ i ].second - y) / (v[ i ].first - x);
        if (v[ i ].second == y && v[ i ].first == x)
            return;
    }

    sort(aux + 1, aux + 2 * n + 1);
    int diff = 1;
    for (int i = 2; i <= 2 * n; i++)
        if (abs(aux[ i ] - aux[i - 1]) > eps)
            diff++;
    if (diff == n) {
        ok = 1;
        cout << "Yes\n" << x << " " << y;
    }
}

void integerIntersection(int p1, int p2, int p3, int p4) {
    long long x, y;
    long long m;
    if (v[ p1 ].first == v[ p2 ].first) {
        if (v[ p3 ].first == v[ p4 ].first)
            return;
        x = v[ p1 ].first;
        m = (v[ p4 ].second - v[ p3 ].second) / (v[ p4 ].first - v[ p3 ].first);
        y = m * (x - v[ p4 ].first) + v[ p4 ].second;
    }
    else {
        if (v[ p3 ].first == v[ p4 ].first) {
            x = v[ p3 ].first;
            m = (v[ p2 ].second - v[ p1 ].second) / (v[ p2 ].first - v[ p1 ].first);
            y = m * (x - v[ p2 ].first) + v[ p2 ].second;
        }

        else {
            long long m1, m2;
            m1 = (v[ p2 ].second - v[ p1 ].second) / (v[ p2 ].first - v[ p1 ].first);
            m2 = (v[ p4 ].second - v[ p3 ].second) / (v[ p4 ].first - v[ p3 ].first);
            if (m1 == m2)
                return;
            long long x1, y1, x2, y2;
            x1 = v[ p1 ].first;
            y1 = v[ p1 ].second;
            x2 = v[ p3 ].first;
            y2 = v[ p3 ].second;
            if (abs(m1 * x1 - y1 - m2 * x2  + y2) % abs(m1 - m2) == 0) {
                x = (m1 * x1 - y1 - m2 * x2  + y2) / (m1 - m2);
                y = m1 * (x - x1) + y1;
            }
            else
                return;
        }
    }
    if (abs( x ) <= 1e6 && abs( y ) <= 1e6)
        checkTangents(x, y);
}

void checkPoints(int p1, int p2) {
    int p3, p4;
    if (p2 == 2)
        p3 = 3;
    else
        p3 = 2;

    for (int i = 3; i <= 2 * n; i++) {
        if (i != p2 && i != p3)
            if (v[ i ].first == v[ p3 ].first || abs(v[ i ].second - v[ p3 ].second) % abs(v[ i ].first - v[ p3 ].first) == 0) {
                p4 = i;
                integerIntersection(p1, p2, p3, p4);
            }
    }
}

int main()
{
    //freopen( "input", "r", stdin );
    //freopen( "output","w", stdout);

    cin >> n;
    for (int i = 1; i <= 2 * n; i++)
        cin >> v[ i ].first >> v[ i ].second;

    for (int i = 2; i <= 2 * n && !ok; i++) {
        if (v[ i ].first == v[ 1 ].first || abs(v[ i ].second - v[ 1 ].second) % abs(v[ i ].first - v[ 1 ].first) == 0) {
            checkPoints(1, i);
        }
    }

    if (ok == 0)
        cout << "No";

    return 0;
}
