#include <bits/stdc++.h>
#define endl '\n'

#define int long long
#define double long double

using namespace std;
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
const int MAXN = (5617);
const double eps = 1e-13;
const int bound = (int)1e6;
const double inf = 1e17;

typedef pair<int, int> pii;
typedef pair<pii, pii> piii;

struct point
{
    int x, y;
    point() { x = y = 0; }
    point(int _x, int _y)
    {
        x = _x;
        y = _y;
    }
};

int n;
point a[MAXN];

void read()
{
    cin >> n;
    n *= 2;
    for(int i = 0; i < n; i++)
        cin >> a[i].x >> a[i].y;
}

bool is_cord_ok(double x)
{
    double err = (x - (int)(x + 0.5));
    x = (int)(x + 0.5);
    if(x > bound || x < -bound) return false;
    return err < eps && err > -eps;
}

bool ok(int64_t x)
{
    if(x > bound) return false;
    if(x < -bound) return false;
    return true;
}

point B[MAXN][MAXN];
point M[MAXN][MAXN];

map<pair<double, double>, bool> used_p;

void check(int oth)
{
    map<pair<int, int>, int> cnt;
    map<piii, bool> used;

    for(int i = 1; i < n; i++)
        if(i != oth)
            for(int j = i + 1; j < n; j++)
                if(j != oth)
                {
                    if(used.count(piii(pii(B[i][j].x, B[i][j].y), pii(M[i][j].x, M[i][j].y)))) continue;
                    used[piii(pii(B[i][j].x, B[i][j].y), pii(M[i][j].x, M[i][j].y))] = true;

                    double a;
                    point M1 = M[0][oth];
                    point M2 = M[i][j];
                    point B1 = ::a[0];
                    point B2 = ::a[i];

                    if(M1.x == M2.x && M1.y == M2.y) continue;

                    if(!M1.x || !M2.x || !M1.y || !M2.y)
                    {
                        if(!M1.x && !M2.x) continue;
                        if(!M1.y && !M2.y) continue;

                        if(!M1.x || !M2.x)
                        {
                            if(!M1.x)
                            {
                                swap(M1, M2);
                                swap(B1, B2);
                            }

                            a = (B2.x - B1.x) / (double)M1.x;
                        }
                        else
                        {
                            if(!M1.y)
                            {
                                swap(M1, M2);
                                swap(B1, B2);
                            }

                            a = (B2.y - B1.y) / (double)M1.y;
                        }
                    }
                    else
                    {
                        a = ((double)(B1.x - B2.x) / (double)M2.x) * (double)M2.y + B2.y - B1.y;
                        a /= (double)(M1.y - ((M1.x / (double)M2.x) * M2.y));
                    }

                    double x = B1.x + a * M1.x;
                    double y = B1.y + a * M1.y;

                    if(!is_cord_ok(x)) continue;
                    if(!is_cord_ok(y)) continue;

                    x = (int)(x + 0.5);
                    y = (int)(y + 0.5);

                    if(used_p.count({x, y})) continue;

                    cnt[{x, y}] += 2;

                    if(cnt[{x, y}] == n - 2)
                    {
                        cout << "Yes" << endl;
                        cout << (int)x << " " << (int)y << endl;
                        exit(0);
                    }
                }
}

int gcd(int a, int b)
{
    if(a == 0 || b == 0) return a + b;
    return __gcd(a, b);
}

void solve()
{
    for(int i = 0; i < n; i++)
        used_p[{a[i].x, a[i].y}] = 1;

    random_shuffle(a, a + n);

    for(int i = 0; i < n; i++)
        for(int j = i + 1; j < n; j++)
        {
            int dx = a[j].x - a[i].x;
            int dy = a[j].y - a[i].y;
            int g = gcd(abs(dx), abs(dy));

            dx /= g;
            dy /= g;

            if(dx < 0) dx *= -1, dy *= -1;
            if(dx == 0 && dy < 0) dy *= -1;

            M[i][j] = point(dx, dy);
            B[i][j] = a[i];

            for(int l = 30; l >= 0; l--)
                if(ok((1ll << l) * 1ll * dx + B[i][j].x) && ok((1ll << l) * 1ll * dy + B[i][j].y))
                    B[i][j].x += (1ll << l) * 1ll * dx, B[i][j].y += (1ll << l) * 1ll * dy;
        }

    for(int i = 1; i < n; i++)
        check(i);

    cout << "No" << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

/**
3
4 2
6 2
2 1
2 6
4 4
6 6
**/
