#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 2e5 + 5;
const int INF = 1e9 + 7;

class Tree {
public:
	class Node {
	public:
		int id, val, sumInSubtree, minInSubtree, sizeOfSubtree;
		vector< Node* > v;
	};

	int cntNodes;
	Node nodes[MAX_N];

	void Init(int cntNodes) {
		this->cntNodes = cntNodes;
		
		for(int i = 1; i <= cntNodes; i++) {
			nodes[i].id = i;
		}
	}

	void PrecomputeDfs(Node *nd) {
		nd->sumInSubtree = nd->val;
		nd->minInSubtree = nd->val;
		nd->sizeOfSubtree = 1;
		
		for(Node *x : nd->v) {
			PrecomputeDfs(x);

			nd->sumInSubtree += x->sumInSubtree;
			nd->minInSubtree = min(nd->minInSubtree, x->minInSubtree);
			nd->sizeOfSubtree += x->sizeOfSubtree;
		}
	}
};

Tree tree;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	
	tree.Init(n);
	for(int i = 2; i <= n; i++) {
		int p;
		cin >> p;

		tree.nodes[p].v.push_back(&tree.nodes[i]);
	}

	bool areAllCOnes = true;
	for(int i = 2; i <= n; i++) {
		cin >> tree.nodes[i].val;
		
		if(tree.nodes[i].val != 1) {
			areAllCOnes = false;
		}
	}

	tree.PrecomputeDfs(&tree.nodes[1]);
	
	if(areAllCOnes) {
		long long ans = 0;
		for(int i = 1; i <= n; i++) {
			if(tree.nodes[i].v.size() == 0) {
				continue;
			}
			
			vector< int > auxSizes;
			for(auto x : tree.nodes[i].v) {
				auxSizes.push_back(x->sizeOfSubtree);
			}
			sort(auxSizes.begin(), auxSizes.end());
			
			int rightInd = auxSizes.size() - 1;
			for(int i = 0; i < rightInd;) {
				if(auxSizes[i] <= auxSizes[rightInd]) {
					auxSizes[rightInd] -= auxSizes[i];
					ans += 2ll * auxSizes[i];
					i++;
				}
				else {
					auxSizes[i] -= auxSizes[rightInd];
					ans += 2ll * auxSizes[rightInd];
					rightInd--;
				}
			}

			ans += 2ll * auxSizes[rightInd];
		}
		
		cout << ans << endl;
	}

	return 0;
}
