#include<iostream>
#include<vector>
#include<climits>
#include<queue>
#include<algorithm>

using namespace std;

const int MAXN = 2*(1e5) + 5;

int n;
long long c[MAXN];

vector <int> graph[MAXN];
vector < pair <long long, int> > level2Nodes[MAXN];

int dist[MAXN];
queue <int> q;

long long treeSize[MAXN];
long long dp[MAXN], sum[MAXN];

long long answer = 0;

void BFS(int x)
{
    dist[x] = 1;
    q.push(x);

    while(q.empty()==false)
    {
        x = q.front();
        q.pop();

        //cout << x << " " << dist[x] << '\n';

        for(int i = 0;i<graph[x].size();i++)
        {
            if(dist[ graph[x][i] ]==0)
            {
                //cout << "go to " << graph[x][i] << '\n';

                dist[ graph[x][i] ] = dist[x] + 1;
                level2Nodes[ dist[ graph[x][i] ] ].push_back(make_pair(c[ graph[x][i] ], graph[x][i]));

                q.push(graph[x][i]);
            }
        }
    }
}

long long DFS(int x)
{
    if(graph[x].empty()==true)
    {
        return 0;
    }

    dp[x] = 0;
    for(int i = 0;i<graph[x].size();i++)
    {
        dp[x]++;
        dp[x] += DFS(graph[x][i]);
    }

    return dp[x];
}

long long DFS1(int x)
{
    if(graph[x].empty()==true)
    {
        return c[x];
    }

    sum[x] = 0;
    for(int i = 0;i<graph[x].size();i++)
    {
        sum[x] += DFS1(graph[x][i]);
    }

    return sum[x];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int parent;
    bool minUsed;

    long long levelAdd1, levelAdd2, levelAdd3;

    cin >> n;
    for(int i = 2;i<=n;i++)
    {
        cin >> parent;
        graph[parent].push_back(i);
    }

    for(int i = 2;i<=n;i++)
    {
        cin >> c[i];
    }


    BFS(1);
    DFS(1);
    DFS1(1);

    /*
    for(int i = 1;i<=5;i++)
    {
        cout << "level " << i << ":";
        for(int j = 0;j<level2Nodes[i].size();j++)
            cout << " " << level2Nodes[i][j].second;

        cout << '\n';
    }

    for(int i = 1;i<=n;i++)
        cout << "treeSize and Sum " << i << " = " << dp[i] << " " << sum[i] << '\n';
    */

    for(int i = 2;i<=n+3;i++)
    {
        if(level2Nodes[i].empty()==true) break;

        sort(level2Nodes[i].begin(), level2Nodes[i].end());
        minUsed = false;levelAdd1 = 0;levelAdd2 = 0;levelAdd3 = LONG_MAX/3;

        if(level2Nodes[i].size()%2==0)
        {
            minUsed = true;
            for(int j = 0;j<level2Nodes[i].size();j++)
                levelAdd1 += level2Nodes[i][j].first;

        }
        else if(level2Nodes[i].size()!=1)
        {
            for(int j = 1;j<level2Nodes[i].size();j++)
                levelAdd1 += level2Nodes[i][j].first;

            levelAdd3 = 0;
            for(int j = 0;j<level2Nodes[i].size();j+=2)
                levelAdd3 += level2Nodes[i][j].first + level2Nodes[i+1][j].first;
            levelAdd3 += level2Nodes[i][0].first + level2Nodes[i][ level2Nodes[i].size() - 1 ].first;
        }

        //cout << "--" << answer << '\n';
        for(int j = 0;j<level2Nodes[i].size();j++)
        {
            //cout << level2Nodes[i][j].second << ": " << dp[ level2Nodes[i][j].second ] << " " << sum[ level2Nodes[i][j].second ] << '\n';
            if(dp[ level2Nodes[i][j].second ]==0) continue;

            minUsed = true;
            answer += dp[ level2Nodes[i][j].second ]*level2Nodes[i][0].first + sum[ level2Nodes[i][j].second ];
        }

        if(minUsed==false)
        {
            levelAdd1 += level2Nodes[i][0].first + level2Nodes[i][1].first;
        }

        levelAdd2 = 0;
        for(int j = 1;j<level2Nodes[i].size();j++)
            levelAdd2 += level2Nodes[i][0].first + level2Nodes[i][j].first;

        if(level2Nodes[i].size()!=1)
            answer += min( min(levelAdd1, levelAdd2), levelAdd3);
        //cout << answer << '\n';
    }

    cout << answer << '\n';
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5
*/
