#include<iostream>
#include<vector>
#include<climits>
#include<queue>
#include<cstring>
#include<algorithm>

using namespace std;

const int MAXN = 2*(1e5) + 5;

int n;
long long c[MAXN];

vector <int> graph[MAXN];
vector < pair <long long, int> > v;
vector < pair <long long, int> > level2Nodes[MAXN];

int dist[MAXN];
queue <int> q;

long long treeSize[MAXN];
long long dp[MAXN], sum[MAXN];

long long answer = 0;

bool used[MAXN];

pair <long long, int> save;
priority_queue < pair <long long, int> > bestOption;

void BFS(int x)
{
    dist[x] = 1;
    q.push(x);

    while(q.empty()==false)
    {
        x = q.front();
        q.pop();

        //cout << x << " " << dist[x] << '\n';

        for(int i = 0;i<graph[x].size();i++)
        {
            if(dist[ graph[x][i] ]==0)
            {
                //cout << "go to " << graph[x][i] << '\n';

                dist[ graph[x][i] ] = dist[x] + 1;
                level2Nodes[ dist[ graph[x][i] ] ].push_back(make_pair(c[ graph[x][i] ], graph[x][i]));

                q.push(graph[x][i]);
            }
        }
    }
}

long long DFS(int x)
{
    if(graph[x].empty()==true)
    {
        return 0;
    }

    dp[x] = 0;
    for(int i = 0;i<graph[x].size();i++)
    {
        dp[x]++;
        dp[x] += DFS(graph[x][i]);
    }

    return dp[x];
}

long long DFS1(int x)
{
    if(graph[x].empty()==true)
    {
        return c[x];
    }

    sum[x] = 0;
    for(int i = 0;i<graph[x].size();i++)
    {
        sum[x] += DFS1(graph[x][i]);
    }

    return sum[x];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int parent;
    int minUsed;
    bool toFix = false;

    int equalToMin = 0, help = 0;
    long long levelAdd1, levelAdd2, levelAdd3;

    cin >> n;
    for(int i = 2;i<=n;i++)
    {
        cin >> parent;
        graph[parent].push_back(i);
    }

    for(int i = 2;i<=n;i++)
    {
        cin >> c[i];
    }


    BFS(1);
    DFS(1);
    DFS1(1);

    /*
    for(int i = 1;i<=5;i++)
    {
        cout << "level " << i << ":";
        for(int j = 0;j<level2Nodes[i].size();j++)
            cout << " " << level2Nodes[i][j].second;

        cout << '\n';
    }

    for(int i = 1;i<=n;i++)
        cout << "treeSize and Sum " << i << " = " << dp[i] << " " << sum[i] << '\n';
    */

    for(int i = 2;i<=n+3;i++)
    {
        if(level2Nodes[i].empty()==true) break;

        memset(used, false, sizeof(used));
        while(bestOption.empty()==false) bestOption.pop();

        sort(level2Nodes[i].begin(), level2Nodes[i].end());
        toFix = false;minUsed = 0;levelAdd1 = 0;levelAdd2 = 0;levelAdd3 = LONG_MAX/3;

        equalToMin = 0;
        for(int j = 0;j<level2Nodes[i].size();j++)
        {
            if(level2Nodes[i][j].first==level2Nodes[i][0].first) equalToMin++;
            bestOption.push(make_pair(-level2Nodes[i][j].first, level2Nodes[i][j].second));
        }
        help = equalToMin;

        //cout << "--" << answer << '\n';
        for(int j = 0;j<level2Nodes[i].size();j++)
        {
            //cout << level2Nodes[i][j].second << ": " << dp[ level2Nodes[i][j].second ] << " " << sum[ level2Nodes[i][j].second ] << '\n';
            if(dp[ level2Nodes[i][j].second ]==0) continue;

            if(bestOption.empty()==true)
            {
                if(j!=0)
                    answer += dp[ level2Nodes[i][j].second ]*level2Nodes[i][0].first + sum[ level2Nodes[i][j].second ];
                else
                    answer += dp[ level2Nodes[i][j].second ]*level2Nodes[i][1].first + sum[ level2Nodes[i][j].second ];

                continue;
            }

            save.first = 69;
            if(bestOption.top().second==level2Nodes[i][j].second)
            {
                save = bestOption.top();
                bestOption.pop();
            }

            if(bestOption.empty()==true)
            {
                if(j!=0)
                    answer += dp[ level2Nodes[i][j].second ]*level2Nodes[i][0].first + sum[ level2Nodes[i][j].second ];
                else
                    answer += dp[ level2Nodes[i][j].second ]*level2Nodes[i][1].first + sum[ level2Nodes[i][j].second ];

                continue;
            }

            answer += dp[ level2Nodes[i][j].second ]*c[ bestOption.top().second ] + sum[ level2Nodes[i][j].second ];
            used[ bestOption.top().second ] = true;
            bestOption.pop();

            //cout << " += " << bestOption.top().second << '\n';

            if(save.first!=69)
            {
                bestOption.push(save);
            }
        }

        v.clear();
        for(int j = 0;j<level2Nodes[i].size();j++)
        {
            if(used[ level2Nodes[i][j].second ]==false)
            {
                v.push_back(level2Nodes[i][j]);
            }
        }


        levelAdd1 = 0;
        if(v.size()>1)
        {
            for(int j = 0;j<v.size()-1;j+=2)
                levelAdd1 += v[j].first + v[j+1].first;
        }
        if(v.size()%2!=0)
        {
            levelAdd1 += v[ v.size() - 1 ].first + level2Nodes[i][0].first;
        }

        //cout << "levelAdd   " << levelAdd1 << '\n';

        if(level2Nodes[i].size()!=1)
            answer += levelAdd1;
       // cout << answer << '\n';
    }

    cout << answer << '\n';
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5
*/
