#include <iostream>
#include <set>
#include <map>

using namespace std;

# define abs( x ) ( x > 0 ? x : -x )

typedef pair<long long, long long> frac;
typedef pair<frac, frac> line;
typedef pair<frac, frac> point;

const int MAX_N = 2600;
pair<long long, long long> points[MAX_N * 2];
set<pair<long long, long long>> s_p;

void sim( frac& x ) {
    if ( x.second < 0 || x.first < 0 && x.second == 0 ) {
        x.first *= -1;
        x.second *= -1;
    }

    long long a = x.first, b = x.second, r;
    if ( a < 0 )
        a *= -1;
    while ( b != 0 ) {
        r = a % b;
        a = b;
        b = r;
    }

    x.first /= a;
    x.second /= a;

    if ( abs( 1.0 * x.first / x.second ) > 3e7 )
        x.second = 0;
}

line get_line( pair<long long, long long> p1, pair<long long, long long> p2 ) {
    if ( p1.first == p2.first )
        return line( frac( 1, 0 ), frac( p2.first, 1 ) );
    frac a = frac( p1.second - p2.second, p1.first - p2.first );
    sim( a );
    frac b = frac( 1LL * p1.second * a.second - 1LL * a.first * p1.first, a.second );
    sim( b );
    return line( a, b );
}

point get_int( line l1, line l2 ) {
    if ( l1.first.second == 0 )
        swap( l1, l2 );
    frac a1 = l1.first;
    frac a2 = l2.first;
    frac b1 = l1.second;
    frac b2 = l2.second;
    frac x, y;
//        cout << "a1 = " << a1.first << " / " << a1.second << endl;
//        cout << "a2 = " << a2.first << " / " << a2.second << endl;
//        cout << "b1 = " << b1.first << " / " << b1.second << endl;
//        cout << "b2 = " << b2.first << " / " << b2.second << endl;
    if ( a1 == a2 )
        return point( frac( 1, 2 ), frac( 1, 2 ) );
    if ( l2.first.second == 0 ) {
        if ( l1.first.second == 0 )
            return point( frac( 1, 2 ), frac( 1, 2 ) );
        else {
            x = l2.second;
        }
    } else {
        frac da = frac( a1.first * a2.second - a2.first * a1.second, a1.second * a2.second );
        frac db = frac( b2.first * b1.second - b1.first * b2.second, b1.second * b2.second );
        sim( da );
        sim( db );
//        cout << "da = " << da.first << " / " << da.second << endl;
//        cout << "db = " << db.first << " / " << db.second << endl;
        x = frac( db.first * da.second, db.second * da.first );
        sim( x );
    }
    y = frac( a1.first * x.first, a1.second * x.second );
    sim( y );
    y = frac( y.first * b1.second + b1.first * y.second, y.second * b1.second );
    sim( y );
    return point( x, y );
}

int main() {
//    line l1 = get_line( make_pair( 0, 0 ), make_pair( 1, 1 ) );
//    line l2 = get_line( make_pair( 0, -5 ), make_pair( 2, 2 ) );
//    point l = get_int( l1, l2 );
//    cout << "x = " << l.first.first << " / " << l.first.second << endl;
//    cout << "y = " << l.second.first << " / " << l.second.second << endl;
//    return 0;

    freopen( "input.txt", "r", stdin );
    int n;
    cin >> n;

    for ( int i = 0; i < 2 * n; i ++ ) {
        cin >> points[i].first >> points[i].second;
        s_p.insert( points[i] );
    }

    int i, j, k;
    pair<long long, long long> c2;
    for ( i = 2; i < 2 * n; i ++ )
        for ( j = 2; j < 2 * n; j ++ ) {
            if ( i == j )
                continue;

            line l1 = get_line( points[0], points[i] );
            line l2 = get_line( points[1], points[j] );
            point c = get_int( l1, l2 );
            if ( c.first.second != 1 || c.second.second != 1 )
                continue;

            c2 = make_pair( c.first.first, c.second.first );
            if ( s_p.find( c2 ) != s_p.end() || abs( c2.first ) > 1e6 || abs( c2.second ) > 1e6 )
                continue;

            map<line, int> f;
            f[l1] = 2;
            f[l2] = 2;
            for ( k = 2; k < 2 * n; k ++ ) {
                if ( k == i || k == j )
                    continue;

                line l3 = get_line( c2, points[k] );
                f[l3] ++;

                if ( f.size() > n || f[l3] > 2 )
                    break;
            }

            if ( k == 2 * n ) {
                i = 2 * n + 1;
                break;
            }
        }
    if ( i == 2 * n ) {
        for ( i = 3; i < 2 * n; i ++ ) {
//            cout << " HEY " << i << endl;
//            cout << points[0].second << ' ' << points[1].second << endl;
            line l1 = get_line( points[0], points[1] );
            line l2 = get_line( points[2], points[i] );
            point c = get_int( l1, l2 );
//            cout << "x = " << c.first.first << " / " << c.first.second << endl;
//            cout << "y = " << c.second.first << " / " << c.second.second << endl;
            if ( c.first.second != 1 || c.second.second != 1 )
                continue;

            c2 = make_pair( c.first.first, c.second.first );
            if ( s_p.find( c2 ) != s_p.end() || abs( c2.first ) > 1e6 || abs( c2.second ) > 1e6 )
                continue;

            map<line, int> f;
            f[l1] = 2;
            f[l2] = 2;
            for ( k = 3; k < 2 * n; k ++ ) {
                if ( k == i )
                    continue;

                line l3 = get_line( c2, points[k] );
                f[l3] ++;

                if ( f.size() > n || f[l3] > 2 )
                    break;
            }

            if ( k == 2 * n ) {
                i = 2 * n + 1;
                break;
            }
        }
    }

    if ( i == 2 * n )
        cout << "No" << endl;
    else {
        cout << "Yes" << endl;
        cout << c2.first << ' ' << c2.second << endl;
    }

    return 0;
}
