#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2 * 2600;
long long x[MAX_N], y[MAX_N];

unordered_map<int, unordered_map<int, bool> > pct;

struct Dreapta {
  long long a, b, c;
  Dreapta() {}
  Dreapta(int a, int b) {
    this->a = y[b] - y[a];
    this->b = x[a] - x[b];
    this->c = (long long)x[b] * y[a] - (long long)x[a] * y[b];
  }
};

long long rezx, rezy;

static inline bool intersect(Dreapta a, Dreapta b) {
  if(a.a == 0) {
    if(a.c % a.b != 0)
      return false;
    rezy = -a.c / a.b;
    if((-b.c - b.b * rezy) % b.a != 0)
      return false;
    rezx = (-b.c - b.b * rezy) / b.a;
    return !pct[rezx][rezy];
  } else if(b.a == 0)
    return intersect(b, a);
  else if(a.b == 0) {
    if(a.c % a.a != 0)
      return false;
    rezx = -a.c / a.a;
    if((-b.c - b.a * rezx) % b.b != 0)
      return false;
    rezy = (-b.c - b.a * rezx) / b.b;
    return !pct[rezx][rezy];
  } else if(b.b == 0)
    return intersect(b, a);
  else if((b.c * a.b - a.c * b.b) % (a.a * b.b - b.a * a.b) != 0)
    return false;
  else {
    rezx = (b.c * a.b - a.c * b.b) / (a.a * b.b - b.a * a.b);
    if((-a.c - a.a * rezx) % a.b != 0)
      return false;
    rezy = (-a.c - a.a * rezx) / a.b;
    return !pct[rezx][rezy];
  }
}


struct Panta {
  long long a, b;
  Panta(long long x, long long y) {
    a = x;
    b = y;

    if(a == 0)
      b = 1;
    else if(b == 0)
      a = 1;

    if(b < 0) {
      a = -a;
      b = -b;
    }
  }
  Panta() {}
};
Panta panta[MAX_N];

bool cmp(Panta a, Panta b) {
  return a.a * b.b < a.b * b.a;
}

bool same(Panta a, Panta b) {
  return a.a * b.b == a.b * b.a;
}

bool check(int a1, int a2, int b1, int b2, int n) {
  Dreapta a(a1, a2), b(b1, b2);
  //printf("%d %d %d %d %d %d\n", a.a, a.b, a.c, b.a, b.b, b.c);
  if(a.a * b.b == b.a * a.b) //drepte paralele sau care coincid
    return false;
  else if(!intersect(a, b))
    return false;
  else { //verificare de pante
    //printf("%d %d:\n", rezx, rezy);
    for(int i = 0; i < n; ++i)
      panta[i] = Panta(x[i] - rezx, y[i] - rezy);
    sort(panta, panta + n, cmp);
    //for(int i = 0; i < n; ++i)
      //printf("%d %d\n", panta[i].a, panta[i].b);
    //printf("``%d\n", cmp(panta[1], panta[0]));
    for(int i = 0; i < n - 1; ++i)
      if(i % 2 == 0 && !same(panta[i], panta[i + 1]))
        return false;
      else if(i % 2 == 1 && same(panta[i], panta[i + 1]))
        return false;
    return true;
  }
}

int main() {
#ifdef HOME
  FILE *fin = fopen("astro.in", "r");
  FILE *fout = fopen("astro.out", "w");
#else
  FILE *fin = fopen("input.txt", "r");
  FILE *fout = fopen("output.txt", "w");
#endif
  int n;
  fscanf(fin, "%d", &n);
  n = 2 * n;
  for(int i = 0; i < n; ++i) {
    fscanf(fin, "%d%d", &x[i], &y[i]);
    pct[x[i]][y[i]] = true;
  }
  for(int i = 1; i < n; ++i) {
    int j = 1;
    if(i == 1)
      j = 2;
    for(int k = j + 1; k < n; ++k) {
      //printf("%d %d %d %d->%d\n", 0, i, j, k, check(0, i, j, k, n));
      if(j != k && check(0, i, j, k, n)) {
        fprintf(fout, "Yes\n%lld %lld", rezx, rezy);
        fclose(fin);
        fclose(fout);
        return 0;
      }
    }
  }
  fprintf(fout, "No");
  //printf("%d", check(0, 3, 1, 2, n));
    /*fscanf(fin, "%d%d%d%d", &x[0], &y[0], &x[1], &y[1]);
    fscanf(fin, "%d%d%d%d", &x[2], &y[2], &x[3], &y[3]);
    Dreapta a(0, 1), b(2, 3);
    printf("%d %d %d\n%d %d\n", a.a, a.b, a.c, x[2], y[2]);
    if(x[2] * a.a + y[2] * a.b + a.c == 0)
      printf("Bun\n");
    else
      printf("NeBun\n");
    if(intersect(a, b))
      printf("%lld %lld\n", rezx, rezy);
    else
      printf("Ai gresit dreptele baiatul meu\n");
  //}*/
  fclose(fin);
  fclose(fout);
  return 0;
}

