#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <string>
#include <ctime>
#include <cassert>

using namespace std;
const int MAXN = 1001;
const long long INF = 1e18;

struct Point{
    long long x;
    long long y;

    Point(){
    }

    Point(long long xx, long long yy){
        x = xx;
        y = yy;
    }
};

long long gcd(long long a, long long b){
    while (b != 0){
        a %= b;
        swap(a, b);
    }
    return a;
}

struct Line{
    long long a;
    long long b;
    long long c;

    Line(Point& p1, Point& p2){
        a = p1.y - p2.y;
        b = p2.x - p1.x;
        c = -a * p1.x - b * p1.y;

        long long d = gcd(a, gcd(b, c));
        a /= d;
        b /= d;
        c /= d;

        if (a < 0){
            a *= -1;
            b *= -1;
            c *= -1;
        } else if (a == 0){
            if (b < 0){
                b *= -1;
                c *= -1;
            }
        }
    }
};

bool operator < (const Point& a, const Point& b){
    if (a.x == b.x){
        return a.y < b.y;
    } else {
        return a.x < b.x;
    }
}

bool operator < (const Line& l1, const Line& l2){
    if (l1.a == l2.a){
        if (l1.b == l2.b){
            return l1.c < l2.c;
        } else {
            return l1.b < l2.b;
        }
    } else {
        return l1.a < l2.a;
    }
}

int n;
Point mas[MAXN];

Point Intersect(Line& l1, Line& l2){
    long long a = l1.a * l2.c - l1.c * l2.a;
    long long b = l1.c * l2.b - l1.b * l2.c;
    long long c = l1.b * l2.a - l1.a * l2.b;

    if (c == 0){
        return Point(INF, INF);
    }

    if (a % c != 0){
        return Point(INF, INF);
    }

    if (b % c != 0){
        return Point(INF, INF);
    }

    return Point(b / c, a / c);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    n *= 2;
    for (int i = 0; i < n; ++i){
        cin >> mas[i].x >> mas[i].y;
    }

    map<Line, int> mp;

    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j){
            mp[Line(mas[i], mas[j])]++;
        }
    }

    set<Line> v;

    for (auto e : mp){
        if (e.second == 1){
            v.insert(e.first);
        }
    }

    for (int i = 1; i < n; ++i){
        Line l = Line(mas[0], mas[i]);
        if (v.count(l)){
            map<Point, int> m;
            for (int j = 1; j < n; ++j){
                if ((j == i)) continue;
                for (int k = j + 1; k < n; ++k){
                    if (k == i) continue;
                    Line cl = Line(mas[j], mas[k]);
                    if (v.count(cl)){
                        Point p = Intersect(l, cl);
                        if ((abs(p.x) <= 1000 * 1000) && (abs(p.y) <= 1000 * 1000)){
                            m[p]++;
                        }
                    }
                }
            }
            for (int i = 0; i < n; ++i){
                m.erase(mas[i]);
            }
            for (auto e : m){
                if (e.second == (n / 2) - 1){
                    cout << "Yes" << endl;
                    cout << e.first.x << ' ' << e.first.y << endl;
                    return 0;
                }
            }
        }
    }

    cout << "No" << endl;

    return 0;
}
