#include <bits/stdc++.h>

using namespace std;

template<typename T>
T gcd(T a, T b) {
    while(a && b) (a > b ? a %= b : b %= a);
    return a + b;
}

set<int> lengths;

void solve(string &s, int n);
void solveAB(string &s, int n);
void solveByBlock(string &s, int n);

int main() {
#ifndef ONLINE_JUDJE
    freopen("input.txt", "r", stdin);
#endif

    string s;
    cin >> s;
    int n = s.size();

    bool isAB = true;
    for(char x : s)
        isAB &= (x == 'a' || x == 'b');

    if(isAB)
        solveAB(s, n);
//    solve(s, n);
    solveByBlock(s, n);
}

void solveAB(string &s, int n) {
    vector<pair<int, int> > cnt(n + 1);
    auto get = [&](int ch, int l, int r) {
        if(ch == 1)
            return cnt[r].first - cnt[l - 1].first;
        return cnt[r].second - cnt[l - 1].second;
    };

    for(int i = 1; i <= n; ++i) {
        cnt[i] = cnt[i - 1];
        if (s[i - 1] == 'a')
            cnt[i].first++;
        else
            cnt[i].second++;
    }

    int maxSize = 0;
    maxSize = gcd(maxSize, cnt[n].first);
    maxSize = gcd(maxSize, cnt[n].second);

    for(int i = 1; 1ll * i * i <= n; ++i) {
        if (n % i == 0) {
            lengths.insert(i);
            lengths.insert(n / i);
        }
    }
    lengths.insert(n);

    for(int x : lengths) {
        int blockCnt = n / x;
        if(maxSize % blockCnt == 0) {
            bool can = true;
            for(int j = 0; can && j < blockCnt; ++j) {
                can &= get(1, j * x + 1, (j + 1) * x) == cnt[n].first / blockCnt;
                can &= get(2, j * x + 1, (j + 1) * x) == cnt[n].second / blockCnt;
            }
            if(can) {
                cout << blockCnt;
                exit(0);
            }
        }
    }

    exit(1);
}

void solve(string &s, int n) {
    vector<vector<int> > cnt(n + 1, vector<int>(26));
    auto get = [&](int ch, int l, int r) {
        return cnt[r][ch] - cnt[l - 1][ch];
    };

    for(int i = 1; i <= n; ++i) {
        for(int j = 0; j < 26; ++j)
            cnt[i][j] = cnt[i - 1][j];
        cnt[i][s[i - 1] - 'a']++;
    }

    int maxSize = 0;
    for(int i = 0; i < 26; ++i)
        maxSize = gcd(maxSize, cnt[n][i]);

    for(int i = 1; 1ll * i * i <= n; ++i) {
        if (n % i == 0) {
            lengths.insert(i);
            lengths.insert(n / i);
        }
    }
    lengths.insert(n);

    for(int x : lengths) {
        int blockCnt = n / x;
        if(maxSize % blockCnt == 0) {
            bool can = true;
            for(int j = 0; can && j < blockCnt; ++j)
                for(int ch = 0; ch < 26; ++ch)
                    can &= get(ch, j * x + 1, (j + 1) * x) == cnt[n][ch] / blockCnt;
            if(can) {
                cout << blockCnt;
                exit(0);
            }
        }
    }

    exit(1);
}

const int MEM_SIZE = 500000;

struct check {
    bool valid;
    int blockSize, lastBlock, lastBlockSum[26], lastBlockLeft;
    check(int x) {
        valid = true;
        blockSize = x;
        lastBlock = 0;
        for(int i = 0; i < 26; ++i)
            lastBlockSum[i] = 0;
        lastBlockLeft = 0;
    }
};

void solveByBlock(string &s, int n) {
    vector<vector<int> > curBlock(MEM_SIZE, vector<int>(26));
    auto get = [&](int ch, int l, int r) {
        if(l == 0)
            return curBlock[r][ch];
        return curBlock[r][ch] - curBlock[l - 1][ch];
    };

    vector<int> allCnt(26);

    for(char c : s)
        allCnt[c - 'a']++;

    int maxSize = 0;
    for(int i = 0; i < 26; ++i)
        maxSize = gcd(maxSize, allCnt[i]);

    for(int i = 1; 1ll * i * i <= n; ++i) {
        if (n % i == 0) {
            lengths.insert(i);
            lengths.insert(n / i);
        }
    }
//    lengths.insert(n);

    vector<check> blocks;
    for(int x : lengths)
        if(n % x == 0)
            blocks.push_back(check(x));

    for(int cntBlock = 0; cntBlock < (n + MEM_SIZE - 1) / MEM_SIZE; ++cntBlock) {
        for(int i = 0; i < MEM_SIZE; ++i)
            for(int j = 0; j < 26; ++j)
                curBlock[i][j] = 0;

        for(int i = cntBlock * MEM_SIZE; i < min(n, (cntBlock + 1) * MEM_SIZE); ++i) {
            if(i > 0) for(int j = 0; j < 26; ++j)
                curBlock[i][j] = curBlock[i - 1][j];
            curBlock[i][s[i] - 'a']++;
        }


        for(check &block : blocks) {
            if(block.lastBlockLeft > 0) {
                int len = min(MEM_SIZE, block.lastBlockLeft);
                block.lastBlockLeft -= len;
                for(int i = 0; i < 26; ++i)
                    block.lastBlockSum[i] += get(i, 0, len - 1);

                if(block.lastBlockLeft == 0) {
                    for(int i = 0; i < 26; ++i)
                        block.valid &= block.lastBlockSum[i] == allCnt[i] / (n / block.blockSize);
                } else {
                    continue;
                }
            }

            while(block.valid) {
                int l = block.lastBlock * block.blockSize;
                int r = (block.lastBlock + 1) * block.blockSize - 1;
                l -= cntBlock * MEM_SIZE;
                r -= cntBlock * MEM_SIZE;
                if(r >= MEM_SIZE) {
                    block.lastBlockLeft = r - MEM_SIZE + 1;
                    r = MEM_SIZE - 1;
                }

                for(int i = 0; i < 26; ++i)
                    block.lastBlockSum[i] += get(i, l, r);
                if(block.lastBlockLeft == 0) {
                    for(int i = 0; i < 26; ++i)
                        block.valid &= block.lastBlockSum[i] == allCnt[i] / (n / block.blockSize);
                }
                block.lastBlock++;
                if(r == MEM_SIZE - 1)
                    break;
            }

            if(!block.valid);
        }
    }

    for(check block : blocks) {
        if(block.valid) {
            cout << n / block.blockSize;
            exit(0);
        }
    }
    cout << 1;
    exit(0);
}