#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <vector <int> > symb;

inline int64_t get(int l, int r, char c) {
	if (l == 0) {
		return symb[c - 'a'][r];
	} else {
		return symb[c - 'a'][r] - symb[c - 'a'][l - 1];
	}
}

int main() 
{
	string s;
	getline (cin, s);
	int n = s.size();
	bool good = any_of(s.begin(), s.end(), [](char c) {return (c == 'a' || c == 'b');});
	int border = (good ? 2 : 27);
	symb.resize(border, vector <int> (n, 0));	
	//cout << border << endl;
	symb[s[0] - 'a'][0]++;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < border; j++) {
			symb[j][i] = symb[j][i - 1];
		}
		symb[s[i] - 'a'][i]++;
	}
	//cout << "Built" << endl;
	for (int k = 1; k <= n; k++) {
		if (n % k != 0) continue;
		bool possible = true;
		for (int j = k; j < n && possible; j += k) {
			for (char c = 'a'; ((c - 'a') < border) && possible; c++) {
				if (get(j, j + k - 1, c) != get(0, k - 1, c)) {
					possible = false;
				}
			}
		}
		if (possible) {
			cout << n / k;
			return 0;
		}
	}
}


	
