/*
   ,  .
  ,   
    O(26).
,    K  
  .

O(N * nDivs + countDivs)

countDivs:
      :
        S     ()
           set' 
        .
*/

/*#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)*/
typedef long ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

set<ll> getDivs (ll a) {
    set<ll> divs;
    for (ll i = 1; i * i <= a; ++ i)
    if (a % i == 0) {
        divs.insert(i);
        divs.insert(a / i);
    } return divs;
}

set<ll> slowCommonDivs (vector<ll> &arr) {
    assert(arr[0]);
    set<ll> d = getDivs(arr[0]);
    for (ll i : arr) if(i) {
        set<ll> c = getDivs(i);
        set<ll> t;
        for (ll ce : c) if (d.count(ce))
            t.insert(ce);
        d = t;
    } return d;
}

set<ll> fastCommonDivs (vector<ll> &arr) {
    assert(arr[0]);
    ll g = arr[0];
    for (ll i : arr) g  = __gcd(g, i);
    return getDivs(g);
}

string s;
ll freq[256];
set<ll> potFrags;

void start () {
    cin >> s;
    for (char c : s)
        ++ freq[(ll)c];
    vector<ll> toCheck; toCheck.push_back(s.size());
    for (ll i = 0; i < 256; ++ i)
        if (freq[i])
            toCheck.push_back(freq[i]);
    potFrags = fastCommonDivs(toCheck);
}

bool goodSub (string c, ll k) {
    ll curf[256]; fill(all(curf), 0);
    for (char h : c) ++ curf[(ll)h];
    for (ll i = 0; i < 256; ++ i)
        if (curf[i] * k != freq[i])
            return false;
    return true;
}

bool check (ll k) {
    ll d = (ll)s.size() / k;
    for (ll i = 0; i < (ll)s.size(); i += d) {
        if (!goodSub(s.substr(i, d), k))
            return false;
    }
    return true;
}

int main () {
    start();
    vector<ll> revFrags(all(potFrags));
    reverse(all(revFrags));

    for (ll k : revFrags)
    if (check(k)) {
        cout << k << endl;
        return 0;
    }
    assert(0);
    return 0;
}
