#define __GLIBCXX_DEBUG
#define __GLIBCXX_ASSERT
#include <bits/stdc++.h>
using namespace std;
#define all(x) begin(x), end(x)
typedef long long ll;
template<class A>void addlog(A a)
{ cerr<<a<<endl; }
template<class A,class... B>void
addlog(A a,B... b){ cerr<<a<<' ';addlog(b...); }

struct Point {ll x, y;};
const Point NO_POINT{-91919,-91919};
struct Line  {ll a, b, c;};

inline bool eq(ll a,ll b){return a==b;}
inline bool eq(const Point &a, const Point &b)
{return eq(a.x,b.x)&&eq(a.y,b.y);}
void norm (Line &l) {
    ll g = __gcd(__gcd(l.a, l.b), l.c);
    l.a /= g; l.b /= g; l.c /= g;
    if ((l.a < 0) || (eq(l.a,0)&&l.b<0))
    {l.a*=-1;l.b*=-1;l.c*=-1;}
}
#define neq(x,y) (!eq((x),(y)))
ostream &operator<<(ostream &out,const Point &p)
{ return out<<p.x<<' '<<p.y; }
istream &operator>>(istream &in,Point &p)
{ return in>>p.x>>p.y; }
ostream &operator<<(ostream &out,const Line &l)
{ return out<<l.a<<' '<<l.b<<' '<<l.c; }
ll vecMul (ll ax,ll ay,  ll bx,ll by) ////
{ return ax*by - ay*bx; }
bool operator< (Line a, Line b) {
    if (eq(a.a,b.a)) {
        if (eq(a.b,b.b))
            return a.c<b.c;
        return a.b<b.b;
    } return a.a < b.a;
}
Point intersectLines (const Line &I, const Line &II) {
    ll D0   = vecMul(I.a, I.b,  II.a, II.b);
    ll Dx   = vecMul(I.b, I.c,  II.b, II.c);
    ll Dy   = vecMul(I.c, I.a,  II.c, II.a);
    if (D0 == 0)
        return NO_POINT;
    if ((Dx % D0) || (Dy % D0))
        return NO_POINT;
    return Point{Dx / D0, Dy / D0};
}
Line getLine (const Point p, const Point q) {
    ll a = p.y - q.y; ll b = q.x - p.x;
    ll c = -(a*p.x + b*p.y);
    return Line{a,b,c};
}

ll N;
vector<Point> points;

void start () {
    freopen("input.txt", "r", stdin);
    cin >> N; N *= 2;
    points.resize((size_t)N);
    for (ll i = 0; i < N; ++ i)
        cin >> points[(size_t)i];
}

bool check (Point m) {
    if (neq(m, NO_POINT)) {
        for (Point p : points)
        if (eq(m, p))return false;
        map<Line, ll> cnt;
        for (Point p : points) {
            Line l = getLine(m, p);
            norm(l); ++ cnt[l];
        }
        for (auto par : cnt)
        if (par.second != 2)
            return false;

        return true;
    } else
        return false;
}

void yes (ll x, ll y) {
    cout << "Yes" << endl;
    cout << x << ' ' << y << endl;
    exit(0);
}

void no () {
    cout << "No" << endl;
    exit(0);
}


int main () {
    start();

    if (N < 4) {
        Point a = points[0];
        Point b = points[1];
        Line l = getLine(a, b); norm(l);
        ll x, y;
        if (l.a == 0) {
            x = min(a.x, b.x) - 1;  ///////////////
            y = a.y; assert(y == b.y);
        } else {
            y = min(a.y, b.y) - l.a;
            assert((l.b * y + l.c) % l.a == 0); //////////////
            x = - (l.b * y + l.c) / l.a;
        }
        assert(abs(x) < 1000000);
        assert(abs(y) < 1000000);
        yes(x, y);
    } else {
        for (Point a : points)
        for (Point b : points) if (neq(a,b))
        for (Point c : points) if (neq(a,c)&&neq(b,c))
        for (Point d : points) if (neq(a,d)&&neq(b,d)&&neq(c,d)){
            Line ab = getLine(a, b);
            Line cd = getLine(c, d);
            Point m = intersectLines(ab, cd);
            if (check(m)) {
                yes(m.x, m.y);
                return 0;
            }
        }
        no();
    }
}
