#include <fstream>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <map>
#include <set>

using namespace std;

ifstream cin("input.txt"); ofstream cout("output.txt");

typedef long long ll;

struct kcm {
    ll k, c, m;
};

int n;
vector <vector <int> > g;
vector <ll> c;
vector <kcm> a;
vector <int> mm;

void dfs(int v) {
    a[v].c += c[v];
    for (int i = 0; i < g[v].size(); i++) {
        dfs(g[v][i]);
        a[v].k += a[g[v][i]].k;
        a[v].c += a[g[v][i]].c;
        if (a[v].m > min(a[g[v][i]].m, c[g[v][i]]))
            a[v].m = min(a[g[v][i]].m, c[g[v][i]]), mm[v] = g[v][i];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.resize(n);
    c.resize(n);
    a.resize(n, { 1, 0, 1000000007 });
    mm.resize(n, -1);
    for (int i = 1; i < n; i++) {
        int y;
        cin >> y;
        g[--y].push_back(i);
    }
    c[0] = 0;
    for (int i = 1; i < n; i++)
        cin >> c[i];
    dfs(0);
    ll sum = 0;
    for (int v = 0; v < n; v++) {
        if (g[v].size() == 0)
            continue;
        if (g[v].size() == 1) {
            sum += c[g[v][0]]*2;
            continue;
        }
        vector <pair<int, int> > d(g[v].size());
        for (int i = 0; i < g[v].size(); i++) 
            d[i] = { a[g[v][i]].k, i };
        sort(d.rbegin(), d.rend());
        if (a[mm[v]].k * 2 < a[v].k - 1) {
            ll k = a[mm[v]].k - 1, m = 1000000007;
            sum += a[mm[v]].c - a[v].m;
            for (int h=0; h<d.size(); h++){
                int i = d[h].second;
                if (mm[v] == g[v][i])
                    continue;
                m = min(m, min(a[g[v][i]].m, c[g[v][i]]));
                sum += a[g[v][i]].c;
                k -= a[g[v][i]].k;
                k = abs(k);
            }
            if (k != 0)
                sum += k * a[v].m;
            else if (g[v].size() == 2)
                sum += a[v].m + m;
            else
                sum += a[v].m * 2;
        }
        else {
            ll k = a[mm[v]].k, m = 1000000007;
            sum += a[mm[v]].c;
            for (int h = 0; h<d.size(); h++) {
                int i = d[h].second;
                if (mm[v] == g[v][i])
                    continue;
                m = min(m, min(a[g[v][i]].m, c[g[v][i]]));
                sum += a[g[v][i]].c;
                k -= a[g[v][i]].k;
            }
            sum += k * m;
        }
    }
    cout << sum;
    return 0;
}

