//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int N = 200000 + 100;
const int INF = 1000000000;

vector<int> g[N];
int c[N];

ll ans;

struct subtree
{
	ll sm;
	int mn, sz;

	bool operator<(const subtree &a) const
	{
		return mn < a.mn;
	}
};

subtree dfs(int v)
{
	if (g[v].size() == 0)
	{
		return { c[v], c[v], 1 };
	}

	vector<subtree> vv;
	for (int to : g[v])
	{
		vv.push_back(dfs(to));
	}

	assert(vv.size() > 1);

	//sort(all(vv));

	vector<int> mn(vv.size(), INF), pref(vv.size(), INF), suff(vv.size(), INF);

	ll sm = 0;
	int mmn = INF;
	int szsm = 0;
	int mmx = 0;

	for (int i = 0; i < vv.size(); i++)
	{
		ans += vv[i].sm;
		sm += vv[i].sm;
		szsm += vv[i].sz;
		mmn = min(mmn, vv[i].mn);
		mmx = max(mmx, vv[i].sz);
	}

	for (int i = 0; i < vv.size(); i++)
	{
		pref[i] = vv[i].mn;
		if (i > 0)
		{
			pref[i] = min(pref[i], pref[i - 1]);
		}
	}

	for (int i = 0; i < vv.size(); i++)
	{
		suff[i] = vv[i].mn;
		if (i + 1 < vv.size())
		{
			suff[i] = min(suff[i], suff[i + 1]);
		}
	}

	for (int i = 0; i < vv.size(); i++)
	{
		if (i > 0)
		{
			mn[i] = min(mn[i], pref[i - 1]);
		}
		if (i + 1 < vv.size())
		{
			mn[i] = min(mn[i], suff[i + 1]);
		}
	}

	if (mmx * 2 > szsm)
	{
		for (int i = 0; i < vv.size(); i++)
		{
			if (vv[i].sz == mmx)
			{
				ans += (ll)mn[i] * (ll)(mmx * 2 - szsm);
			}
		}
	}
	else
	{
		if (szsm % 2 == 1)
		{
			ans += mmn;
		}
	}

	return { sm + (ll)c[v], min(mmn, c[v]), szsm + 1 };
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;
		g[x - 1].push_back(i);
	}

	for (int i = 1; i < n; i++)
	{
		cin >> c[i];
	}

	dfs(0);

	cout << ans;


#ifdef _DEBUG
	while (1);
#endif
}