//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

struct point
{
	ll x, y;
};

long long d(ll a, ll b, ll c, ll d)
{
	return a * d - b * c;
}

ll gcd(ll a, ll b)
{
	if (b == 0)
	{
		return a;
	}
	return gcd(b, a % b);
}

struct line
{
	ll a, b, c;
	line(point p1, point p2)
	{
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -a * p1.x - b * p1.y;
		if (a < 0)
		{
			a *= -1;
			b *= -1;
			c *= -1;
		}
		ll g = gcd(a, abs(b));
		g = gcd(g, abs(c));
		a /= g;
		b /= g;
		c /= g;
	}
	pair<bool, point> intersect(line l)
	{
		ll delta = d(a, b, l.a, l.b);
		if (delta == 0)
		{
			return { false, {0, 0} };
		}
		ll delta1 = d(c, b, l.c, l.b);
		ll delta2 = d(a, c, l.a, l.c);
		if (delta1 % delta != 0 || delta2 % delta != 0)
		{
			return { false, {0, 0} };
		}
		return { true, {-delta1 / delta, -delta2 / delta } };
	}
	bool operator<(const line &l) const
	{
		if (a != l.a) return a < l.a;
		if (b != l.b) return b < l.b;
		return c < l.c;
	}
};

map<pair<ll, ll>, ll> mp;

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	n *= 2;

	vector<point> v;
	for (int i = 0; i < n; i++)
	{
		ll x, y;
		cin >> x >> y;
		v.push_back({ x, y });
	}

	set<line> lines;
	set<pair<ll, ll>> st;
	for (point p : v)
	{
		st.insert({ p.x, p.y });
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++) if (i != j)
		{
			lines.insert(line(v[i], v[j]));
		}
	}

	vector<line> vv;
	for (line l : lines)
	{
		vv.push_back(l);
	}

	bool find = false;

	for (int i = 0; i < vv.size(); i++) if (!find)
	{
		for (int j = 0; j < i; j++) if (!find)
		{
			auto it = vv[i].intersect(vv[j]);
			if (it.first && st.find({ it.second.x, it.second.y }) == st.end())
			{
				mp[{it.second.x, it.second.y}] ++;
				if (mp[{it.second.x, it.second.y}] == n/2 * (n/2 - 1) / 2)
				{
					cout << "Yes\n";
					cout << it.second.x << " " << it.second.y;
					find = true;
				}
			}
		}
	}

	if (!find)
	{
		cout << "No";
	}





#ifdef _DEBUG
	while (1);
#endif
}