//#pragma gcc optimize("OFast")
//#pragma target("sse,sse2,sse3,sse4,tune=native")
//#pragma gcc optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <string>
#include <cassert>
#include <random>
#include <ctime>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef long double ld;

const int M = 1000000;

struct point
{
	ll x, y;
};

inline long long d(ll a, ll b, ll c, ll d)
{
	return a * d - b * c;
}

inline ll gcd(ll a, ll b)
{
	if (b == 0)
	{
		return a;
	}
	return gcd(b, a % b);
}

struct line
{
	ll a, b, c;
	ll k;
	inline line(point p1, point p2)
	{
		k = 
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = -a * p1.x - b * p1.y;
		if (a < 0)
		{
			a *= -1;
			b *= -1;
			c *= -1;
		}
		ll g = gcd(a, abs(b));
		g = gcd(g, abs(c));
		a /= g;
		b /= g;
		c /= g;
	}
	inline pair<bool, point> intersect(line l)
	{
		ll delta = d(a, b, l.a, l.b);
		if (delta == 0)
		{
			return { false, {0, 0} };
		}
		ll delta1 = d(c, b, l.c, l.b);
		ll delta2 = d(a, c, l.a, l.c);
		if (delta1 % delta != 0 || delta2 % delta != 0)
		{
			return { false, {0, 0} };
		}
		return { true, {-delta1 / delta, -delta2 / delta } };
	}
	inline bool operator<(const line &l) const
	{
		if (a != l.a) return a < l.a;
		if (b != l.b) return b < l.b;
		return c < l.c;
	}
	inline int get(point p)
	{
		return a * p.x + b * p.y + c;
	}
};

inline bool check(point p)
{
	return (-M <= p.x && p.x <= M) && (-M <= p.y && p.y <= M);
}

unordered_map<ll, ll> mp[2*M+10];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	n *= 2;

	vector<point> v;
	for (int i = 0; i < n; i++)
	{
		ll x, y;
		cin >> x >> y;
		v.push_back({ x, y });
	}


	set<line> lines;
	unordered_set<ll> st[2*M+10];
	for (point p : v)
	{
		st[p.x+M].insert(p.y);
	}

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < i; j++) if (i != j)
		{
			lines.insert(line(v[i], v[j]));
		}
	}

	vector<line> vv;

	for (line l : lines)
	{
		int cnt = 0;
		for (int i = 0; i < v.size(); i++)
		{
			if (l.get(v[i]) == 0)
			{
				++cnt;
			}
		}
		if (cnt == 2)
			vv.push_back(l);
	}

	srand(time(0));
	random_shuffle(vv.begin(), vv.end());

	bool find = false;

	int cnt = 0;

	for (int i = 0; i < vv.size(); i++) if (!find)
	{
		for (int j = 0; j < i; j++) if (!find)
		{
			auto it = vv[i].intersect(vv[j]);
			/*if (++cnt > 3e8)
			{
				cout << "No";
				return 0;
			}*/
			if (it.first && check(it.second) && st[it.second.x+M].count(it.second.y) == 0)
			{
				auto &tt = mp[it.second.x+M][it.second.y];
				++tt;
				if (tt == n/2 * (n/2 - 1) / 2)
				{
					cout << "Yes\n";
					cout << it.second.x << " " << it.second.y;
					find = true;
				}
			}
		}
	}

	if (!find)
	{
		cout << "No";
	}





#ifdef _DEBUG
	while (1);
#endif
}