#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define int long long
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

struct point {
	ll x, y;
	point() = default;
	point(int _x, int _y) {
		x = _x, y = _y;
	}
	bool operator<(const point & p) const {
		return x == p.x ? y < p.y : x < p.x;
	}
	bool operator==(const point & p) const {
		return p.x == x && p.y == y;
	}
};

int gcd(int a, int b) {
    a = abs(a);
    b = abs(b);
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void normalize(int & x, int & y) {
    if (x < 0)
        x = -x, y = -y;
    else
        if (!x && y < 0)
            y = -y;
    int g = gcd(x, y);
    x /= g, y /= g;
}

struct line {
	ll a, b, c;
	line() = default;
	line(point p1, point p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		normalize(a, b);
		c = -a * p1.x - b * p1.y;
	}
	bool parallel(line l) {
		return a * l.b - l.a * b == 0;
	}
	point intersect(line l) {
		ll x = (l.c * b - c * l.b) / (a * l.b - l.a * b);
		ll y = (l.c * a - c * l.a) / (l.a * b - a * l.b);
		if (l.a * x + l.b * y + l.c != 0 || a * x + b * y + c != 0)
			return point(1e7, 1e7);
		return point(x, y);
	}
	bool operator<(const line & l) const {
		return a != l.a ? a < l.a : (b != l.b ? b < l.b : c < l.c);
	}
};

int chosen[4];
const int MAXT = 4.9 * CLOCKS_PER_SEC;
vector<point> a;
int n;

bool check(point moon) {
	map<pair<int, int>, int> cnt;
	for (int i = 0; i < a.size(); ++i) {
		if (moon == a[i])
			return false;
		int dx = moon.x - a[i].x, dy = moon.y - a[i].y;
		if (dx < 0)
			dx = -dx, dy = -dy;
        else
            if (!dx && dy < 0)
                dy = -dy;
		int g = gcd(dx, dy);
		dx /= g, dy /= g;
		++cnt[{dx, dy}];
		if (cnt[{dx, dy}] > 2) return false;
	}
	for (auto i : cnt)
		if (i.s == 1)
			return false;
	return true;
}

/*bool check1(point moon) {
    map<pair<int, int>, int> cnt;
	for (int i = 0; i < n; ++i) {
		if (moon == a[i])
			return false;
		int dx = moon.x - a[i].x, dy = moon.y - a[i].y;
		cout << dx << ' ' << dy << " -> ";
		if (dx < 0)
			dx = -dx, dy = -dy;
        else
            if (!dx && dy < 0)
                dy = -dy;
		int g = gcd(dx, dy);
		dx /= g, dy /= g;
		cout << dx << ' ' << dy << endl;
		++cnt[{dx, dy}];
	}
	for (auto i : cnt)
		if (i.s != 2)
			return false;
	return true;
}*/

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// cout << CLOCKS_PER_SEC << endl;
	// freopen("inputB.txt", "r", stdin);
	srand(1337);
	cin >> n;
	n *= 2;
	a.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;
	// int cnt = 0;
	// if (n <= 100) {
	// 	for (int i = 0; i < n; ++i) {
	// 		for (int j = i + 1; j < n; ++j) {
	// 			for (int l = 0; l < n; ++l) {
	// 				for (int k = l + 1; k < n; ++k) {

	// 				}
	// 			}
	// 		}
	// 	}
	// }
	// else {
	set<pair<line, line>> s;
	set<point> moons;
	set<line> liness;
	vector<line> lines;
	for (int i = 0; i < n; ++i)
		for (int j = i + 1; j < n; ++j)
			liness.insert(line(a[i], a[j]));
	
	for (auto i : liness)
		lines.pb(i);
	n = lines.size();
	while (clock() < MAXT) {
		int i1 = rand() % n, i2 = rand() % n;
		if (i1 == i2 || lines[i1].parallel(lines[i2])) continue;
		point moon = lines[i1].intersect(lines[i2]);
		if (abs(moon.x) > 1e6 || abs(moon.y) > 1e6 || moons.find(moon) != moons.end()) continue;
		moons.insert(moon);
		if (check(moon)) {
			cout << "Yes\n" << moon.x << ' ' << moon.y;
			return 0;
		}
	}
	// while (clock() < MAXT) {
	// // ++cnt;
	// 	for (int i = 0; i < 4; ++i) {
	// 		bool fl = false;
	// 		while (!fl) {
	// 			chosen[i] = rand() % n;
	// 			fl = true;
	// 			for (int j = 0; j < i; ++j)
	// 				if (chosen[i] == chosen[j])
	// 					fl = false;
	// 		}
	// 	}
	// 	line l1 = line(a[chosen[0]], a[chosen[1]]);
	// 	line l2 = line(a[chosen[2]], a[chosen[3]]);

	// 	if (l1.parallel(l2)) continue;
	// 	point moon = l1.intersect(l2);

	// 	if (moon == point(2, 2)) {
	// 		cout << "kek" << endl;
	// 		check1(moon);
	// 		return 0;
	// 	}
	// 	if (abs(moon.x) > 1e6 || abs(moon.y) > 1e6) continue;
	// 	if (moons.find(moon) != moons.end()) continue;
	// 	moons.insert(moon);
	// 	// ++cnt;
	// 	// for (int i = 0; i < 4; ++i)
	// 	// 	cout << chosen[i] + 1 << ' ';
	// 	// cout << endl;
	// 	// cout << moon.x << ' ' << moon.y << endl;
	// 	if (check(moon)) {
	// 		cout << "Yes\n" << moon.x << ' ' << moon.y;
	// 		return 0;
	// 	}
	// }
	cout << "No";
	// }

	return 0;
}
