#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)((a).size())
#define int long long
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
template<typename T1> inline void die(T1 x) {cout << x; exit(0);}

struct point {
	ll x, y;
	point() = default;
	point(int _x, int _y) {
		x = _x, y = _y;
	}
	inline bool operator<(const point & p) const {
		return x == p.x ? y < p.y : x < p.x;
	}
	inline bool operator==(const point & p) const {
		return p.x == x && p.y == y;
	}
};

inline int gcd(int a, int b) {
    a = abs(a);
    b = abs(b);
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

inline void normalize(int & x, int & y) {
    if (x < 0)
        x = -x, y = -y;
    else
        if (!x && y < 0)
            y = -y;
    int g = gcd(x, y);
    x /= g, y /= g;
}

struct line {
	ll a, b, c;
	line() = default;
	line(point p1, point p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		normalize(a, b);
		c = -a * p1.x - b * p1.y;
	}
	inline bool parallel(line l) {
		return a * l.b - l.a * b == 0;
	}
	inline point intersect(line l) {
		ll x = (l.c * b - c * l.b) / (a * l.b - l.a * b);
		ll y = (l.c * a - c * l.a) / (l.a * b - a * l.b);
		if (l.a * x + l.b * y + l.c || a * x + b * y + c)
			return point(1e7, 1e7);
		return point(x, y);
	}
	inline bool operator<(const line & l) const {
		return a != l.a ? a < l.a : (b != l.b ? b < l.b : c < l.c);
	}
};

int chosen[4];
int MAXT = 4.9 * CLOCKS_PER_SEC;
vector<point> a;
int n, HALF;

inline bool check(point moon) {
	map<pair<int, int>, int> cnt;
	for (int i = 0; i < a.size(); ++i) {
		if (moon == a[i])
			return false;
		int dx = moon.x - a[i].x, dy = moon.y - a[i].y;
		normalize(dx, dy);
		++cnt[{dx, dy}];
		if (cnt.size() > HALF || cnt[{dx, dy}] > 2) return false;
	}
	return true;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	// cout << CLOCKS_PER_SEC << endl;
	// freopen("inputB.txt", "r", stdin);
	srand(1337);
	cin >> n;
	HALF = n;
	n *= 2;
	a.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].x >> a[i].y;
	
	set<point> moons;
	set<line> liness, bad_lines;
	vector<line> lines;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			int sz = liness.size();
			liness.insert(line(a[i], a[j]));
			if (liness.size() == sz)
				bad_lines.insert(line(a[i], a[j]));
		}
	}
	if (n > 1000)
		MAXT = 4.7 * CLOCKS_PER_SEC;
	for (auto i : bad_lines)
		liness.erase(i);
	lines.reserve(liness.size());
	for (auto i : liness)
		lines.pb(i);
	random_shuffle(all(lines));
	n = lines.size();
	for (int i = 0; i < n && clock() < MAXT; ++i) {
		for (int j = i + 1; j < n && clock() < MAXT; ++j) {
			if (lines[i].parallel(lines[j])) continue;
			point moon = lines[i].intersect(lines[j]);
			if (abs(moon.x) > 1e6 || abs(moon.y) > 1e6 || moons.find(moon) != moons.end()) continue;
			moons.insert(moon);
			if (check(moon)) {
				cout << "Yes\n" << moon.x << ' ' << moon.y;
				return 0;
			}
		}
	}
	cout << "No";
	return 0;
}
