#pragma GCC optimize ("O3")
#include <bits/stdc++.h>
using namespace std;
#define ll long long

struct vec {
	ll x, y;
	vec (ll x = 0, ll y = 0) : x(x), y(y) {}
	vec(vec A, vec B) {
		x = B.x - A.x;
		y = B.y - A.y;
	}
	ll operator * (vec A) {
		return x * A.x + y * A.y;
	}
	ll operator % (vec A) {
		return x * A.y - y * A.x;
	}
};
#define dot vec
struct line {
	ll a, b, c;
	line (int a = 0, int b = 0, int c = 0) : a(a), b(b), c(c) {}
	line (dot A, dot B) {
		vec v = vec(B, A);
		a = v.y;
		b = -v.x;
		c = a * B.x + b * B.y;
	}
	pair <bool, dot> inter(line M) {
		ll d = a * M.b - b * M.a;
		ll dx = c * M.b - b * M.c;
		ll dy = a * M.c - c * M.a;
		if (d == 0 || dx % d != 0 || dy % d != 0) return {false, dot()};
		return {true, dot(dx / d, dy / d)};
	}
};

const int MAXN = 6000;
dot arr[MAXN];

dot cmp_dot;
bool cmp(dot A, dot B) {
	return vec(cmp_dot, A) % vec(cmp_dot, B) > 0;
}

int gcd(int a, int b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

signed main() {
	ios_base::sync_with_stdio(false);

	int n;
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].x >> arr[i].y;
	}
	mt19937_64 rd;
	// shuffle(arr, arr + n, rd);
	set <pair <int, int> > used;
	for (int p1 = 1; p1 < n; p1++) {
		for (int p2 = 0; p2 < n; p2++) {
			line L, M;
			if (p1 == 1) {
				if (p2 < 2) continue;
				L = line(arr[0], arr[p1]);
				M = line(arr[2], arr[p2]);
			} else {
				if (p2 < 2 || p2 == p1) continue;
				L = line(arr[0], arr[p1]);
				M = line(arr[1], arr[p2]);
			}
			auto elem = L.inter(M);
			if (!elem.first) continue;
			dot O = elem.second;
			bool flag = true;
			if (!flag || abs(O.x) > 1e6 || abs(O.y) > 1e6) continue;
			if (used.count({O.x, O.y})) continue;
			used.insert({O.x, O.y});
			// cout << O.x << " " << O.y;
			vector <dot> up, down;
			vector <dot> stars;
			for (int i = 0; i < n; i++) {
				arr[i].x -= O.x;
				arr[i].y -= O.y;
				stars.push_back(arr[i]);

				if (arr[i].x == arr[i].y && arr[i].x == 0) {
					flag = false;
				}

				arr[i].x += O.x;
				arr[i].y += O.y;
			}
			if (!flag || abs(O.x) > 1e6 || abs(O.y) > 1e6) continue;
			vector <pair <int, int> > tg;
			for (int i = 0; i < n; i++) {
				if (stars[i].y < 0 || (stars[i].y == 0 && stars[i].x > 0)) {
					stars[i].x *= -1;
					stars[i].y *= -1;
				}
				int d = gcd(abs(stars[i].x), abs(stars[i].y));
				tg.push_back({stars[i].x/d, stars[i].y/d});
			}
			sort(tg.begin(), tg.end());
			for (int i = 0; i < n && flag; i += 2) {
				flag &= (tg[i] == tg[i + 1]);
			}
			for (int i = 2; i < n && flag; i += 2) {
				flag &= (tg[i] != tg[i - 1]);
			}
			if (flag) {
				cout << "Yes\n";
				cout << O.x << " " << O.y << endl;
				return 0;
			}
		}
	}
	cout << "No\n";
	return 0;
}