#include <bits/stdc++.h>
using namespace std;

#define vec vector
#define pb push_back
typedef long long ll;
typedef pair<int, int> pii;

struct point {
    ll x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}
    void read() { cin >> x >> y; }
    void write() { cout << "(" << x << "; " << y << ") "; }
};

struct line {
    ll a, b, c;
    line() {}
    line(point l, point r) {
        a = l.y - r.y;
        b = r.x - l.x;
        c = -a * l.x - b * l.y;
    }
    write() { cout << a << "x + " << b << "y + " << c << " = 0\n"; }
};
bool intersect(line l, line r, point &p) {
    ll t = l.a * r.b - l.b * r.a;
    if (t == 0) { return false; }
    if ((r.b * l.c - r.c * l.b) % t) { return false; }
    if ((r.a * l.c - r.c * l.a) % t) { return false; }
    p.x = -(r.b * l.c - r.c * l.b) / t;
    p.y = (r.a * l.c - r.c * l.a) / t;
    return true;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    n *= 2;
    map<pii, int> lst;
    set<pii> all;
    vec<point> arr(n);
    for (int k = 0; k < n; k++) {
        int x, y;
        cin >> x >> y;
        arr[k] = point(x, y);
        all.insert(pii(x, y));
    }
    for (int k = 0; k < n; k++) {
        for (int i = k + 1; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (j == k || j == i) { continue; }
                for (int z = j + 1; z < n; z++) {
                    if (z == k || z == i) { continue; }
                    point p(-1, -1);
                    line a(arr[k], arr[i]), b(arr[j], arr[z]);
                    //cout << '\n';
                    if (!intersect(a, b, p) || all.find(pii(p.x, p.y)) != all.end()) { continue; }
                    //arr[k].write(); arr[i].write(); a.write();
                    //arr[j].write(); arr[z].write(); b.write();
                   // p.write(); cout << '\n'; cout << '\n';
                    lst[pii(p.x, p.y)]++;
                }
            }
        }
    }
    for (auto it : lst) {
        //cout << it.first.first << " " << it.first.second << " " << it.second << '\n';
        if (it.second == (n / 2) * (n / 2 - 1)) {
            cout << "Yes\n";
            cout << it.first.first << " " << it.first.second << '\n';
            return 0;
        }
    }
    cout << "No\n";
    return 0;
}
