#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define f first
#define s second
ll sqr(ll a) {
    return a * a;
}


vector < vector < int > > g, up;
vector < int > tin, tout;
int timer;
const int L = 15;

void dfs(int v, int p) {
    up[v][0] = p;
    tin[v] = timer++;
    for (int i = 1; i < L; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto to: g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
    tout[v] = timer++;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}


int lca(int a, int b) {
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;

    for (int i = L - 1; i >= 0; i--) {
        if (!upper(up[a][i], b)) {
            a = up[a][i];
        }
    }

    return up[a][0];
}


int main() {
//    freopen("a.txt", "r", stdin);
//    freopen("b.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    int n;
    cin >> n;
    g.resize(n);

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        g[--p].push_back(i);
        g[i].push_back(p);
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
    }

    up.resize(n, vector < int > (L));
    tin.resize(n);
    tout.resize(n);
    dfs(0, 0);

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            int b = lca(i, j);
            if (i != b && j != b) {
                ans++;
            }
        }
    }

    cout << ans;
}
