#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
#define endl '\n'
#define mp make_pair

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p) {
    out << p.fi << " " << p.se;
    //out << "{" << p.fi << ", " << p.se << "}";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

struct line {
    int a, b, c;

    line (pair <int, int> aa, pair <int, int> bb) {
        a = aa.se - bb.se;
        b = bb.fi - aa.fi;
        c = -aa.fi * a - aa.se * b;
    }

    friend ostream & operator << (ostream & out, line a) {
        out << a.a << " " << a.b << " " << a.c << endl;
        return out;
    }
};

pair <int, int> intersect(line a, line b) {
    if (a.b == 0)
        swap(a, b);
    if (a.b == 0)
        return mp(-1000000000000000000, 1);
    if ((a.a * b.b - b.a * a.b) == 0 || (b.c * a.b - a.c * b.b) % (a.a * b.b - b.a * a.b) != 0) {
        return mp(-1000000000000000000, 1);
    }
    int x = (b.c * a.b - a.c * b.b) / (a.a * b.b - b.a * a.b);
    if ((-a.c - a.a * x) % a.b != 0)
        return mp(-1000000000000000000, 1);
    int y = (-a.c - a.a * x) / a.b;
    return mp(x, y);
}

bool check(vector <pair <int, int> > arr, pair <int, int> p) {
    set <pair <int, int> > s;
    for (auto x : arr) {
        if (p == x)
            return false;
        auto p2 = mp(x.fi - p.fi, x.se - p.se);
        if (p2.fi < 0)
        {
            p2.fi *= -1;
            p2.se *= -1;
        }
        int c = __gcd(p2.fi, p2.se);
        p2.fi /= c;
        p2.se /= c;
        s.insert(p2);
    }
    return (s.size() == arr.size() / 2);
}

pair <int, int> get(vector <pair <int, int> > arr) {
    int n = arr.size();
    if (n == 2) {
        auto p = mp(arr[1].fi - arr[0].fi, arr[1].se - arr[0].se);
        int c = abs(__gcd(p.fi, p.se));
        if (c != 1) {
            p.fi /= c;
            p.se /= c;
            return mp(arr[0].fi + p.fi, arr[0].se + p.se);
        }
        if (abs(2 * arr[1].fi - arr[0].fi) <= 1000000 && abs(2 * arr[1].se - arr[0].se) <= 1000000)
            return mp(2 * arr[1].fi - arr[0].fi, 2 * arr[1].se - arr[0].se);
        swap(arr[0], arr[1]);
        if (abs(2 * arr[1].fi - arr[0].fi) <= 1000000 && abs(2 * arr[1].se - arr[0].se) <= 1000000)
            return mp(2 * arr[1].fi - arr[0].fi, 2 * arr[1].se - arr[0].se);
        return mp(-1000000000, 1);
    }
    for (int i = 2; i < n; ++i) {
        for (int j = 2; j < n; ++j) {
            if (i == j)
                continue;
            line a(arr[0], arr[i]);
            line b(arr[1], arr[j]);
            auto p = intersect(a, b);
            if (abs(p.fi) > 1000000 || abs(p.se) > 1000000)
                continue;
            //cout << "i, j = " << i << " " << j << endl;
            //cout << "a = " << a << "b = " << b << endl;
            //cout << "p = " << p << endl;
            if (check(arr, p)) {
                return p;
            }
        }
    }
    return mp(-1000000000, 1);
}

signed main()
{
    srand(time(NULL));
    int n;
    cin >> n;
    vector <pair <int, int> > arr(2 * n);
    cin >> arr;
    auto p = get(arr);
    if (p.fi != -1000000000) {
        cout << "Yes" << endl;
        cout << p << endl;
        return 0;
    }
    for (int i = 0; i < 50; ++i) {
        random_shuffle(arr.begin(), arr.end());
        p = get(arr);
        if (p.fi != -1000000000) {
            cout << "Yes" << endl;
            cout << p << endl;
            return 0;
        }
    }
    int t = clock();
    while (clock() - t < 500)
        continue;
    cout << "No" << endl;
    return 0;
}
