#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <time.h>
#include <limits>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e9;


struct point
{
	ll x, y;

	point() {};

	point(ll nx, ll ny) : x(nx), y(ny) {};

	point operator - (point p)
	{
		return point(x - p.x, y - p.y);
	}

	point operator + (point p)
	{
		return point(x + p.x, y + p.y);
	}

	ll operator * (point p)
	{
		return x * p.x + y * p.y;
	}

	ll operator % (point p)
	{
		return x * p.y - y * p.x;
	}

	ll sqrlen()
	{
		return x * x + y * y;
	}

	dl len()
	{
		return sqrt(sqrlen());
	}

	void turn()
	{
		swap(x, y);
		x *= (-1);
	}
};

struct line
{
	ll a, b, c;

	line() {};

	line(point p1, point p2)
	{
		a = p1.y - p2.y;
		b = p2.x - p1.x;
		c = p2.y * p1.x - p1.y * p2.x;
	}
};

ll sign(ll a)
{
	if (a > 0)
		return 1;

	if (a < 0)
		return -1;

	return 0;
}

int main()
{
    freopen("inputB.txt", "r", stdin);
    //freopen("outputB.txt", "w", stdout);
	ll n;
	cin >> n;

	vector<point> vp(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> vp[i].x >> vp[i].y;
	}
	
	if (n == 2)
	{
		point np = vp[1] + point(vp[1].x - vp[0].x, vp[1].y - vp[0].y);

		puts("Yes");

		cout << np.x << " " << np.y << endl;

		return 0;
	}
    return 0;
}

