#include <map>
#include <set>
#include <list>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <tuple>
#include <chrono>
#include <cstdio>
#include <random>
#include <vector>
#include <cassert>
#include <climits>
#include <complex>
#include <cstdlib>
#include <iomanip>
#include <numeric>
#include <iostream>
#include <algorithm>
#include <functional>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using namespace chrono;

inline int gcd(int a, int b) {
	return b ? gcd(b, a%b) : a;
}

template<typename T>
class Array2D {
private:
	int n, m;
	T *a;
public:
	inline T &operator()(int x, int y) {
		return a[x*m + y];
	}
	
	Array2D(int n, int m)
		: n(n), m(m) {
		a = new T[n*m];
		for (int i = 0; i < n*m; i++) {
			a[i] = T();
		}
	}
	
	~Array2D() {
		delete[] a;
	}
};

int main() {
	#ifdef DEBUG
	//	freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	
	string s; cin >> s;
	int n = s.size();
	vector<int> knt(26);
	int charKnt = 0;
	vector<int> charMean(26, -1);
	
	for (char c: s) {
		knt[c - 'a']++;
	}
	
	int g = n;
	for (int i = 0; i < 26; i++) {
		g = gcd(g, knt[i]);
	}
	int block = n / g;
	
	for (int i = 0; i < 26; i++) {
		if (knt[i] != 0) {
			charMean[i] = charKnt++;
		}
	}
	
	Array2D<int> pre(g, charKnt);
	for (int i = 0; i < g; i++) {
		if (i != 0) {
			for (int j = 0; j < charKnt; j++) {
				pre(i, j) = pre(i-1, j);
			}
		}
		for (int j = i*block; j < (i+1)*block; j++) {
			pre(i, charMean[s[j] - 'a'])++;
		}
	}
	
	auto check = [&](int sz) {
		for (int i = sz; i <= g; i += sz) {
			for (int j = 0; j < charKnt; j++) {
				if ((int64_t)pre(i-1, j) * g != (int64_t)pre(g-1, j) * i) {
					return;
				}
			}
		}
		cout << g/sz << endl;
		exit(0);
	};
	
	int last = 0;
	for (int i = 1; i*i <= g; i++) {
		last = i;
		if (g % i == 0) {
			check(i);
		}
	}
	for (int i = last; i >= 1; i--) {
		if (g % i == 0) {
			check(g / i);
		}
	}
	
	return 42;
}
