import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class D {

    public String s;

    public int n;

    public int[] count;

    public void inc(char key) {
        count[(int) key - 97]++;
    }

    public int get(char key) {
        return count[(int) key - 97];
    }

    public boolean eq(int[] count1, int[] count2) {
        return Arrays.equals(count1, count2);
    }

    public void clear(int[] count) {
        Arrays.fill(count, 0);
    }

    public boolean check(int lenOfDividing) {
        if (n % lenOfDividing != 0)
            return false;
        clear(count);
        int i = 0;
        for (int j = 0; j < n / lenOfDividing; j++) {
            int[] copy = Arrays.copyOf(count, count.length);
            clear(count);
            for (int k = 0; k < lenOfDividing; k++) {
                inc(s.charAt(i++));
            }
            if (j > 0 && !eq(count, copy))
                return false;
        }
        return true;
    }

    public void solve() throws IOException {
        s = br.readLine();
        n = s.length();
        count = new int[26];
        List<Integer> dividers = new ArrayList<>(n / 2);
        for (int i = 1; i <= n; i++) {
            if (n % i == 0)
                dividers.add(i);
        }
        int l = 0;
        int r = dividers.size();
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (check(dividers.get(m)))
                r = m;
            else
                l = m;
        }
        if (!check(dividers.get(l)))
            out.println(n / dividers.get(r));
        else
            out.println(n / dividers.get(l));
        /*for (int i = 1; i <= n; i++) {
            if (check(i)) {
                out.println(n / i);
                return;
            }
        }*/
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }
}
