import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class C {

    public int n;

    public List<List<Integer>> g;

    public boolean[] used;

    public long[] count, dp;

    public void dfs(int v) {
        used[v] = true;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            if (!used[u])
                dfs(u);
        }
        count[v] = 1;
        for (int i = 0; i < g.get(v).size(); i++) {
            int u = g.get(v).get(i);
            count[v] += count[u];
            dp[v] += dp[u];
        }
        if (g.get(v).size() > 0) {
            long min = count[g.get(v).get(0)];
            int minInd = 0;
            for (int i = 1; i < g.get(v).size(); i++) {
                int u = g.get(v).get(i);
                if (count[u] < min) {
                    min = count[u];
                    minInd = i;
                }
            }
            for (int i = 0; i < g.get(v).size(); i++) {
                if (i == minInd)
                    continue;
                int u = g.get(v).get(i);
                dp[v] += count[u] * min;
            }
        }
    }

    public void solve() throws IOException {
        n = nextInt();
        g = new ArrayList<>(n);
        used = new boolean[n];
        dp = new long[n];
        count = new long[n];
        for (int i = 0; i < n; i++) {
            g.add(new ArrayList<Integer>());
        }
        for (int i = 1; i < n; i++) {
            int parent = nextInt() - 1;
            g.get(parent).add(i);
        }
        dfs(0);
        out.print(dp[0] * 2L);
    }

    public void run() throws IOException {
        br = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    public String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(br.readLine());
        }
        return tokenizer.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public BufferedReader br;
    public PrintWriter out;
    public StringTokenizer tokenizer;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }
}
