//#include "stdafx.h"
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <ctime>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forn(i, n) for (int i = 0; i < n; i++)
#define endl '\n'
#define mp make_pair

const ll inf = (ll)9e+18;
const ll bound = (ll)1e+6;

struct vec
{
	ll x, y;
	vec()
	{
		this->x = 0ll;
		this->y = 0ll;
	}
	vec(ll nx, ll ny)
	{
		this->x = nx;
		this->y = ny;
	}

	vec operator+(const vec &b)
	{
		return vec(x + b.x, y + b.y);
	}
	vec operator-(const vec &b)
	{
		return vec(x - b.x, y - b.y);
	}
	ll operator%(const vec &b)
	{
		return x * b.y - b.x * y;
	}
	ll operator*(const vec &b)
	{
		return x * b.x + y * b.y;
	}

	vec ort()
	{
		return vec(-y, x);
	}
};

struct line
{
	ll a, b, c;
	
	void set(vec a, vec b)
	{
		vec d = (a - b);
		this->a = d.ort().x;
		this->b = d.ort().y;
		this->c = -a.x * this->a - a.y * this->b;
	}

	bool pointontheline(vec v)
	{
		return (this->a * v.x + this->b * v.y + this->c == 0ll);
	}
};

bool any;
pair<ll, ll> intersect(line x, line y)
{
	ll det = x.a * y.b - y.a * x.b;
	if (det == 0ll)
	{
		any = false;
		return mp(inf, inf);
	}

	ll ux = x.c * y.b - y.c * x.b;
	ll uy = x.a * y.c - y.a * x.c;

	if (ux % det != 0ll || uy % det != 0ll)
	{
		any = false;
		return mp(inf, inf);
	}

	any = true;
	return mp(-ux / det, -uy / det);
}

int main()
{
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
	srand(1373737);
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n;
	cin >> n;
	n *= 2;

	set < pair<ll, ll> > havep;
	vector < pair<ll, ll> > arr(n);
	forn(i, n)
	{
		cin >> arr[i].first >> arr[i].second;
		havep.insert(arr[i]);
	}

	vector <vec> now(n);
	forn(i, n)
		now[i] = vec(arr[i].first, arr[i].second);

	forn(s1, n)
	{
		forn(s2, n)
		{
			if (s2 == s1)
				continue;
			forn(s3, n)
			{
				if (s3 == s1 || s3 == s2)
					continue;
				forn(s4, n)
				{
					if (s4 == s1 || s4 == s2 || s4 == s3)
						continue;

					line x, y;
					x.set(now[s1], now[s2]);
					y.set(now[s3], now[s4]);

					pair <ll, ll> nowinter = intersect(x, y);
					if (!any)
						continue;
					if (havep.count(nowinter) == 1)
						continue;
					if (abs(nowinter.first) > bound || abs(nowinter.second) > bound)
						continue;

					vector <bool> cover(n);
					cover[s1] = cover[s2] = cover[s3] = cover[s4] = true;

					vec O = vec(nowinter.first, nowinter.second);

					bool flag = true;
					forn(i, n)
					{
						if (cover[i])
							continue;
						
						line h;
						h.set(now[i], O);

						int cnt = 0, last = -1;
						forn(j, n)
						{
							if (j == i)
								continue;

							if (h.pointontheline(now[j]))
							{
								cnt++;
								last = j;
							}
						}

						if (cnt != 1)
						{
							flag = false;
							break;
						}
						cover[i] = cover[last] = true;
					}

					if (flag)
					{
						cout << "Yes\n";
						cout << nowinter.first << " " << nowinter.second;
						return 0;
					}
				}
			}
		}
	}

	cout << "No";

	return 0;
}