#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

//#define int long long
#define D double

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
	out << "(" << a.fi << ", " << a.se << ")" << endl;
	return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
	for (auto el : arr) {
		out << el << ", ";
	}
	return out;
}

// ------------------------------------- CODE NOW ---------------------------------------

const int A = 26;
const int MAXN = 5000005;
int n;
int cnt[A];
vi pos[A];
string s;

vi get_divs(int n) {
	int d = 1;
	vi res;
	while (d * d <= n) {
		if (n % d == 0) {
			res.pb(d);
			res.pb(n / d);
		}
		++d;
	}
	sort(all(res));
	return res;
}

int get(int l, int r, int c) {
	int k = pos[c].size();
	int L = -1, R = k;
	while (R - L > 1) {
		int m = (L + R) / 2;
		if (pos[c][m] < l) {
			L = m;
		}
		else {
			R = m;
		}
	}
	int from = R;

	L = -1, R = k;
	while (R - L > 1) {
		int m = (L + R) / 2;
		if (pos[c][m] < r) {
			L = m;
		}
		else {
			R = m;
		}
	}
	int to = R;

	return to - from;
}

bool check(int d) {
	vi cur(A);
	for (int c = 0; c < A; ++c) {
		if (cnt[c] % (n / d) != 0) {
			return false;
		}
		else {
			cur[c] = cnt[c] / (n / d);
		}
	}
	for (int i = 0; i < n; i += d) {
		vi now_cnt(A);
		for (int c = 0; c < A; ++c) {
			now_cnt[c] = get(i, i + d, c);
		}
		if (now_cnt != cur) {
			return false;
		}
	}
	return true;
}

bool check_solve_last(int d, vvi &pref) {
	vi cur(2);
	for (int c = 0; c < 2; ++c) {
		if (cnt[c] % (n / d) != 0) {
			return false;
		}
		else {
			cur[c] = cnt[c] / (n / d);
		}
	}
	for (int i = 0; i < n; i += d) {
		vi now_cnt(2);
		for (int c = 0; c < 2; ++c) {
			now_cnt[c] = pref[i + d][c] - pref[i][c];
		}
		if (now_cnt != cur) {
			return false;
		}
	}
	return true;
}

void solve_last() {
	vvi pref(MAXN, vi(2));
	for (int i = 0; i < n; ++i) {
		pref[i + 1][0] = pref[i][0];
		pref[i + 1][1] = pref[i][1];
		++pref[i + 1][s[i] - 'a'];
	}
	vi divs = get_divs(n);
	for (int d : divs) {
		if (check_solve_last(d, pref)) {
			cout << n / d << endl;
			exit(0);
		}
	}
	cout << 0 << endl;
	exit(0);
}

signed main() {
	doRoutine();

	cin >> s;
	n = s.size();

	for (int i = 0; i < n; ++i) {
		++cnt[s[i] - 'a'];
		pos[s[i] - 'a'].pb(i);
	}
	bool is_group_last = true;
	for (int i = 2; i < A; ++i) {
		if (cnt[i]) {
			is_group_last = false;
		}
	}
	if (is_group_last) {
		solve_last();
	}

	vi divs = get_divs(n);
	for (int d : divs) {
		if (check(d)) {
			cout << n / d << endl;
			return 0;
		}
	}
	cout << 0 << endl;

	return 0;
}