#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
	out << "(" << a.fi << ", " << a.se << ")" << endl;
	return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
	for (auto el : arr) {
		out << el << ", ";
	}
	return out;
}

// ------------------------------------- CODE NOW ---------------------------------------

const int INF = 1000000000000000000;
const int MAXN = 2605;
int n;
int x[2 * MAXN], y[2 * MAXN];
const int C = 1000000;

bool ok_point(pii p) {
	return -C <= p.fi && p.fi <= C && -C <= p.se && p.se <= C;
}

void relax(pii &a) {
	int g = __gcd(abs(a.fi), abs(a.se));
	a.fi /= g;
	a.se /= g;	
}

bool divable(pii a, pii b) {
	if (b.fi == 0) {
		if (a.fi != 0) {
			return false;
		}
		else {
			if (b.se == 0) {
				return a.se == 0;
			}
			else {
				return a.se % b.se == 0;
			}
		}
	}
	else {
		if (a.fi % b.fi != 0) {
			return false;
		}
		else {
			if (b.se == 0) {
				return a.se == 0;
			}
			else {
				return a.se % b.se == 0;
			}
		}
	}
}

int div(pii a, pii b) {
	if (b.fi == 0 && b.se == 0) {
		return 0;
	}
	else if (b.fi != 0) {
		return a.fi / b.fi;
	}
	else if (b.se != 0) {
		return a.se / b.se;
	}
}

bool col(pii a, pii b) {
	relax(a);
	relax(b);
	if (a == b) {
		return true;
	}
	else {
		a.fi *= -1;
		a.se *= -1;
		if (a == b) {
			return true;
		}
	}
	return false;
}

pii intersect(int i, int j, int a, int b) {
	cerr << i << " " << j << " " << a << " " << b << ": ";
	pii p1 = {x[i], y[i]}, v1 = {x[j] - x[i], y[j] - y[i]};
	pii p2 = {x[a], y[a]}, v2 = {x[b] - x[a], y[b] - y[a]};
	relax(v1);
	relax(v2);
	pii top = {p1.fi - p2.fi, p1.se - p2.se}, bot = {v2.fi - v1.fi, v2.se - v1.se};
	if (col(v1, v2)) {
		return make_pair(-INF, -INF);
	}
	//cerr << top << endl << bot << endl;
	if (divable(top, bot)) {
		int k = div(top, bot);
		pii res = {p1.fi + v1.fi * k, p1.se + v1.se * k};
		cerr << res << endl;
		if (ok_point(res)) {
			return res;
		}
	}
	cerr << make_pair(-INF, -INF) << endl;
	return {-INF, -INF};
}

signed main() {
	doRoutine();

	cin >> n;
	set<pii> points;
	for (int i = 0; i < 2 * n; ++i) {
		cin >> x[i] >> y[i];
		points.insert({x[i], y[i]});
	}

	map<pii, int> cnt;
	int s = 2 * n;
	for (int i = 0; i < s; ++i) {
		for (int j = i + 1; j < s; ++j) {
			for (int a = 0; a < s; ++a) {
				for (int b = a + 1; b < s; ++b) {
					if (a != i && a != j && b != i && b != j) {
						pii p = intersect(i, j, a, b);
						if (p != make_pair(-INF, -INF)) {
							++cnt[p];
						}
					}
				}
			}
		}
	}

	for (auto el : cnt) {
		cerr << el.fi << ": " << el.se << endl;
	}

	for (auto pr : cnt) {
		if (pr.se == n && !points.count(pr.fi) && pr.fi != make_pair(-INF, -INF)) {
			cout << "Yes" << endl;
			cout << pr.fi.fi << " " << pr.fi.se << endl;
			return 0;
		}
	}
	cout << "No" << endl;

	return 0;
}