#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
}

#define DBG(x) cerr << #x << ": " << x << endl;
#define DBG_ARR(arr, a, b) for (int i = a; i < b; ++i) {cerr << #arr << "[" << i << "]: " << arr[i] << endl;}

#ifndef LOCAL
#define cerr if(0) cerr
#define DBG(...) (true)
#endif

#define pii pair<int, int>
#define fi first
#define se second
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define last(x) (--x.end())

#define int long long
#define D double

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> a) {
	out << "(" << a.fi << ", " << a.se << ")" << endl;
	return out;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
	for (auto el : arr) {
		out << el << ", ";
	}
	return out;
}

// ------------------------------------- CODE NOW ---------------------------------------

const int INF = 1000000000000000000;
const int MAXN = 2605;
int n;
int x[2 * MAXN], y[2 * MAXN];
const int C = 1000000;

bool ok_point(pii p) {
	return -C <= p.fi && p.fi <= C && -C <= p.se && p.se <= C;
}

void relax(pii &a) {
	int g = __gcd(abs(a.fi), abs(a.se));
	a.fi /= g;
	a.se /= g;	
}

bool divable(pii a, pii b) {
	if (b.fi == 0) {
		if (a.fi != 0) {
			return false;
		}
		else {
			if (b.se == 0) {
				return a.se == 0;
			}
			else {
				return a.se % b.se == 0;
			}
		}
	}
	else {
		if (a.fi % b.fi != 0) {
			return false;
		}
		else {
			if (b.se == 0) {
				return a.se == 0;
			}
			else {
				return a.se % b.se == 0;
			}
		}
	}
}

int div(pii a, pii b) {
	if (b.fi == 0 && b.se == 0) {
		return 0;
	}
	else if (b.fi != 0) {
		return a.fi / b.fi;
	}
	else if (b.se != 0) {
		return a.se / b.se;
	}
}

bool col(pii a, pii b) {
	relax(a);
	relax(b);
	if (a == b) {
		return true;
	}
	else {
		a.fi *= -1;
		a.se *= -1;
		if (a == b) {
			return true;
		}
	}
	return false;
}

struct Line {
	int a, b, c;
	Line(int i, int j) {
		int ax = x[i], ay = y[i], bx = x[j], by = y[j];
		a = by - ay, b = ax - bx, c = ax * (ay - by) + ay * (bx - ax);
	}
};

pii cross(Line r, Line t) {
	int a1 = r.a, b1 = r.b, c1 = r.c;
	int a2 = t.a, b2 = t.b, c2 = t.c;
	cerr << a1 << " " << b1 << " " << c1 << endl;
	cerr << a2 << " " << b2 << " " << c2 << endl;
	cerr << (c2 * b1 - c1 * b2) << endl;
	cerr << (a1 * b2 - a2 * b1) << endl;
	if (a1 * b2 == a2 * b1 || (c2 * b1 - c1 * b2) % (a1 * b2 - a2 * b1) != 0) {
		return make_pair(-INF, -INF);
	}
	else {
		int x = (c2 * b1 - c1 * b2) / (a1 * b2 - a2 * b1);
		int y = (c2 * a1 - c1 * a2) / (a2 * b1 - a1 * b2);
		return {x, y};
	}
}

pii intersect(int i, int j, int a, int b) {
	Line r(i, j), t(a, b);
	pii res = cross(r, t);
	if (ok_point(res)) {
		return res;
	}
	else {
		return {-INF, -INF};
	}
}

signed main() {
	doRoutine();

	cin >> n;
	set<pii> points;
	for (int i = 0; i < 2 * n; ++i) {
		cin >> x[i] >> y[i];
		points.insert({x[i], y[i]});
	}

	map<pii, int> cnt;
	int s = 2 * n;
	for (int i = 0; i < s; ++i) {
		for (int j = i + 1; j < s; ++j) {
			for (int a = 0; a < s; ++a) {
				for (int b = a + 1; b < s; ++b) {
					if (a != i && a != j && b != i && b != j) {
						pii p = intersect(i, j, a, b);
						if (p != make_pair(-INF, -INF)) {
							++cnt[p];
						}
					}
				}
			}
		}
	}

	for (auto el : cnt) {
		cerr << el.fi << ": " << el.se << endl;
	}

	for (auto pr : cnt) {
		if (pr.se == n * (n - 1) && !points.count(pr.fi)) {
			cout << "Yes" << endl;
			cout << pr.fi.fi << " " << pr.fi.se << endl;
			return 0;
		}
	}
	cout << "No" << endl;

	return 0;
}