#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x, y;

    Point (int x0 = 0, int y0 = 0) {
        x = x0; y = y0;
    }
};

istream & operator >> (istream & in, Point & A) {
    in >> A.x >> A.y;
    return in;
}

const double EPS = 1e-9;

bool eq (double a, double b) {
    return abs(a - b) < EPS;
}

pair <int, int> check (Point A, Point B, Point C, Point D) {
    if (A.x > B.x) swap(A, B);
    if (C.x > D.x) swap(C, D);
    if (A.x == B.x || C.x == D.x)
    return {-1, -1};
    double k1 = (B.y - A.y) / (B.x - A.x), b1 = A.y - (A.x * k1);
    double k2 = (D.y - C.y) / (D.x - C.x), b2 = C.y - (C.x * k2);

    if (eq(k1, k2))
    return {-1, -1};
    double x = (b2 - b1) / (k1 - k2);
    double y = k1 * x + b1;
    int x1 = x, y1 = y;
    if (eq(x, (double)x1) && eq(y, (double)y1))
    return {x1, y1};
    else return {-1, -1};
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n; cin >> n;

    vector <Point> a(2 * n);
    int min_x = 1e9, min_y = 1e9;
    for (int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        min_x = min(min_x, a[i].x);
        min_y = min(min_y, a[i].y);
    }
    for (int i = 0; i < 2 * n; ++i) {
        a[i].x -= min_x; a[i].y -= min_y;
    }

    if (n == 2) {
        for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4; ++j)
        for (int k = 0; k < 4; ++k)
        for (int l = 0; l < 4; ++l) {
        if (!(i == j || i == k || i == l || j == k || j == l || k == l)) {
        pair <int, int> p = check(a[i], a[j], a[k], a[l]);
        if (p.first != -1 && p.second != -1)
        {
                cout << "Yes" << endl;
                cout << p.first + min_x << " " << p.second + min_y << endl;
                return 0;
        }
        }
        }
        cout << "No" << endl;
    }
    else cout << "No" << endl;

    return 0;
}