#pragma gcc optimize("Ofast")
#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <set>
#define ll long long
#define double long double
using namespace std;

const double eps = 1e-9;

struct point {
	point(){}
	point(double x, double y) : x(x), y(y) {}
	double x, y;
};

struct viktor {
	double x, y;
	viktor(){}
	viktor(double x, double y) : x(x), y(y) {}
};

struct line {
	double a, b, c;
	line(){}
	line(double a, double b, double c) : a(a), b(b), c(c) {}
	line(point p, point q) {
		a = p.y-q.y;
		b = q.x-p.x;
		c = -(a*p.x + b*p.y);
		normalize();
	}
	void normalize() {
		double z = a*a+b*b;
		a /= z, b /= z, c /= z;
	}
};

point operator *(line a, line b) {
	point p;
	double a1 = a.a, b1 = a.b, c1 = a.c;
	double a2 = b.a, b2 = b.b, c2 = b.c;
	double opr = a1*b2-a2*b1;
	double xop = c1*b2-c2*b1;
	double yop = a1*c2-a2*c1;
	p.x = -xop/opr;
	p.y = -yop/opr;
	return p;
}
istream& operator >> (istream& is, point& p) {
	is >> p.x >> p.y;
	return is;
}

ostream& operator << (ostream& os, point p) {
	os << p.x << " " << p.y;
	return os;
}

bool operator ==(point a, point b) {
	return abs(a.x-b.x) <= eps && abs(a.y-b.y) <= eps;
}

vector<point> v;

bool check(point p) {
	for (point pp : v) {
		if (pp == p)
			return false;
	}
	return (abs(p.x - (int)p.x) <= eps && abs(p.y - (int)p.y) <= eps);
}

int cnt (line a) {
	int ans = 0;
	for (int i = 0; i < v.size(); ++i) {
		point p = v[i];
		if (abs(a.a*p.x + a.b*p.y + a.c) <= eps)
			ans++;
	}
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; ++i) {
		point p;
		cin >> p;
		v.push_back(p);
	}
	// cout << line(point(0,0), point(-2,-2))*line(point(0,-2), point(-2, 0));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				for (int l = 0; l < n; ++l) {
					if (i == j || i == k || i == l ||
						j == k || j == l || k == l) continue;
					point p1 = v[i], p2 = v[j], p3 = v[k], p4 = v[l];
					line ln1(p1, p2), ln2(p3, p4);
					point p = ln1*ln2;
					if (check(p)) {
						// cout << p << endl;
						bool bo = true;
						for (int q = 0; q < n; ++q) {
							if (q == i || q == j || q == k || q == l)
								continue;
							line ln(p, v[q]);
							if (cnt(ln) != 2) {
								bo = false;
								break;
							}
						}
						if (bo)
							return !(cout << "Yes\n" << (int)p.x << " " << (int)p.y);
					}
				}
			}
		}
	}
	cout << "No";
	return 0;
}