#pragma gcc optimize("Ofast")
// #include <bits/stdc++.h>
#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
#include <unordered_set>
#include <set>
#define ll long long
#define int long long
#define double long double
using namespace std;

const double eps = 1e-6;

struct point {
	point(){}
	point(int x, int y) : x(x), y(y) {}
	int x, y;
};
bool operator <(point a, point b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}

struct viktor {
	double x, y;
	viktor(){}
	viktor(double x, double y) : x(x), y(y) {}
};

struct line {
	int a, b, c;
	line(){}
	line(double a, double b, double c) : a(a), b(b), c(c) {}
	line(point p, point q) {
		a = p.y-q.y;
		b = q.x-p.x;
		c = -(a*p.x + b*p.y);
		// normalize();
	}
	void normalize() {
		double z = a*a+b*b;
		a /= z, b /= z, c /= z;
	}
};

point operator *(line a, line b) {
	point p;
	int a1 = a.a, b1 = a.b, c1 = a.c;
	int a2 = b.a, b2 = b.b, c2 = b.c;
	int opr = a1*b2-a2*b1;
	int xop = c1*b2-c2*b1;
	int yop = a1*c2-a2*c1;
	if (opr == 0 || xop % opr != 0 || yop % opr != 0)
		return point(1e7, 1e7);
	p.x = -xop/opr;
	p.y = -yop/opr;
	return p;
}
istream& operator >> (istream& is, point& p) {
	is >> p.x >> p.y;
	return is;
}

ostream& operator << (ostream& os, point p) {
	os << p.x << " " << p.y;
	return os;
}

bool operator ==(point a, point b) {
	return a.x == b.x && a.y == b.y;
}

vector<point> v;
set<point> findme;

bool check(point p) {
	if (findme.find(p) != findme.end()) return false;
	return abs(p.x) <= 1e6 && abs(p.y) <= 1e6;
}

set<point> se;

int cnt (line a) {
	int ans = 0;
	se.clear();
	for (point p : v) {
		se.insert(p);
	}

	for (auto it = se.begin(); it != se.end(); ++it) {
		point p = *it;
		if (a.a*p.x + a.c == -a.b*p.y) {
			ans++;
			se.erase(it);
		}
	}
	return ans;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	n *= 2;
	for (int i = 0; i < n; ++i) {
		point p;
		cin >> p;
		v.push_back(p);
		findme.insert(p);
	}
	random_shuffle(v.begin(), v.end());
	// cout << cnt(line(point(0,0), v[1])) << endl;
	if (n == 2) {
		if (v[1].x < v[0].x) swap(v[1], v[0]);
		else if (v[1].x == v[0].x && v[1].y < v[0].y) swap(v[1], v[0]);
		point p1 = point(v[1].x*2-v[0].x, v[1].y*2-v[0].y);
		point p2 = point(v[0].x-v[1].x+v[0].x, v[0].y-v[1].y+v[0].y);
		if (check(p1))
			cout << "Yes\n" << p1;
		else if (check(p2))
			cout << "Yes\n" << p2;
		else
			cout << "No";
		return 0;
	}
	int times = clock();
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			for (int k = 0; k < n; ++k) {
				for (int l = 0; l < n; ++l) {
					if (i == j || i == k || i == l ||
						j == k || j == l || k == l) continue;
					point p1 = v[i], p2 = v[j], p3 = v[k], p4 = v[l];
					line ln1(p1, p2), ln2(p3, p4);
					point p = ln1*ln2;
					if (check(p)) {
						// cout << p << endl;
						bool bo = true;
						for (int q = 0; q < n; ++q) {
							if (q == i || q == j || q == k || q == l)
								continue;
							line ln(p, v[q]);
							if (cnt(ln) != 2) {
								bo = false;
								break;
							}
						}
						if (bo){
							if (p.x > 1e6 || p.y > 1e6) while(1) {}
							return !(cout << "Yes\n" << p.x << " " << p.y);
						}
					}
					if (clock() - times > 4800000) {
						return !(cout << "No");
					}
				}
			}
		}
	}
	cout << "No";
	return 0;
}