#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;
const ll LEN = 5e6 + 11;

ll hash_char(char c)
{
    ll ans = 1;

    for (char i = 'a'; i < c; i++)
    {
        ans *= LEN;
        ans %= MOD;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, i;
    string s;
    cin >> s;
    n = s.size();

    vector<ll> hashes(n);
    for (i = 0; i < n; i++)
        hashes[i] = hash_char(s[i]);

    vector<ll> pfx_hashes(n + 1, 0);
    for (i = 0; i < n; i++)
        pfx_hashes[i + 1] = (pfx_hashes[i] + hashes[i]) % MOD;

    ll ans = 0;
    for (ll k = 1; k <= n; k++)
    {
        if (n % k != 0)
            continue;

        bool ok = true;
        for (i = k; i < n; i += k)
        {
            if (pfx_hashes[i + k] - pfx_hashes[i] !=
                pfx_hashes[i] - pfx_hashes[i - k])
            {
                ok = false;
                break;
            }
        }

        if (ok)
        {
            ans = n / k;
            break;
        }
    }

    cout << ans << endl;

    return 0;
}
