#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

int hashes1[5000000][2];
int hashes2[500000][26];
char s[5000000];
int n, i;

bool comp_diff(int a, int b, int c)
{
    for (int i = 0; i < 26; i++)
        if (hashes2[a][i] - hashes2[b][i] != hashes2[b][i] - hashes2[c][i])
            return false;

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    cin >> s;

    for (n = 0; n < 5000000; n++)
        if (s[n] == 0)
            break;

    int maxchar = -1;
    for (i = 0; i < n; i++)
        maxchar = max(maxchar, s[i] - 'a' + 1);

    int ans = 0;
    if (maxchar == 2)
    {
        for (i = 0; i < n; i++)
            hashes1[i + 1][s[i] - 'a']++;

        for (i = 0; i < n; i++)
        {
            hashes1[i + 1][0] += hashes1[i][0];
            hashes1[i + 1][1] += hashes1[i][1];
        }

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if ((hashes1[i + k][0] - hashes1[i][0]
                    != hashes1[i][0] - hashes1[i - k][0]) ||
                        (hashes1[i + k][1] - hashes1[i][1]
                         != hashes1[i][1] - hashes1[i - k][1]))
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }
    else
    {
        for (i = 0; i < n; i++)
            hashes2[i + 1][s[i] - 'a']++;

        for (i = 0; i < n; i++)
            for (int j = 0; j < 26; j++)
                hashes2[i + 1][j] += hashes2[i][j];

        for (int k = 1; k <= n; k++)
        {
            if (n % k != 0)
                continue;

            bool ok = true;
            for (i = k; i < n; i += k)
            {
                if (!comp_diff(i + k, i, i - k))
                {
                    ok = false;
                    break;
                }
            }

            if (ok)
            {
                ans = n / k;
                break;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
