#include <iostream>
#include <vector>
#include <unordered_map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-6;

struct point
{
    ll x, y;
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, i;
    cin >> n;

    vector<point> points(2 * n);
    for (i = 0; i < 2 * n; i++)
        cin >> points[i].x >> points[i].y;

    bool found = false;
    ll ansx, ansy;
    for (int i = 0; i < 2 * n; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            for (int k = 0; k < 2 * n; k++)
            {
                for (int p = 0; p < 2 * n; p++)
                {
                    if (i == j || i == k || i == p || j == k || j == p || k == p)
                        continue;

                    ll a1 = points[j].y - points[i].y;
                    ll b1 = points[i].x - points[j].x;
                    ll c1 = points[i].y * (points[j].x - points[i].x) +
                            points[i].x * (points[i].y - points[j].y);

                    ll a2 = points[p].y - points[k].y;
                    ll b2 = points[k].x - points[p].x;
                    ll c2 = points[k].y * (points[p].x - points[k].x) +
                            points[k].x * (points[k].y - points[p].y);

                    ll num1 = c2 * b1 - c1 * b2;
                    ll num2 = c1 * a2 - c2 * a1;
                    ll div = a1 * b2 - a2 * b1;

                    if (div == 0 || (num1 % div != 0) || (num2 % div != 0))
                        continue;

                    ll x = num1 / div;
                    ll y = num2 / div;

                    if (abs(x) > 1000000 || abs(y) > 1000000)
                        continue;

                    vector<ld> values(2 * n - 4);
                    bool bad = false;
                    for (int f = 0; f < 2 * n; f++)
                    {
                        if (points[f].x == x && points[f].y == y)
                        {
                            bad = true;
                            break;
                        }

                        if (f == i || f == j || f == k || f == p)
                            continue;

                        if (points[f].y == y)
                            values.push_back((ld)-1e16);
                        else
                            values.push_back((ld)(points[f].x - x) / (ld)(points[f].y - y));
                    }

                    if (bad)
                        continue;

                    sort(values.begin(), values.end());

                    bool good = true;
                    for (int f = 1; f < 2 * n - 4; f++)
                    {
                        if ((f % 2 == 0 && abs(values[f] - values[f - 1]) <= EPS)
                        ||  (f % 2 == 1 && abs(values[f] - values[f - 1]) > EPS))
                        {
                            good = false;
                            break;
                        }
                    }

                    if (good)
                    {
                        found = true;
                        ansx = x;
                        ansy = y;
                        break;
                    }
                }

                if (found)
                    break;
            }

            if (found)
                break;
        }

        if (found)
            break;
    }

    if (found)
    {
        cout << "Yes" << endl;
        cout << ansx << " " << ansy << endl;
    }
    else
        cout << "No" << endl;

    return 0;
}
