//#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

ll INF = 1e16;;
ld eps = 1e-7;
ld pi = acos(-1);

struct pnt {
    ll x, y;
    pnt() {}
    pnt(ll _x, ll _y) {
        x = _x, y = _y;
    }
    pnt operator +(pnt p) {
        return pnt(x + p.x, y + p.y);
    }
    pnt operator -(pnt p) {
        return pnt(x - p.x, y - p.y);
    }
    pnt operator /(ld sc) {
        return pnt(x / sc, y / sc);
    }
    bool operator != (pnt p) {
        return fabs(x - p.x) > eps || fabs(y - p.y) > eps;
    }
};

struct Line {
    ll A, B, C;
    pnt p1, p2;
    Line() {}
    Line(pnt _p1, pnt _p2) {
        p1 = _p1, p2 = _p2;
        A = p2.y - p1.y;
        B = p1.x - p2.x;
        C = -(A * p1.x + B * p1.y);
    }
    bool isOn(pnt p) {
        return A * p.x + B * p.y + C == 0;
    }
    bool isParallel(Line l) {
        return A * l.B == B * l.A;
    }
    pnt intersect(Line l) {
        if (isParallel(l)) {
            return pnt(INF, INF);
        }
        if (abs(B * l.C - l.B * C) % abs(l.B * A - B * l.A) != 0) return pnt(INF, INF);
        if (abs(A * l.C - C * l.A) % abs(l.A * B - A * l.B) != 0) return pnt(INF, INF);
        return pnt((B * l.C - l.B * C) / (l.B * A - B * l.A), (A * l.C - C * l.A) / (l.A * B - A * l.B));
    }
};

int n;
vector <pnt> a;

void check(Line l1, Line l2, pnt p1, pnt p2, pnt p3, pnt p4) {
    if (l1.isParallel(l2)) return;
    pnt p = l1.intersect(l2);
    ll x = round(p.x), y = round(p.y);
    if (x == INF || y == INF) {
        return;
    }
    if ((!l2.isOn(p)) && p1.x != INF) {
        cout << "!!!!!!!!\n" << "!!!!!!";
        exit(0);
    }
    if (p != p1 && p != p2 && p != p3 && p != p4) {
        cout << "Yes\n";
        cout << x << ' ' << y;
        exit(0);
    }
    return;
}

int main() {
    i_o;
    cin >> n;
    a.resize(n * 2);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    Line l01 = Line(a[0], a[1]);
    Line l02 = Line(a[0], a[2]);
    Line l03 = Line(a[0], a[3]);
    Line l12 = Line(a[1], a[2]);
    Line l13 = Line(a[1], a[3]);
    Line l23 = Line(a[2], a[3]);
    check(l01, l23, a[0], a[1], a[2], a[3]);
    check(l02, l13, a[0], a[1], a[2], a[3]);
    check(l12, l03, a[0], a[1], a[2], a[3]);
    cout << "No";
    return 0;
}

