//#pragma GCC optimize("Ofast")

//#include "stdafx.h"

#include <fstream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <map>
#include <set>
#include <iomanip>;
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;


#define mp make_pair
#define all(a) a.begin(), a.end()
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

ll INF = 1e16;

struct pnt {
    ll x, y;
    pnt() {}
    pnt(ll _x, ll _y) {
        x = _x, y = _y;
    }
    pnt operator +(pnt p) {
        return pnt(x + p.x, y + p.y);
    }
    pnt operator -(pnt p) {
        return pnt(x - p.x, y - p.y);
    }
    pnt operator /(ll sc) {
        return pnt(x / sc, y / sc);
    }
    bool operator != (pnt p) {
        return x != p.x || y != p.y;
    }
    bool operator ==(pnt p) {
        return x == p.x && y == p.y;
    }
};

struct Line {
    ll A, B, C;
    pnt p1, p2;
    Line() {}
    Line(pnt _p1, pnt _p2) {
        p1 = _p1, p2 = _p2;
        A = p2.y - p1.y;
        B = p1.x - p2.x;
        C = -(A * p1.x + B * p1.y);
    }
    bool isOn(pnt p) {
        return A * p.x + B * p.y + C == 0;
    }
    bool isParallel(Line l) {
        return A * l.B == B * l.A;
    }
    pnt intersect(Line l) {
        if (isParallel(l)) {
            return pnt(INF, INF);
        }
        if (abs(B * l.C - l.B * C) % abs(l.B * A - B * l.A) != 0) return pnt(INF, INF);
        if (abs(A * l.C - C * l.A) % abs(l.A * B - A * l.B) != 0) return pnt(INF, INF);
        return pnt((B * l.C - l.B * C) / (l.B * A - B * l.A), (A * l.C - C * l.A) / (l.A * B - A * l.B));
    }
};

int n;
pnt p0;
vector <pnt> a, b;

bool check(pnt moon) {
    for (int i = 0; i < n; i++) {
        if (moon == a[i]) return false;
    }
    vector <Line> Lines(n);
    for (int i = 0; i < n; i++) {
        Lines[i] = Line(moon, a[i]);
    }
    vector <int> match(n, -1);
    for (int i = 0; i < n; i++) {
        if (match[i] != -1) continue;
        for (int j = 0; j < n; j++) {
            if (i == j || !Lines[i].isParallel(Lines[j])) continue;
            if (match[i] != -1 || match[j] != -1) {
                return false;
            }
            match[i] = j;
            match[j] = i;
        }
        if (match[i] == -1) {
            return false;
        }
    }
    return true;
}
/*
void solve() {
    i_o;
    cin >> n;
    a.resize(n * 2);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    n = n * 2;
    for (int i = 2; i < n; i++) {
        for (int j = 2; j < n; j++) {
            if (i == j) continue;
            Line l1 = Line(a[0], a[i]);
            Line l2 = Line(a[1], a[j]);
            pnt moon = l1.intersect(l2);
            if (moon.x == INF) continue;
            if (check(moon)) {
                cout << "Yes\n";
                cout << moon.x << ' ' << moon.y;
                exit(0);
            }
        }
    }
    for (int i = 3; i < n; i++) {
        Line l1 = Line(a[0], a[1]), l2 = Line(a[2], a[i]);
        pnt moon = l1.intersect(l2);
        if (moon.x == INF) continue;
        if (check(moon)) {
            cout << "Yes\n";
            cout << moon.x << ' ' << moon.y;
            exit(0);
        }
    }
    cout << "No\n";
}
*/
bool isCol(pnt x, pnt y, pnt z) {
    pnt v1 = y - x, v2 = z - x;
    return v1.x * v2.y == v1.y * v2.x;
}

int main() {
    int n;
    cin >> n;
    vector <pnt> a(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    if (isCol(a[0], a[1], a[2]) && isCol(a[0], a[1], a[3])) {
        cout << "No";
        return 0;
    }
    pnt p1 = Line(a[0], a[1]).intersect(Line(a[2], a[3]));
    pnt p2 = Line(a[0], a[2]).intersect(Line(a[1], a[3]));
    pnt p3 = Line(a[0], a[3]).intersect(Line(a[2], a[1]));
    if (p1.x != INF) {
        cout << "Yes\n";
        cout << p1.x << ' ' << p1.y;
    }
    else if (p2.x != INF) {
        cout << "Yes\n";
        cout << p2.x << ' ' << p2.y;
    }
    else if (p3.x != INF) {
        cout << "Yes\n";
        cout << p3.x << ' ' << p3.y;
    }
    else {
        cout << "No";
    }
}