#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

typedef long long ll;

using namespace std;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

bool fits(string &s, int k) {
    int n = s.size();
    int l = n / k;

    vector<int> base('z' - 'a' + 1);
    for (int i = 0; i < l; ++i) {
        base[s[i] - 'a']++;
    }

    for (int i = n - l; i >= l; i -= l) {
        vector<int> cr('z' - 'a' + 1);
        for (int j = i; j < i + l; ++j) {
            cr[s[j] - 'a']++;
        }
        if (cr != base) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    string s;
    cin >> s;

    vector<int> ctr('z' - 'a' + 1);
    for (char &c : s) {
        ctr[c - 'a']++;
    }

    int a = s.size();
    for (int &i : ctr) {
        a = gcd(max(a, i), min(a, i));
    }

    int sq = sqrt(a) + 1;
    int maxi = 1;
    for (int i = 1; i <= sq; ++i) {
        if (a % i == 0) {
            if (a / i > maxi && fits(s, a / i)) {
                maxi = a / i;
            }
            if (i > maxi && fits(s, i)) {
                maxi = i;
            }
        }
    }

    cout << maxi;
    return 0;
}