#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 2e18;
const ld EPS = 1e-8;

pair<ll, ll> solve(ll a11, ll a12, ll b1, ll a21, ll a22, ll b2) {
    if (a11 * a22 == a21 * a12 || (a22 * b1 - a12 * b2) % (a11 * a22 - a21 * a12) != 0 || (a11 * b2 - a21 * b1) % (a11 * a22 - a21 * a12) != 0) {
        return {-INF, -INF};
    }
    return {(a22 * b1 - a12 * b2) / (a11 * a22 - a21 * a12), (a11 * b2 - a21 * b1) / (a11 * a22 - a21 * a12)};
}

bool online(ll a, ll b, ll c, ll x, ll y) {
    return (a * x + b * y + c == 0);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    int n;
    cin >> n;
    n *= 2;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    int i0 = 3 * n / 4, j0 = n / 3;
    ll x1 = a[i0].first, y1 = a[i0].second;
    ll x3 = a[j0].first, y3 = a[j0].second;
    for (int i = 0; i < n; ++i) {
        if (i != i0 && i != j0) {
            for (int j = 0; j < n; ++j) {
                if (j != j0 && j != i && j != i0) {
                    ll x2 = a[i].first, y2 = a[i].second;
                    ll x4 = a[j].first, y4 = a[j].second;
                    pair<ll, ll> cr = solve(y2 - y1, x1 - x2, -(y1 - y2) * x1 - (x2 - x1) * y1,
                                            y4 - y3, x3 - x4, -(y3 - y4) * x3 - (x4 - x3) * y3);
                    if (abs(cr.first) <= 1000000 && abs(cr.second) <= 1000000) {
                        bool fl = true;
                        set<ld> st;
                        for (int t = 0; fl && t < n; ++t) {
                            ld ccr = (ld)(cr.second - a[t].second) / (a[t].first - cr.first);
                            auto it = st.lower_bound(ccr - EPS);
                            if (it != st.end() && abs(*it - ccr) <= EPS) {
                                fl = false;
                                break;
                            } else {
                                st.insert(ccr);
                            }
                        }
                        if (fl) {
                            cout << "Yes\n" << cr.first << ' ' << cr.second;
                            return 0;
                        }
                    }
                }
            }
        }
    }

    ll x2 = a[j0].first, y2 = a[j0].second;
    for (int i = 0; i < n; ++i) {
        if (i != i0 && i != j0) {
            for (int j = 0; j < n; ++j) {
                if (j != j0 && j != i && j != i0) {
                    x3 = a[i].first, y3 = a[i].second;
                    ll x4 = a[j].first, y4 = a[j].second;
                    pair<ll, ll> cr = solve(y2 - y1, x1 - x2, -(y1 - y2) * x1 - (x2 - x1) * y1,
                                            y4 - y3, x3 - x4, -(y3 - y4) * x3 - (x4 - x3) * y3);
                    if (abs(cr.first) <= 1000000 && abs(cr.second) <= 1000000) {
                        bool fl = true;
                        set<ld> st;
                        for (int t = 0; fl && t < n; ++t) {
                            ld ccr = (ld)(cr.second - a[t].second) / (a[t].first - cr.first);
                            auto it = st.lower_bound(ccr - EPS);
                            if (it != st.end() && abs(*it - ccr) <= EPS) {
                                fl = false;
                                break;
                            } else {
                                st.insert(ccr);
                            }
                        }
                        if (fl) {
                            cout << "Yes\n" << cr.first << ' ' << cr.second;
                            return 0;
                        }
                    }
                }
            }
        }
    }



    cout << "No";
    return 0;
}
