#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG



#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST

int n;
vector<int> *g;
ll *c;
ll *sz;

ll dfs1(int node) {
    sz[node] = 1;
    for (auto i : g[node])sz[node] += dfs1(i);
    return sz[node];
}

ll dfs(int node) {
    ll ans = 0;
    int nn = g[node].size();
    ll *subs = new ll[nn];
    int j = 0;
    ll sum = 0;
    for (auto i : g[node]) {
        ans += dfs(i);
        subs[j] = sz[i];
        sum += subs[j];
        j++;
    }
    sort(subs, subs + nn);
    ll mn = 0;
    ll psum = 0;
    if (node == 0)
        int h = 0;
    for (int i = 0; i < nn; i++) {
        mn -= subs[i];
        if (mn < 0) {
            if (psum > subs[i]) {
                mn = (psum - subs[i]) % 2;
            }
            else {
                mn = subs[i] - psum;
            }
        }
        psum += subs[i];
    }
    ans += sz[node] - 1 + mn;
    return ans;

}

int __main() {
    cin >> n;
    g = new vector<int>[n];
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a; a--;
        g[a].push_back(i);
    }
    c = new ll[n];
    for (int i = 1; i < n; i++)cin >> c[i];
    sz = new ll[n];
    dfs1(0);
    cout << dfs(0);
    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}