#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <stack>
#include <map>
#include <algorithm>
#include <functional>
#include <climits>
#include <cmath>
#include <cassert>
#include <fstream>
#include <ctime>
using namespace std;
typedef long long ll;

//#define DEBUG
//#define TIMETEST

#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif // DEBUG


#ifdef TIMETEST
#define __test main
#else
#define __main main
#endif // TIMETEST


struct point {
    ll x, y;
    bool operator<(const point &a) const {
        if (x == a.x)return (y < a.y);
        return (x < a.x);
    }
};

set<point> points;


ll gcd(ll a, ll b) {
    if (b == 0) return a;
    return gcd(b, (a%b));
}

ll gcd1(ll a, ll b) {
    

    ll gc = gcd(a, b);
    if (gc <= 0) {
        cout << "re";
    }
    return gc;
}

struct drob {
    ll m, n;
    drob(ll mm, ll nn) {
        if (nn < 0) {
            mm = -mm;
            nn = -nn;
        }
      
        ll dc = gcd(((mm<0)?-mm:mm), nn);
        m = mm / dc;
        n = nn / dc;
        if (n == 0)m = 0;
    }

    bool operator==(const drob &a) {
        return (a.m == m && a.n == n);
    }
};

drob polar(point a, point b) {
    if(a.y > b.y)swap(a, b);
    return drob(b.y - a.y, b.x - a.x);
}

ll ampl = 1000000;

void check(point moon, int n, point *p) {
    if (points.find(moon) != points.end())return;

    vector<drob> angles;
    for (int i = 0; i < n; i++)angles.push_back(polar(moon, p[i]));
    sort(angles.begin(), angles.end(), [](const drob &a, const drob &b) {
        if (a.m == b.m)return (a.n < b.n);
        return (a.m < b.m);
    });

    int same = 1;
    for (int i = 1; i < n; i++) {
        if (angles[i] == angles[i - 1]) {
            same++;
        }
        else {
            if (same != 2)
                return;
            same = 1;
        }
    }
    if (same != 2)
        return;

    cout << "Yes\n" << moon.x << " " << moon.y;
    exit(0);
}

int __main() {
    int n;
    cin >> n;
    n = n + n;
    point *p = new point[n];
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
        points.insert(p[i]);
    }

    for (int x = -ampl; x <= ampl; x++) {
        for (int y = -ampl; y <= ampl; y++) {
            check({ x, y }, n, p);
        }
    }
    
    cout << "No";
    return 0;
}

int __test() {
    clock_t t = clock();
    __main();
    cout << endl;
    cout << (clock() - t) << "ms";

    return 0;
}