#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <functional>
#include <numeric>
#include <complex>

using namespace std;
typedef long long nagai;

vector<int> divs(int n)
{
    vector<int> ans;
    for (int i = 1; i * i <= n; ++i)
        if (n % i == 0)
        {
            ans.push_back(i);
            if (i * i != n)
                ans.push_back(n / i);
        }
    return ans;
}

const int mod = 1e9 + 7;

vector<nagai> ha;
nagai get(int l, int r)
{
    nagai ans = ha[r] - ha[l];
    if (ans < mod)
        ans += mod;
    return ans;
}

inline void md(nagai& x)
{
    if (x >= mod)
        x -= mod;
}

int main()
{
    ios::sync_with_stdio(false);
    string s;
    cin >> s;
    int n = s.size();
    ha.resize(n + 1);
    vector<int> d = divs(n);
    const int C = 27;
    vector<nagai> pws(C, 1);
    for (int i = 0; i + 1 < C; ++i)
        pws[i + 1] = pws[i] * (10000000 + i * 10) % mod;
    for (int i = 0; i < n; ++i)
        md(ha[i + 1] = ha[i] + pws[s[i] - 'a' + 1]);
    
    int ans = 1;
    for (int dv : d)
    {
        int mem = get(0, dv);
        bool ok = true;
        for (int i = dv; i < n; i += dv)
            if (mem != get(i, i + dv))
            {
                ok = false;
                break;
            }
        if (ok)
            ans = max(ans, n / dv);
    }
    cout << ans << '\n';
}