#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const ll INF = (ll) 1e18;

struct Graph {
    int n;
    vector<vector<int>> g;
    vector<ll> sz;
    vector<ll> sumc;
    vector<pair<ll, ll>> mins;
    vector<pair<int, int>> indMins;
    vector<ll> cs;

    void add(int v, int u) {
        g[v].push_back(u);
    }

    void readCs() {
        cs[0] = 0;
        for (int i = 1; i < n; ++i) {
            cin >> cs[i];
        }
    }

    ll dfs(int v) {
        mins[v].first = INF, mins[v].second = INF;
        sz[v] = 1;
        sumc[v] = cs[v];
        ll here = 0;
        set<pair<ll, int>> s;
        for (auto to : g[v]) {
            here += dfs(to);
            if (mins[to].first < mins[v].first) {
                mins[v].second = mins[v].first;
                indMins[v].second = indMins[v].first;
                mins[v].first = mins[to].first;
                indMins[v].first = to;
            } else if (mins[to].first < mins[v].second) {
                mins[v].second = mins[to].first;
                indMins[v].second = to;
            }
            sz[v] += sz[to];
            sumc[v] += sumc[to];
            s.insert({sz[to], to});
            here += sumc[to];
        }
        ll firstVar = 0;
        auto sr = s;
        while (s.size() > 1) {
            auto p = *s.rbegin();
            s.erase(--s.end());
            auto pp = *s.rbegin();
            s.erase(--s.end());
            p.first -= pp.first;
            if (p.first) {
                s.insert(p);
            }
        }
        if (!s.empty()) {
            auto p = *s.begin();
            if (p.second != indMins[v].first) {
                firstVar += p.first * mins[v].first;
            } else {
                firstVar += p.first * mins[v].second;
            }
        }
        ll secondVar = 0;
        auto ost = sz[indMins[v].first];
        sr.erase({sz[indMins[v].first], indMins[v].first});
        while (ost && !sr.empty()) {
            auto p = *sr.rbegin();
            sr.erase(--sr.end());
            ll db = min(ost, p.first);
            p.first -= db;
            ost -= db;
            if (p.first) {
                sr.insert(p);
            }
        }
        if (!sr.empty()) {
            while (sr.size() > 1) {
                auto p = *sr.rbegin();
                sr.erase(--sr.end());
                auto pp = *sr.rbegin();
                sr.erase(--sr.end());
                p.first -= pp.first;
                if (p.first) {
                    sr.insert(p);
                }
            }
            if (!sr.empty()) {
                auto p = *sr.begin();
                secondVar = p.first * mins[v].first;
            } else {
                secondVar = 0;
            }
        } else {
            secondVar = ost * mins[v].second;
        }
        secondVar = INF;
        here += min(firstVar, secondVar);
        if (cs[v] < mins[v].first) {
            mins[v].first = cs[v];
        } else if (cs[v] < mins[v].second) {
            mins[v].second = cs[v];
        }
        return here;
    }

    Graph(int n):
            n(n), g(n), sz(n), sumc(n),
            mins(n), indMins(n), cs(n) { }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n;
    cin >> n;
    Graph g(n);
    for (int i = 1, p; i < n; ++i) {
        cin >> p;
        g.add(--p, i);
    }
    g.readCs();
    cout << g.dfs(0) << "\n";
    return 0;
}
/*
5
1 2 2 1
1 1 1 1

6
1 1 1 4 4
1 2 3 4 5
 */