#define _CRT_SECURE_NO_WARNINGS
typedef long long ll;
typedef long double ld;
#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<algorithm>
#include<map>
#include<cmath>
#include<math.h>
#include<set>
#include<queue>
#include<deque>
#include<iomanip>
#include<unordered_map>
#include<unordered_set>
#include<bitset>
#include<ctime>

using namespace std;
ll INF = 1e17;
ld eps = 1e-9;
ll MOD = 1e9 + 7;
ld PI = atan2(0, -1);

ll iter = 0;

bool eq(ld a, ld b) {
	return abs(a - b) < eps;
}

struct pt {
	ll x, y;
	pt(ll _x = 0, ll _y = 0) {
		x = _x;
		y = _y;
	}

	pt operator +(pt b) {
		x += b.x;
		y += b.y;
		return { x,y };
	}
	pt operator -(pt b) {
		x -= b.x;
		y -= b.y;
		return { x,y };
	}
	bool operator ==(pt b) {
		return x == b.x && y == b.y;
	}

	ll operator %(pt b) {
		return x * b.x + y * b.y;
	}
	ll operator *(pt b) {
		return x * b.y - b.x*y;
	}
};

inline pt llersect(pt f1, pt f2, pt s1, pt s2) {
	ll a1 = f1.y - f2.y;
	ll b1 = f2.x - f1.x;
	ll c1 = -(a1*f1.x + b1 * f1.y);
	
	ll a2 = s1.y - s2.y;
	ll b2 = s2.x - s1.x;
	ll c2 = -(a2*s1.x + b2 * s1.y);

	if (a1*b2== a2*b1) {
		return{ INF,INF };
	}
	ll x = INF, y = INF;
	if ((c2*b1 - c1 * b2) % (a1*b2 - a2 * b1) == 0) {
		x = (c2*b1 - c1 * b2) / (a1*b2 - a2 * b1);
	}
	if ((c2*b1 - c1 * b2) % (a1*b2 - a2 * b1) == 0) {
		x = (c2*b1 - c1 * b2) / (a1*b2 - a2 * b1);
	}
	if ((c2*a1 - c1 * a2) % (b1*a2 - b2 * a1) == 0) {
		y = (c2*a1 - c1 * a2) / (b1*a2 - b2 * a1);
	}
	return{ x,y };
}
pt v[100000];
ll n;

inline ld dist(pt a, pt b) {
	return sqrt((a.x - b.x)*(a.x - b.x) + (a.y - b.y)*(a.y - b.y));
}

inline ll on_line(pt a, pt t, pt b) {
	return ((!(a == t)) && (!(b == t)) & (a-t)*(b-t)==0);
}

inline ll check(pt t) {
	vector<ll>used(2 * n, 0);
	for (ll i = 0; i < 2 * n; i++) {
		if (used[i] == 1) {
			continue;
		}
		ll cnt = 0;
		for (ll j = i + 1; j < 2 * n; j++) {
			iter++;
			if (used[i] == 1) {
				continue;
			}
			if (on_line(v[i], t, v[j])) {
				cnt++;
				if (cnt > 1) {
					return 0;
				}
				used[j] = 1;
			}
		}
		if (cnt == 0) {
			return 0;
		}
	}
	return 1;
}

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a%b);
}

int main() {
	cin.tie(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	cin >> n;
	for (ll i = 0; i < 2*n; i++) {
		cin >> v[i].x >> v[i].y;
	}
	random_shuffle(v, v + 2 * n);
	
	/*if (n == 1) { //////
		ll g = gcd(abs(v[0].x - v[1].x), abs(v[0].y - v[1].y));
		if (g>1) {
			cout << "Yes" << '\n' << min(v[0].x, v[1].x) + abs(v[0].x - v[1].x) / g << ' ' << min(v[0].y, v[1].y) + abs(v[0].y - v[1].y) / g;
		}
		else {
			cout << "No";
		}
		return 0;
	}*/


	ll i1 = 0;
	for (ll i2 = 1; i2 < 2 * n; i2++) {
		ll j1 = 1;
		while (j1==i2) {
			j1++;
		}
		for (ll j2 = 1; j2 < 2 * n; j2++) {
			iter++;
			if (j2 == i1 || j2 == i2 || j2 == j1) {
				continue;
			}
			pt t = llersect(v[i1], v[i2], v[j1], v[j2]);
			if (abs(t.x) <= 1000000 && abs(t.y) <= 1000000) {
				if (check(t)) {
					cout << "Yes" << '\n' << t.x << ' ' << t.y;
					return 0;
				} 
			}
		}
	}
	cout << "No";



	return 0;
}