#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <cstdio>
#include <utility>
#include <ostream>
#include <ctime>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;

void dfs(int s, int p, vector<vector<int>> &g, vector<int> &sz,
	vector<ll> &sum, vector<int> &c, vector<int> &minz) {
	sz[s] = 1;
	sum[s] = c[s];
	minz[s] = c[s];
	for (int to : g[s]) {
		if (to == p) continue;
		dfs(to, s, g, sz, sum, c, minz);
		sz[s] += sz[to];
		sum[s] += sum[to];
		minz[s] = min(minz[s], minz[to]);
	}
}

int rem(vector<int> &a) {
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	int n = a.size();
	if (n == 0) return 0;
	if (n == 1) return a[0];
	while (true) {
		if (a[1] == 0) break;
		a[0]--;
		a[1]--;
		int cur = 1;
		while (cur + 1 < n && a[cur] < a[cur + 1]) {
			swap(a[cur], a[cur + 1]);
			cur++;
		}
		cur = 0;
		while (cur + 1 < n && a[cur] < a[cur + 1]) {
			swap(a[cur], a[cur + 1]);
			cur++;
		}
	}
	return a[0];
}

ll solve(int s, int p, vector<vector<int>> &g, vector<int> &sz,
	vector<ll> &sum, vector<int> &minz, vector<int> &c) {
	ll result = 0;
	vector<int> t;
	int mint = 1e9;
	for (int to : g[s]) {
		if (to == p) continue;
		result += solve(to, s, g, sz, sum, minz, c);
		t.push_back(sz[to]);
		mint = min(mint, minz[to]);
	}
	return result + sum[s] - c[s] + 1ll * rem(t) * mint;
} 
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<vector<int>> g(n);
	for (int i = 0; i < n - 1; i++) {
		int a;
		cin >> a;
		a--;
		g[a].push_back(i + 1);
		g[i + 1].push_back(a);
	}
	vector<int> c(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> c[i + 1];
	}
	vector<int> sz(n);
	vector<ll> sum(n);
	vector<int> minz(n);
	dfs(0, -1, g, sz, sum, c, minz);
	cout << solve(0, -1, g, sz, sum, minz, c);
}