#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <cstdio>
#include <utility>
#include <ostream>
#include <ctime>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;


ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

struct Line {
	ll a, b, c;
	bool operator < (const Line &l) const {
		return (a < l.a) || (a == l.a && b < l.b) ||
			(a == l.a && b == l.b && c < l.c);
	}
	Line(ll _a, ll _b, ll _c) {
		int g = gcd(gcd(abs(_a), abs(_b)), abs(_c));
		a = _a / g;
		b = _b / g;
		c = _c / g;
		if (a < 0) a *= -1, b *= -1, c *= -1;
	}
};

pii find(int a, int b, vector<int> &x, vector<int> &y,
	map<Line, vector<pii>> &mlines) {
	int n = x.size();
	ll dx, dy;
	for (int i = 0; i < n; i++) {
		if (a == i) continue;
		dx = x[a] - x[i];
		dy = y[a] - y[i];
		Line l1 = Line(dy, -dx, -(dy * x[a] - dx * y[a]));
		for (int j = 0; j < n; j++) {
			if (b == j) continue;
			dx = x[b] - x[j];
			dy = y[b] - y[j];
			Line l2 = Line(dy, -dx, -(dy * x[b] - dx * y[b]));
			ll k = l2.b * l1.a - l2.a * l1.b;
			if (k == 0) continue;
			int xp, yp;
			xp = (l2.c * l1.b - l2.b * l1.c) / k;
			if (l1.b != 0) yp = (-l1.c - l1.a * xp) / l1.b;
			else yp = (-l2.c - l2.a * xp) / l2.b;
			if (l1.a * xp + l1.b * yp + l1.c != 0
				|| l2.a * xp + l2.b * yp + l2.c != 0)
				continue;
			bool can = true;
			for (int q = 0; q < n; q++) {
				if (xp == x[q] && yp == y[q]) {
					can = false;
					break;
				}
			}
			if (xp == 2 && yp == 2) {
				int w = 1;
			}
			if (!can) continue;
			for (int q = 0; q < n; q++) {
				if (q == a || q == b || q == i || q == j) continue;
				dx = x[q] - xp;
				dy = y[q] - yp;
				Line l3 = Line(dy, -dx, -(dy * x[q] - dx * y[q]));
				if (!mlines.count(l3)) {
					can = false;
					break;
				}
			}
			if (can) return { xp, yp };
		}
	}
	return { 1e9, 1e9 };
}
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	n *= 2;
	vector<int> x(n), y(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	map<Line, vector<pii>> mlines;
	vector<Line> lines;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			// vec(a, b) = { x1 - x0, y1 - y0 }
			ll dx = x[i + 1] - x[i];
			ll dy = y[i + 1] - y[i];
			Line l = Line(dy, -dx, -(dy * x[i] - dx * y[i]));
			lines.push_back(l);
			mlines[l].push_back({ i, j });
		}
	}
	pii p1 = find(0, 1, x, y, mlines);
	pii p2 = find(0, 2, x, y, mlines);
	if (p1.first != 1e9) {
		cout << "Yes\n";
		cout << p1.first << " " << p1.second;
		return 0;
	}
	if (p2.first != 1e9) {
		cout << "Yes\n";
		cout << p2.first << " " << p2.second;
		return 0;
	}
	cout << "No";
}