#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <cstdio>
#include <utility>
#include <ostream>
#include <ctime>
#include <cmath>
#include <string>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ldb;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

struct Line {
	ll a, b, c;
	bool operator < (const Line &l) const {
		return (a < l.a) || (a == l.a && b < l.b) ||
			(a == l.a && b == l.b && c < l.c);
	}
	Line(ll _a, ll _b, ll _c) {
		ll g = gcd(gcd(abs(_a), abs(_b)), abs(_c));
		a = _a / g;
		b = _b / g;
		c = _c / g;
		if (a < 0) a *= -1, b *= -1, c *= -1;
	}
};
/*
ldb eps = 1e-18;
bool eq(ldb a, ldb b) {
	return abs(a - b) < eps;
}*/

pii find(int a, int b, vector<int> &x, vector<int> &y,
	vector<set<Line>> &ml, bool t = false) {
	int n = x.size();
	ll dx, dy;
	for (int i = 0; i < n; i++) {
		if (a == i) continue;
		if (t) {
			if (i != (n + b - 1) % n) continue;
		}
		dx = x[a] - x[i];
		dy = y[a] - y[i];
		Line l1 = Line(dy, -dx, -(dy * x[a] - dx * y[a]));
		for (int j = 0; j < n; j++) {
			if (b == j) continue;
			dx = x[b] - x[j];
			dy = y[b] - y[j];
			Line l2 = Line(dy, -dx, -(dy * x[b] - dx * y[b]));
			ll k = l2.b * l1.a - l2.a * l1.b;
			if (k == 0) continue;
			ll xp, yp; 
			xp = (l2.c * l1.b - l2.b * l1.c) / k;
			if (l1.b != 0) yp = (-l1.c - l1.a * xp) / l1.b;
			else yp = (-l2.c - l2.a * xp) / l2.b; 
			if (l1.a * xp + l1.b * yp + l1.c != 0
				|| l2.a * xp + l2.b * yp + l2.c != 0) continue;
			/*ldb xpd, ypd;
			xpd = 1.0 * (l2.c * l1.b - l2.b * l1.c) / k;
			if (l1.b != 0) ypd = 1.0 * (-l1.c - l1.a * xpd) / l1.b;
			else ypd = (-l2.c - l2.a * xpd) / l2.b;
			ll xp, yp;
			if (eq(l1.a * xpd + l1.b * ypd + l1.c, 0)
				&& eq(l2.a * xpd + l2.b * ypd + l2.c, 0))
				xp = xpd, yp = ypd;
			else continue;*/
			if (abs(xp) > 1e6 || abs(yp) > 1e6) continue;
			bool can = true;
			for (int q = 0; q < n; q++) {
				if (xp == x[q] && yp == y[q]) {
					can = false;
					break;
				}
			}
			if (!can) continue;
			map<Line, int> sl;
			for (int q = 0; q < n; q++) {
				dx = x[q] - xp;
				dy = y[q] - yp;
				Line l3 = Line(dy, -dx, -(dy * x[q] - dx * y[q]));
				if (!ml[q].count(l3)) {
					can = false;
					break;
				}
				sl[l3]++;
			}
			for (auto a : sl) {
				if (a.second > 2) can = false;
			}
			if (can) return { xp, yp };
		}
	}
	return { 1e9, 1e9 };
}
int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	n *= 2;
	vector<int> x(n), y(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
	}
	vector<set<Line>> ml(n);
	vector<Line> lines;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ll dx = x[j] - x[i];
			ll dy = y[j] - y[i];
			Line l = Line(dy, -dx, -(dy * x[i] - dx * y[i]));
			lines.push_back(l);
			ml[i].insert(l);
			ml[j].insert(l);
		}
	}
	srand(n + 1234);
	int a = rand() % n;
	int b;
	while (a == b) b = rand() % n;
	pii p1 = find(a, b, x, y, ml);
	pii p2 = find(a, (b + 1) % n, x, y, ml);
	//a
	//pii p2 = find(a, (b + 1) % n, x, y, ml, true);
	if (p1.first != 1e9) {
		cout << "Yes\n";
		cout << p1.first << " " << p1.second;
		return 0;
	}
	if (p2.first != 1e9) {
		cout << "Yes\n";
		cout << p2.first << " " << p2.second;
		return 0;
	}
	cout << "No";
}