//{

#include <bits/stdc++.h>

#define forn(i, n) for (auto i = 0; i <= n; i++)
#define mp make_pair
#define pb push_back
#define all(x) x.begin (), x.end ()
#define rall(x) x.rbegin (), x.rend ()

using namespace std;

typedef long long lli;
typedef long double ld;

//}

struct Vector
{
    lli x, y;
    Vector (lli x0 = 0, lli y0 = 0): x (x0), y (y0) {}
};

bool operator == (const Vector& f, const Vector& s)
{
    return (f.x == s.x) && (f.y == s.y);
}

struct Line
{
    lli a, b, c;
    Line (Vector f, Vector s): a (s.y - f.y), b (f.x - s.x), c (f.y * s.x - f.x * s.y) {}
};

bool operator < (const Line& f, const Line& s)
{
    if (f.a != s.a)
        return f.a < s.a;
    if (f.b != s.b)
        return f.b < s.b;
    return f.c < s.c;
}

vector <Vector> Crossing (Line f, Line s)
{
    vector <Vector> result;
    if (((s.a * f.b - f.a * s.b) == 0) || ((s.b * f.a - s.a * f.b) == 0))
        return result;
    lli x = (s.b * f.c - s.c * f.b) / (s.a * f.b - f.a * s.b);
    lli y = (s.a * f.c - f.a * s.c) / (s.b * f.a - s.a * f.b);
    result.push_back ({ x, y });
    return result;
}

bool OnLine (Line f, Vector s)
{
    return (f.a * s.x + f.b * s.y + f.c == 0);
}

lli Mod (lli a, lli b)
{
    return (a % b + b) % b;
}

lli GCD (lli a, lli b)
{
    if (b == 0)
        return a;
    return GCD (b, Mod (a, b));
}

void Solve ()
{
    lli n = 0;
    cin >> n;
    vector <Vector> data (2 * n);
    for (auto &it : data)
        cin >> it.x >> it.y;
    if (data.size () < 4)
    {
        cout << "No";
        return;
    }
    for (lli i = 1; i < data.size () - 1; i++)
    {
        for (lli j = 1; j < data.size () - 1; j++)
        {
            if (i == j)
                continue;
            Line f (data[0], data[i]), s (data.back (), data[j]);
            vector <Vector> buffer = Crossing (f, s);
            if (buffer.empty ())
                continue;
            Vector next = buffer[0];
            if ((!OnLine (f, next)) || (!OnLine (s, next)))
                continue;
            if ((abs (next.x) > 1e6) || (abs (next.y) > 1e6))
                continue;
            bool flag = true;
            for (lli t = 0; t < data.size (); t++)
            {
                if (data[t] == next)
                {
                    flag = false;
                    break;
                }
            }
            if (!flag)
                continue;
            map <Line, lli> check;
            for (lli t = 1; t < data.size () - 1; t++)
            {
                if ((t == i) || (t == j))
                    continue;
                Line h (data[t], next);
                lli value = GCD (abs (h.c), GCD (abs (h.a), abs (h.b)));
                h.a /= value;
                h.b /= value;
                h.c /= value;
                if (check.count (h) == 0)
                {
                    h.a = -h.a;
                    h.b = -h.b;
                    h.c = -h.c;
                }
                check[h]++;
            }
            for (auto it : check)
            {
                if (it.second != 2)
                {
                    flag = false;
                    break;
                }
            }
            if (!flag)
                continue;
            else
            {
                cout << "Yes\n";
                cout << next.x << ' ' << next.y;
                return;
            }
        }
    }





    for (lli j = 2; j < data.size () - 1; j++)
    {
        Line f (data[0], data.back ()), s (data[1], data[j]);
        vector <Vector> buffer = Crossing (f, s);
        if (buffer.empty ())
            continue;
        Vector next = buffer[0];
        if ((!OnLine (f, next)) || (!OnLine (s, next)))
            continue;
        if ((abs (next.x) > 1e6) || (abs (next.y) > 1e6))
            continue;
        bool flag = true;
        for (lli t = 0; t < data.size (); t++)
        {
            if (data[t] == next)
            {
                flag = false;
                break;
            }
        }
        if (!flag)
            continue;
        map <Line, lli> check;
        for (lli t = 2; t < data.size () - 1; t++)
        {
            if (t == j)
                continue;
            Line h (data[t], next);
            lli value = GCD (abs (h.c), GCD (abs (h.a), abs (h.b)));
            h.a /= value;
            h.b /= value;
            h.c /= value;
            if (check.count (h) == 0)
            {
                h.a = -h.a;
                h.b = -h.b;
                h.c = -h.c;
            }
            check[h]++;
        }
        for (auto it : check)
        {
            if (it.second != 2)
            {
                flag = false;
                break;
            }
        }
        if (!flag)
            continue;
        else
        {
            cout << "Yes\n";
            cout << next.x << ' ' << next.y;
            return;
        }
    }
    cout << "No";
}

signed main ()
{
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    cout.tie (nullptr);
    cout << fixed << setprecision (20);
    Solve ();
    return 0;
}
