
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct point
{
	int x, y;
	bool operator==(point q)
	{
		return q.x == x && q.y == y;
	}
};

struct line
{
	int a, b, c;
	line() : a(0), b(0), c(0) {};
	line(point q, point w)
	{
		a = q.y - w.y;
		b = w.x - q.x;
		c = -a * q.x - b * q.y;
	}

};

vector <point > b;

bool cross(line q, line w, point &an)
{
	ll p1 = w.c * q.b - q.c * w.b;
	ll p2 = q.a * w.b - q.b * w.a;
	ll p3 = w.c * q.a - q.c * w.a;
	if (p2 == 0 || p1 % p2 != 0 || p3 % p2 != 0)
		return false;
	an.x = p1 / p2;
	an.y = -p3 / p2;
}

bool on(line a1, point b)
{
	return (a1.a * b.x + a1.b * b.y + a1.c == 0);
}

bool check(int q, int w, int e, int r)
{
	vector <point > a;
	a = b;
	point an;
	if (!cross(line(a[q], a[w]), line(a[e], a[r]), an))
		return false;
	int flag = 0;
	for (int i = 0; i < a.size(); i++)
	{
		if (a[i] == an)
			return false;
		flag = 0;
		for (int j = 0; j < a.size(); j++)
			if (i != j && on(line(an, a[i]), a[j]))
				flag++;
		if (flag != 1)
			return false;
	}
	return true;
}


int main()
{
	ifstream cin("input.txt");
	//ofstream cout("output.txt");
	ios_base::sync_with_stdio(0), cin.tie(0);
	int n;
	cin >> n;
	n *= 2;
	b.resize(n);
	for (int i = 0; i < n; i++)
		cin >> b[i].x >> b[i].y;
	random_shuffle(b.begin(), b.end());
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			for (int q = 0; q < n; q++)
				for (int w = 0; w < n; w++)
					if (i != j && i != q && i != w && j != q && j != w && q != w && check(i, j, q, w))
					{
						point an;
						cross(line(b[i], b[j]), line(b[q], b[w]), an);
						cout << "Yes\n";
						cout << an.x << ' ' << an.y << endl;
						return 0;
					}
	cout << "No";
	return 0;
}
