#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef unsigned long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}
vector<ll> multiply(26);
string s;
vector<ll> pref;
ll getsum(int l, int r) {
    return (pref[r] - pref[l] + multiply[s[l] - 'a'] + mod) % mod;
}

int main() {
    fast_input();
    files();
    cin >> s;
    int n = s.size();
    multiply[0] = 1;
    for (int i = 1; i < 26; ++i)
        multiply[i] = (multiply[i - 1] * 37) % mod;
    pref = vector<ll>(n);
    ll currsum = 0;
    for (int i = 0; i < n; ++i) {
        currsum = (currsum + multiply[s[i] - 'a']) % mod;
        pref[i] = currsum;
    }
    for (int i = 1; i <= n; ++i) 
        if (n % i == 0) {
            ll checksum = getsum(0, i - 1);
            bool cr = true;
            for (int j = i - 1; j < n && cr; j += i)
                if (getsum(j - i + 1, j) != checksum)
                    cr = false;
            if (cr) {
                cout << n / i;
                return 0;
            }
        }
    system("pause");
    return 0;
}