#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef unsigned long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

vector<vector<ll>> G;
vector<ll> cnt;
ll ans = 0;

void dfs(ll v) {
    vector<ll> arr;
    for (auto i : G[v]) {
        dfs(i);
        arr.push_back(cnt[i]);
    }
    ll summ = 0;
    for (auto i : arr) summ += i;
    cnt[v] = summ + 1;
    if (arr.size() == 0) return;
    sort(arr);
    while (arr[arr.size() - 2] > 0) {
        --arr[arr.size() - 1];
        --arr[arr.size() - 2];
        ans += 2;
        sort(arr);
    }
    ans += arr[arr.size() - 1] * 2;
}

int main() {
    fast_input();
    files();
    ll n;
    cin >> n;
    G = vector<vector<ll>>(n);
    cnt = vector<ll>(n, 0);
    for (ll i = 1; i < n; ++i) {
        ll p;
        cin >> p;
        G[p - 1].push_back(i);
    }
    vector<ll> c(n);
    for (ll i = 1; i < n; ++i) cin >> c[i];
    dfs(0);
    cout << ans;
    return 0;
}