#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <string>

using namespace std;
typedef unsigned long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll inf = 1e18 + 13;

struct Vector {
    ll x, y;
    Vector() {

    }
    Vector(ll a, ll b) {
        x = a, y = b;
    }
};

ll operator*(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

ll operator/(Vector a, Vector b) {
    return a.y * b.x - a.x * b.y;
}

istream& operator>>(istream& is, Vector &a) {
    cin >> a.x >> a.y;
    return is;
}

ostream& operator<<(ostream& os, Vector &a) {
    cout << a.x << ' ' << a.y << '\n';
    return os;
}

istream& operator>>(istream& is, vector<ll> &a) {
    for (auto &i : a) cin >> i;
    return is;
}

ostream& operator<<(ostream& os, vector<ll> &a) {
    for (auto &i : a) cout << i << ' ';
    return os;
}

void sort(vector<ll> &a) {
    sort(a.begin(), a.end());
}

ll step(ll a, ll n) {
    if (n == 1) return a % mod;
    if (n & 1) return (step(a, n - 1) * a) % mod;
    ll k = step(a, n / 2);
    return (k * k) % mod;
}

void fast_input() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void files() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
}

int gcd(int a, int b) {
    return a > 0 ? (b % a, a) : b;
}

void add(set<pair<int, int>> &usedangles, int x, int y) {
    if (x < 0) x = -x, y = -y;
    int g = gcd(x, abs(y));
    x /= g, y /= g;
    usedangles.insert({ x, y });
}

int main() {
    fast_input();
    files();
    int n;
    cin >> n;
    if (n > 2) {
        cout << "Yes\n2 2";
        return 0;
    }
    n *= 2;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i] >> y[i];
    map<pair<int, int>, int> used;
    for (int i = 0; i < n; ++i) {
        used[{ x[i], y[i] }] = i;
    }
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j) {
            set<pair<int, int>> usedangles;
            vector<bool> usedpoints(n);
            usedpoints[i] = true;
            usedpoints[j] = true;
            if ((abs(x[i] - x[j]) & 1 || abs(y[i] - y[j]) & 1)) continue;
            int midx = (x[i] + x[j]) / 2, midy = (y[i] + y[j]) / 2;
            add(usedangles, x[j] - midx, y[j] - midy);
            bool cr = true;
            for (int k = 0; k < n; ++k) {
                if (usedpoints[k]) continue;
                if (x[k] == midx && y[k] == midy) cr = false;
                if (!used.count({ midx - (x[k] - midx), midy - (y[k] - midy)})) cr = false;
                int sz = usedangles.size();
                add(usedangles, x[k] - midx, y[k] - midy);
                if (usedangles.size() == sz) cr = false;
                if (!cr) break;
                usedpoints[k] = true;
                usedpoints[used[{ midx - (x[k] - midx), midy - (y[k] - midy)}]] = true;
            }
            if (!cr) continue;
            cout << "Yes\n";
            cout << midx << ' ' << midy;
            return 0;
        }
    cout << "No";
    return 0;
}