#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rnd(1235);

struct line{
    int a, b;
    ll c;
    bool operator ==(const line &p) const{
        return a == p.a && b == p.b && c == p.c;
    }
};

struct point{
    int x, y;
    bool operator ==(const point &p) const{
        return x == p.x && y == p.y;
    }
    bool operator !=(const point &p) const{
        return x != p.x || y != p.y;
    }
};

double leng(point a){
    return sqrt(a.x * a.x + a.y * a.y);
}

int angle(ll x){
    if (x > 0)
        return 1;
    if (x < 0)
        return -1;
    return 0;
}

ll cpr(point a, point b){
    return a.x * b.y - a.y * b.x;
}

ll dpr(point a, point b){
    return a.x * b.x + a.y * b.y;
}

point dif(point a, point b){
    return {b.x - a.x, b.y - a.y};
}

ll area(point a, point b, point c){
    return cpr(dif(a, b), dif(a, c));
}

line getline(point a, point b){
    return {a.y - b.y, b.x - a.x, a.x * (ll)b.y - b.x * (ll)a.y};
}

const int bound = 1e6;

bool inb(ll x){
    return x >= -bound && x <= bound;
}

bool inb(ll x, ll y){
    return inb(x) && inb(y);
}

point BAD = {bound + 1, bound + 1};

point intersect(line a, line b){
    ll A = -(a.c * b.b - b.c * a.b), B = (a.a * (ll)b.b - a.b * (ll)b.a), C = -(a.a * b.c - b.a * a.c);
    if (B == 0 || A % B != 0 || C % B != 0 || !inb(A / B, C / B))
        return BAD;
    return {A / B, C / B};
}

int interx(line a, line b){
    ll A = -(a.c * b.b - b.c * a.b), B = (a.a * (ll)b.b - a.b * (ll)b.a), C = -(a.a * b.c - b.a * a.c);
    if (B == 0 || A % B != 0 || C % B != 0 || !inb(A / B, C / B))
        return BAD.x;
    return A / B;
}

bool same(line a, line b){
    return a.a * (ll)b.b - a.b * (ll)b.a == 0 && a.c == b.c;
}

const int maxn = 1000 + 10, maxw = 2e6 + 100, inf = 1e9 + 100, mod = 1e9 + 7, sq = 300, LG = 18;

int n;

point arr[2 * maxn];

line q[2 * maxn][2 * maxn];

bool badl[2 * maxn][2 * maxn];

int b[2 * maxn][2 * maxn];

int mas[maxw];

int main()
{
    #ifdef ONPC
    freopen("a.in", "r", stdin);
    freopen("a.out", "w", stdout);
    #endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < 2 * n; i++)
        cin >> arr[i].x >> arr[i].y;
    for (int i = 0; i < 2 * n; i++)
        for (int j = i + 1; j < 2 * n; j++)
            q[i][j] = getline(arr[i], arr[j]);
    for (int i = 0; i < 2 * n; i++)
        for (int j = i + 1; j < 2 * n; j++)
            for (int k = j + 1; k < 2 * n; k++)
                if (same(q[i][j], q[i][k])){
                    badl[i][j] = 1;
                    badl[i][k] = 1;
                    badl[j][k] = 1;
                }
    for (int start = 1; start < 2 * n; start++)
    if (!badl[0][start]){
        line st = q[0][start];
        for (int i = 1; i < 2 * n; i++)
        if (i != start)
            for (int j = i + 1; j < 2 * n; j++)
            if (j != start && !badl[i][j]){
                b[i][j] = interx(st, q[i][j]);
                if (b[i][j] != BAD.x && b[i][j] != arr[start].x && b[i][j] != arr[0].x){
                    mas[b[i][j] + bound]++;
                    if (mas[b[i][j] + bound] == n - 1){
                        point ans = intersect(st, q[i][j]);
                        cout << "Yes\n" << ans.x << ' ' << ans.y;
                        return 0;
                    }
                }
            }
        for (int i = 1; i < 2 * n; i++)
        if (i != start)
            for (int j = i + 1; j < 2 * n; j++)
            if (j != start && !badl[i][j]){
                if (b[i][j] != BAD.x){
                    if (mas[b[i][j] + bound] == 0)
                        continue;
                    if (b[i][j] != arr[0].x && b[i][j] != arr[start].x && mas[b[i][j] + bound] == n - 1){
                        point ans = intersect(st, q[i][j]);
                        cout << "Yes\n" << ans.x << ' ' << ans.y;
                        return 0;
                    }
                    mas[b[i][j] + bound] = 0;
                }
            }
    }
    cout << "No\n";
}
