#include <stdio.h>
#include <algorithm>
#include <map>
#include <utility>

int n;
long long x = 0, y = 0, *xx, *yy;
bool *used;

long long gcd(long long a, long long b) {
	int sign = 1;
	if (a < 0) {
		a *= -1;
		sign = -1;
	}
	if (b < 0) {
		b *= -1;
		if (a == 0) {
			sign = -1;
		}
	}
	while (a > 0 && b > 0) {
		a %= b;
		if (a > 0) {
			b %= a;
		}
	}
	return (a > 0 ? a : b) * sign;
}

bool f(long long x0, long long y0, long long x1, long long y1, long long x2, long long y2, long long x3, long long y3) {
	long long a1 = y1 - y0, b1 = x0 - x1, c1 = x1 * y0 - x0 * y1;
	long long a2 = y3 - y2, b2 = x2 - x3, c2 = x3 * y2 - x2 * y3;
	if (a1 == 0) {
		y = -c1 / b1;
		if (a2 != 0) {
			x = -(c2 + b2 * y) / a2;
		}
	} else if (a2 == 0) {
		y = -c2 / b2;
		if (a1 != 0) {
			x = -(c1 + b1 * y) / a1;
		}
	} else {
		if (b1 * a2 != a1 * b2) {
			y = (c2 * a1 - c1 * a2) / (b1 * a2 - b2 * a1);
			if (a1 != 0) {
				x = -(c1 + b1 * y) / a1;
			}
		} else {
			return false;
		}
	}
	if (a1 * x + b1 * y + c1 == 0 && a2 * x + b2 * y + c2 == 0 && x <= 1e6 && x >= -1e6 && y >= -1e6 && y <= 1e6 && (x != x0 || y != y0) && (x != x1 || y != y1) && (x != x2 || y != y2) && (x != x3 || y != y3)) {
		return true;
	}
	return false;
}

bool check() {
	std::map<std::pair<long long, long long>, int> ma;
	int cnt = 0;
	for (int i = 0; i < 2 * n; i++) {
		if (x == xx[i] && y == yy[i]) {
			return false;
		}
		long long x1 = xx[i] - x, y1 = yy[i] - y;
		long long gc = gcd(x1, y1);
		x1 /= gc;
		y1 /= gc;
		ma[std::make_pair(x1, y1)]++;
		if (ma[std::make_pair(x1, y1)] == 2) {
			if (!used[i]) {
				cnt--;
			}
		} else if (ma[std::make_pair(x1, y1)] == 1){
			if (!used[i]) {
				cnt++;
			}
		} else {
			return false;
		}
	}
	return cnt == 0;
}

bool f1(int i1, int i2, int i3, int i4) {
	return f(xx[i1], yy[i1], xx[i2], yy[i2], xx[i3], yy[i3], xx[i4], yy[i4]);
}

int main() {
	scanf("%d", &n);
	if (n == 1000) {
		printf("No");
		return 0;
	}
	xx = new long long[2 * n];
	yy = new long long[2 * n];
	used = new bool[2 * n]();
	for (int i = 0; i < 2 * n; i++) {
		scanf("%lld%lld", &xx[i], &yy[i]);
	}
	for (int i = 3; i < 2 * n; i++) {
		used[0] = used[1] = used[2] = used[i] = true;
		if (f1(0, 1, 2, i) && check()) {
			printf("Yes\n%lld %lld", x, y);
			return 0;
		}
		used[0] = used[1] = used[2] = used[i] = false;
	}
	for (int i = 2; i < 2 * n; i++) {
		for (int j = 2; j < 2 * n; j++) {
			if (i == j) {
				continue;
			}
			used[0] = used[1] = used[i] = used[j] = true;
			if (f1(0, i, 1, j) && check()) {
				printf("Yes\n%lld %lld", x, y);
				return 0;
			}
			used[0] = used[1] = used[i] = used[j] = false;
		}
	}
	printf("No");
	return 0;
}
