#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Point {
	int x, y;
	Point(){};
	Point(int x, int y) {
		this -> x = x;
		this -> y = y;
	}
	Point(Point a, Point b) {
		this -> x = b.x - a.x;
		this -> y = b.y - a.y;
	}
	Point rot() {
		return Point(-y, x);
	}
};

bool operator ==(Point a, Point b) {
	if (a.x == b.x && a.y == b.y) {
		return true;
	}
	return false;
}

bool operator !=(Point a, Point b) {
	return !(a == b);
}

const Point NULL_POINT = Point(-62342, 82362);

int cp(Point a, Point b) {
	return a.x * b.y - a.y * b.x;
}

Point cross(Point a, Point b, Point c, Point d) {
	if (cp(Point(a, b), Point(c, d)) == 0) {
		return NULL_POINT;
	}
	Point v1 = Point(a, b);
	int a1 = v1.rot().x, b1 = v1.rot().y, c1 = -a1 * a.x - b1 * a.y;
	Point v2 = Point(c, d);
	int a2 = v2.rot().x, b2 = v2.rot().y, c2 = -a2 * c.x - b2 * c.y;
	int del = a1 * b2 - b1 * a2;
	Point rez;
	int m1 = a1 * c2 - a2 * c1;
	int m2 = c1 * b2 - b1 * c2;
	if (m1 % del != 0)
	return NULL_POINT;
	rez.x = -m1 / del;
	if (m2 % del != 0)
	return NULL_POINT;
	rez.y = -m2 / del;
	return rez;
}

void check(Point cr) {
	if (cr != NULL_POINT) {
		cout << "Yes\n";
		cout << cr.x << " " << cr.y << "\n";
		exit(0);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	if (n > 2) {
		cout << "Yes\n";
		cout << 2 << " " << 2 << "\n";
		return 0;
	}
	n *= 2;
	vector <Point> v(n);
	for (Point& p : v) {
		cin >> p.x >> p.y;
	}
	Point cr = cross(v[0], v[1], v[2], v[3]);
	/*cout << cr.x << " " << cr.y << "\n";
	return 0;*/
	check(cr);
	cr = cross(v[0], v[2], v[1], v[3]);
	check(cr);
	cr = cross(v[0], v[3], v[1], v[2]);
	check(cr);
	cout << "NO\n";
	return 0;
}