#include <bits/stdc++.h>

using namespace std;

#define int long long

struct Point {
	int x, y;
	Point(){};
	Point(int x, int y) {
		this -> x = x;
		this -> y = y;
	}
	Point(Point a, Point b) {
		this -> x = b.x - a.x;
		this -> y = b.y - a.y;
	}
	Point rot() {
		return Point(-y, x);
	}
};

bool operator ==(Point a, Point b) {
	if (a.x == b.x && a.y == b.y) {
		return true;
	}
	return false;
}

bool operator !=(Point a, Point b) {
	return !(a == b);
}

const Point NULL_POINT = Point(-62342, 82362);

vector <Point> v;

int cp(Point a, Point b) {
	return a.x * b.y - a.y * b.x;
}

Point cross(Point a, Point b, Point c, Point d) {
	if (cp(Point(a, b), Point(c, d)) == 0) {
		return NULL_POINT;
	}
	Point v1 = Point(a, b);
	int a1 = v1.rot().x, b1 = v1.rot().y, c1 = -a1 * a.x - b1 * a.y;
	Point v2 = Point(c, d);
	int a2 = v2.rot().x, b2 = v2.rot().y, c2 = -a2 * c.x - b2 * c.y;
	int del = a1 * b2 - b1 * a2;
	Point rez;
	int m1 = a1 * c2 - a2 * c1;
	int m2 = c1 * b2 - b1 * c2;
	if (del == 0) {
		return NULL_POINT;
	}
	if (m1 % del != 0)
	return NULL_POINT;
	rez.x = -m2 / del;
	if (m2 % del != 0)
	return NULL_POINT;
	rez.y = -m1 / del;
	return rez;
}

bool check(Point cr) {
	for (Point p : v) {
		if (p == cr) {
			return false;
		}
	}
	if (abs(cr.x) > 1e6 || abs(cr.y) > 1e6) {
		return false;
	}
	if (cr != NULL_POINT) {
		return true;
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	n *= 2;
	v.resize(n);
	for (Point& p : v) {
		cin >> p.x >> p.y;
	}
	vector <bool> used(n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			for (int t = 0; t < n; ++t) {
				if (t == i || t == j) {
					continue;
				}
				for (int k = t + 1; k < n; ++k) {
					if (k == i || k == j) {
						continue;
					}
					Point cr = cross(v[i], v[j], v[t], v[k]);
					if (!check(cr)) {
						continue;
					}
					used.assign(n, false);
					used[i] = true;
					used[j] = true;
					used[t] = true;
					used[k] = true;
					vector <pair <Point, Point> > ans;
					ans.push_back({v[i], v[j]});
					ans.push_back({v[t], v[k]});
					for (int m = 0; m < n; ++m) {
						if (used[m]) {
							continue;
						}
						for (int q = m + 1; q < n; ++q) {
							if (used[q]) {
								continue;
							}
							if (cross(v[i], v[j], v[m], v[q]) != cr) {
								continue;
							}
							bool err = false;
							for (auto it : ans) {
								if (cp(Point(it.first, it.second), Point(v[m], v[q])) == 0) {
									err = true;
									break;
								}
							}
							if (!err) {
								used[q] = true;
								used[m] = true;
								ans.push_back({v[q], v[m]});
								break;
							}
						}
					}
					bool f = false;
					for (bool it : used) {
						if (!it) {
							f = true;
							break;
						}
					}
					if (!f) {
						cout << "Yes\n";
						cout << cr.x << " " << cr.y << "\n";
						return 0;
					}
				}
			}
		}
	}
	cout << "No\n";
	return 0;
}