#include <bits/stdc++.h>

using namespace std;
//F 
typedef long long ll;
struct pt
{
	ll x, y;
	pt(ll x_, ll y_): x(x_), y(y_) {}
	pt() {}
	
	pt operator - (pt p)
	{
		return pt(x - p.x, y - p.y);
	}
	ll operator *(pt p)
	{
		return x * p.y - y * p.x;
	}
	
	bool operator == (pt p)
	{
		return x == p.x && y == p.y;
	}
	
};

pt moon;

bool online(pt a, pt b, pt c)
{
	if (a == b || b == c || a == c)
		return false;
	pt ab = b - a;
	ll A = -ab.y;
	ll B = ab.x;
	ll C = -A * a.x - B * a.y;
	return (c.x * A + c.y * B + C == 0);
}

bool check(pt p, vector<pt> &a)
{
	int n = (int)a.size();
	vector<int> used(n);
	for (int i = 0; i < n; i++)
	{
		if (used[i])
			continue;
		used[i] = 1;
		int cnt = 0;
		for (int j = 0; j < n; j++)
		{
			if (used[j])
				continue;
			if (online(p, a[i], a[j]))
			{
				used[j] = 1;
				cnt++;
			}
		}
		if (cnt != 1)
			return false;
	}
	return true;
}

ll det(ll a1, ll b1, ll a2, ll b2)
{
	return a1 * b2 - a2 * b1;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//freopen("in.txt", "r", stdin);
	int n;
	cin >> n;
	int m = 2 * n;
	vector<pt> a(m);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i].x >> a[i].y;
	}
	if (n == 1)
	{
		if (a[0].x == a[1].x)
		{
			cout << "Yes\n";
			cout << a[0].x << " " << 280800;
		} else
		{
			pt vec = a[1] - a[0];
			ll A = -vec.y;
			ll B = vec.x;
			ll C = -A * a[0].x - B * a[0].y;
			for (ll x = -1000000; x <= 1000000; x++)
			{
				if (x != a[0].x && x != a[1].x && (C + A * x) % B == 0)
				{
					ll y = -(C + A * x) / B;
					cout << "Yes\n";
					cout << x << " " << y;
					return 0;
				}
			}
		}
		return 0;
	}
	pt s = a[0];
	pt q = a[1];
	for (int i = 2; i < m; i++)
	{
		for (int j = 2; j < m; j++)
		{
			if (i == j)
				continue;
			pt t = a[i]; // st
			pt p = a[j]; // qp
			/*cout << "s : " << s.x << " " << s.y << endl;
			cout << "t : " << t.x << " " << t.y << endl;
			cout << "q : " << q.x << " " << q.y << endl;
			cout << "p : " << p.x << " " << p.y << endl;*/
			pt st = t - s;
			pt qp = p - q;
			ll A1 = -st.y;
			ll B1 = st.x;
			ll C1 = -A1 * s.x - B1 * s.y;
			//cout << A1 << " " << B1 << " " << C1 << endl;
			
			ll A2 = -qp.y;
			ll B2 = qp.x;
			ll C2 = -A2 * q.x - B2 * q.y;
			//cout << A2 << " " << B2 << " " << C2 << endl;
			ll d = det(A1, B1, A2, B2);
			if (d == 0)
				continue;
			ll dx = det(-C1, B1, -C2, B2);
			ll dy = det(A1, -C1, A2, -C2);
			//cout << "dx = " << dx << endl;
			//cout << "dy = " << dy << endl;
			
			if (dx % d != 0 || dy % d != 0)
				continue;
			pt res(dx / d, dy / d);
			//cout << "res: " << res.x << " " << res.y << endl;
			if (abs(res.x) > 1000000 || abs(res.y) > 1000000)
				continue;
			if (check(res, a))
			{
				cout << "Yes\n";
				cout << res.x << " " << res.y;
				return 0;
			}
			
		}
	}
	s = a[m - 1];
	q = a[0];
	for (int i = 1; i < m - 1; i++)
	{
		for (int j = 1; j < m - 1; j++)
		{
			if (i == j)
				continue;
			pt t = a[i]; // st
			pt p = a[j]; // qp
			pt st = t - s;
			pt qp = p - q;
			ll A1 = -st.y;
			ll B1 = st.x;
			ll C1 = -A1 * s.x - B1 * s.y;
			ll A2 = -qp.y;
			ll B2 = qp.x;
			ll C2 = -A2 * q.x - B2 * q.y;
			ll d = det(A1, B1, A2, B2);
			if (d == 0)
				continue;
			ll dx = det(-C1, B1, -C2, B2);
			ll dy = det(A1, -C1, A2, -C2);
			if (dx % d != 0 || dy % d != 0)
				continue;
			pt res(dx / d, dy / d);
			//cout << "res: " << res.x << " " << res.y << endl;
			if (abs(res.x) > 1000000 || abs(res.y) > 1000000)
				continue;
			if (check(res, a))
			{
				cout << "Yes\n";
				cout << res.x << " " << res.y;
				return 0;
			}
			
		}
	}
	
	cout << "No";
	return 0;
}


