#include <bits/stdc++.h>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll MX_T = 1e6;;
const ll mx = 3000;

struct point {
	ll x, y;
	point() {}
	point(ll _x, ll _y): x(_x), y(_y) {}
};

bool operator < (point a, point b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

bool operator == (point a, point b) {
	return make_pair(a.x, a.y) == make_pair(b.x, b.y);
}

bool operator != (point a, point b) {
	return make_pair(a.x, a.y) != make_pair(b.x, b.y);
}

struct line {
	ll a, b, c;
};

line make_line(point p1, point p2) {
	line res;
	res.a = p1.y - p2.y;
	res.b = p2.x - p1.x;
	res.c = p2.x * p1.y - p1.x * p2.y;
	return res;
}

point intersect(line a, line b) {
	ll a1 = a.a;
	ll a2 = b.a;
	ll b1 = a.b;
	ll b2 = b.b;
	ll c1 = a.c;
	ll c2 = b.c;
	ll p = a1 * b2 - a2 * b1;
	if (p == 0) {
		return {INF, INF};
	}
	else {
		ll x0 = c1 * b2 - b1 * c2;
		ll y0 = a1 * c2 - a2 * c1;
		if (x0 % p == 0 && y0 % p == 0) {
			return {x0 / p, y0 / p};
		}
		else {
			return {INF, INF};
		}
	}
}

int n;
vector<point> p0, p2;
set<point> s0;
vector<line> l1;

int main() {
	cin >> n;
	ll kek = (n) * (n - 1) / 2;
	n *= 2;
	p0.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> p0[i].x >> p0[i].y;
		s0.insert(p0[i]);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			l1.push_back(make_line(p0[i], p0[j]));
		}
	}
	int lc = l1.size();
	for (int i = 0; i < lc; ++i) {
		for (int j = i + 1; j < lc; ++j) {
			point s = intersect(l1[i], l1[j]);
			if (s != point(INF, INF) && s0.find(s) == s0.end()) {
				p2.push_back(s);
			}
		}
	}
	sort(p2.begin(), p2.end());
	/*cout << "p2" << endl;
	for (int i = 0; i < p2.size(); ++i) {
		cout << p2[i].x << " " << p2[i].y << endl;
	}*/
	int cnt = 1;
	point ans = {INF, INF};
	if (p2.empty()) {
		cout << "No" << endl;
		return 0;
	}
	//cout << "kek = " << kek << endl;
	for (int i = 1; i < p2.size(); ++i) {
		if (p2[i] == p2[i - 1]) {
			cnt++;
		}
		else {
			if (cnt >= kek) {
				ans = p2[i - 1];
				break;
			}
			else {
				cnt = 1;
			}
		}
	}
	if (cnt >= kek && ans == point(INF, INF)) {
		ans = p2.back();
	}
	if (ans == point(INF, INF)) {
		cout << "No" << endl;
	}
	else {
		cout << "Yes" << endl;
		cout << ans.x << " " << ans.y << endl;
	}
}