#include <bits/stdc++.h>
#define ll long long
#define null NULL

using namespace std;

const ll MOD = 1e9 + 7;
const ll INF = 1e18;
const ll MX_T = 1e6;;
const ll mx = 3000;

struct point {
	ll x, y;
	point() {}
	point(ll _x, ll _y): x(_x), y(_y) {}
};

bool operator < (point a, point b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}

bool operator == (point a, point b) {
	return make_pair(a.x, a.y) == make_pair(b.x, b.y);
}

bool operator != (point a, point b) {
	return make_pair(a.x, a.y) != make_pair(b.x, b.y);
}

struct line {
	ll a, b, c;
};

ll calc(ll x1, ll y1, ll x2, ll y2) {
	if (y1 < 0) {
		x1 = -x1;
		y1 = -y1;
	}
	if (y2 < 0) {
		x2 = -x2;
		y2 = -y2;
	}
	ll p = x1 * y2 - x2 * y1;
	if (p < 0)
		return -1;
	if (p == 0)
		return 0;
	return 1;
}

bool operator < (line a, line b) {
	//cout << "calculating" << endl;
	ll a1 = a.a;
	ll a2 = b.a;
	ll b1 = a.b;
	ll b2 = b.b;
	ll c1 = a.c;
	ll c2 = b.c;
	ll p1 = calc(a1, b1, a2, b2);
	ll p2 = calc(b1, c1, b2, c2);
	ll p3 = calc(a1, c1, a2, c2);
	//cout << a1 << " " << b1 << " " << c1 << endl;
	//cout << a2 << " " << b2 << " " << c2 << endl;
	//cout << p1 << " " << p2 << endl;
	return make_pair(p1, make_pair(p2, p3)) < make_pair(0LL, make_pair(0LL, 0LL));
}

bool operator == (line a, line b) {
	return (!(a < b)) && (!(b < a));
}

line make_line(point p1, point p2) {
	line res;
	res.a = p1.y - p2.y;
	res.b = p2.x - p1.x;
	res.c = p2.x * p1.y - p1.x * p2.y;
	return res;
}

point intersect(line a, line b) {
	ll a1 = a.a;
	ll a2 = b.a;
	ll b1 = a.b;
	ll b2 = b.b;
	ll c1 = a.c;
	ll c2 = b.c;
	ll p = a1 * b2 - a2 * b1;
	if (p == 0) {
		return {INF, INF};
	}
	else {
		ll x0 = c1 * b2 - b1 * c2;
		ll y0 = a1 * c2 - a2 * c1;
		if (x0 % p == 0 && y0 % p == 0) {
			return {x0 / p, y0 / p};
		}
		else {
			return {INF, INF};
		}
	}
}

int n;
vector<point> p0, p2;
set<point> s0;
vector<line> l1;

int main() {
	cin >> n;
	ll kek = (n) * (n - 1) / 2;
	n *= 2;
	p0.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> p0[i].x >> p0[i].y;
		s0.insert(p0[i]);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			l1.push_back(make_line(p0[i], p0[j]));
			//cout << "line between " << i << " " << j << endl;
			//cout << "abc = " << l1.back().a << " " << l1.back().b << " " << l1.back().c << endl;
		}
	}
	sort(l1.begin(), l1.end());
	/*cout << "lines" << endl;
	for (int i = 0; i < l1.size(); ++i) {
		cout << l1[i].a << " " << l1[i].b << " " << l1[i].c << endl;
	}*/
	l1.erase(unique(l1.begin(), l1.end()), l1.end());
	/*cout << "lines" << endl;
	for (int i = 0; i < l1.size(); ++i) {
		cout << l1[i].a << " " << l1[i].b << " " << l1[i].c << endl;
	}*/
	int lc = l1.size();
	for (int i = 0; i < lc; ++i) {
		for (int j = i + 1; j < lc; ++j) {
			point s = intersect(l1[i], l1[j]);
			if (s != point(INF, INF) && s0.find(s) == s0.end() && abs(s.x) <= MX_T && abs(s.y) <= MX_T) {
				//cout << "adding intersection" << endl;
				//cout << i << " " << j << endl;
				p2.push_back(s);
			}
		}
	}
	sort(p2.begin(), p2.end());
	/*cout << "p2" << endl;
	for (int i = 0; i < p2.size(); ++i) {
		cout << p2[i].x << " " << p2[i].y << endl;
	}*/
	int cnt = 1, kekos = 0;
	point ans = {INF, INF};
	if (p2.empty()) {
		cout << "No" << endl;
		return 0;
	}
	//cout << "kek = " << kek << endl;
	for (int i = 1; i < p2.size(); ++i) {
		if (p2[i] == p2[i - 1]) {
			cnt++;
		}
		else {
			if (cnt >= kek) {
				ans = p2[i - 1];
				//cout << "what" << endl;
				//cout << "i = " << i << endl;
				kekos++;
			}
			cnt = 1;
		}
	}
	if (kekos >= 2 && n >= 5) {
		cout << 5 / 0 << endl;
	}
	if (cnt >= kek && ans == point(INF, INF)) {
		ans = p2.back();
	}
	if (ans == point(INF, INF)) {
		cout << "No" << endl;
	}
	else {
		cout << "Yes" << endl;
		cout << ans.x << " " << ans.y << endl;
	}
}