import java.io.*;
import java.lang.reflect.Array;
import java.util.*;

public class Main {
    long gcd(long a, long b) {
        if (b == 0) return a;
        return gcd(b, a % b);
    }

    public class point {
        long x, y;

        point(long a, long b) {
            x = a;
            y = b;
        }
    }

    public class line {
        long a, b, c;

        line(point c1, point c2) {
            a = c2.y - c1.y;
            b = c1.x - c2.x;
            c = -c2.y * c1.x + c1.y * c2.x;
            long z = gcd(Math.abs(a), Math.abs(b));
            z = gcd(z, Math.abs(c));
            if (z != 0) {
                a /= z;
                b /= z;
                c /= z;
            }
        }
    }
    point pp = new point((long)1e7,(long)1e7);
    point pers(line a, line b) {
        if (a.a * b.b == b.a * a.b) {
            return pp;
        } else {
            long p1 = -a.c * b.a + b.c * a.a;
            long p2 = a.b * b.a - b.b * a.a;
            if (p1 % p2 != 0) {
            return pp;
            }
            long y = p1 / p2;
            p1 = b.c * a.b - a.c * b.b;
            p2 = -p2;
            if (p1 % p2 != 0) {
                return pp;
            }
            return new point(p1 / p2, y);
        }
    }

    boolean sc(point a, point b, point c) {
        point x1 = new point(a.x - b.x, a.y - b.y);
        point x2 = new point(a.x - c.x, a.y - c.y);
        if (x1.x * x2.y == x2.x * x1.y) {
            return true;
        }
        return false;
    }

    public void solve() throws IOException {
        int n = nextInt();
        point[] a = new point[2 * n];
        for (int i = 0; i < 2 * n; i++) {
            a[i] = new point(nextInt(), nextInt());
        }
        Random kk = new Random();
        int h = Math.abs(kk.nextInt()) % 2 * n;
        for (int i = 0; i < 2 * n; i++) {
            for (int j = 0; j < 2 * n; j++) {
                for (int k = 0; k < 2 * n; k++) {
                    if (h == i || h == j || h == k || i == j || i == k || j == k) continue;
                    line z1 = new line(a[h], a[i]);
                    line z2 = new line(a[j], a[k]);
                    point c = pers(z1, z2);
                    if (Math.abs(c.x) <= (long) 1000000 && Math.abs(c.y) <= (long) 1000000) {
                        boolean t = true;
                        for (int l = 0; l < 2 * n; l++) {
                            int m = -1;
                            if (c.x == a[l].x && c.y == a[l].y) {
                                t = false;
                            }
                            for (int o = 0; o < 2 * n; o++) {
                                if (sc(c, a[l], a[o])) {
                                    m++;
                                }
                            }
                            if (m != 1) {
                                t = false;
                            }
                        }
                        if (t) {
                            out.println("Yes");
                            out.println(c.x + " " + c.y);
                            return;
                        }
                    }
                }
            }
        }
        out.println("No");
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
