#include <bits/stdc++.h>

using namespace std;

struct point{
    double x, y;
    point () {}
    point(double x, double y) : x(x), y(y) {};
};

bool operator < (point a, point b){
    return a.x < b.x || a.x == b.x && a.y < b.y;
}

struct line{
    double a, b, c;
    line () {}
    line(double a, double b, double c) : a(a), b(b), c(c) {}
};

line make_line(point a, point b){
    double A = b.y - a.y;
    double B = a.x - b.x;
    double C = -A * a.x - B * a.y;

    return line(A, B, C);
}

pair<bool, point> intersect(line a, line b){
    if (a.a * b.b - b.a * a.b == 0 || a.a * b.b - b.a * a.b == 0)
        return {0, {-1, -1}};

    double x = -(a.c * b.b - b.c * a.b) / (a.a * b.b - b.a * a.b);
    double y = -(a.a * b.c - b.a * a.c) / (a.a * b.b - b.a * a.b);

    return {1, {x, y}};
}

int n;
vector<point> pts;

void check(){
    line pr;
    point now;
    for (int i = 0; i < 2 * n; i += 2){
        line a = make_line(pts[i], pts[i + 1]);
        if (i != 0){
            auto tmp = intersect(a, pr);
            if (floor(tmp.second.x) != tmp.second.x || floor(tmp.second.y) != tmp.second.y)
                return;

            if (!tmp.first)
                return;
            if (i > 2 && (now.x != tmp.second.x || now.y != tmp.second.y)){
                return;
            }
            now = tmp.second;
        }

        pr = a;
    }

    for (int i = 0; i < 2 * n; ++i)
        if (now.x == pts[i].x && now.y == pts[i].y)
            return;

    cout << "Yes\n";
    cout << fixed << setprecision(0);
    cout << now.x << ' ' << now.y << '\n';
    exit(0);
}

int main()
{
    cin >> n;
    for (int i = 0; i < 2 * n; ++i){
        int x, y;
        cin >> x >> y;
        pts.push_back({x, y});
    }
    sort(pts.begin(), pts.end());

    check();
    while (next_permutation(pts.begin(), pts.end())){
        check();
    }

    cout << "No\n";
    return 0;
}
