#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>

using namespace std;

typedef long long LL;
typedef long long dbl;

inline dbl gcd(dbl x, dbl y) {
  if (x == 0) return y;
  if (y == 0) return x;
  while (y != 0) {
    x %= y;
    swap(x, y);
  }
  return x;
}

struct Point {
  dbl x, y;

  inline void normalize() {
    dbl g = gcd(x, y);
    x /= g;
    y /= g;

    if (x < 0) {
      x *= -1;
      y *= -1;
    }
  }

  inline Point operator*(const dbl d) const {
    return Point { x*d, y*d };
  }

  inline Point operator+(const Point &p) const {
    return Point{ x + p.x, y + p.y };
  }
  inline bool operator==(const Point &p) const {
    return x == p.x && y == p.y;
  }
};

struct Line {
  dbl a, b, c;
  Line(Point p, Point q) {
    a = q.y - p.y;
    b = p.x - q.x;
    c = -(a * p.x + b * p.y);
  }

  inline dbl operator()(const Point &p) const {
    return a * p.x + b * p.y + c;
  }
};

const dbl BOUND = 1000000;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n;
  cin >> n;

  n *= 2;

  vector<Point> ps(n);

  for (int i = 0; i < n; ++i) {
    cin >> ps[i].x >> ps[i].y;
  }

  srand((int)'P' + 'L' + 'E' + 'A' + 'S' + 'E');
  random_shuffle(ps.begin(), ps.end());

  int F = 0;

  vector<vector<int>> incompl(3);

  for (int F = 0; F < min(3, n); ++F) {
    for (int S = 0; S < n; ++S) {
      if (S == F) continue;
      Point fs{ ps[S].x - ps[F].x, ps[S].y - ps[F].y };
      fs.normalize();

      bool kok = 1;

      for (int kek = 0; kek < n; ++kek) {
        if (kek == S || kek == F) continue;
        Point fkek{ ps[kek].x - ps[F].x, ps[kek].y - ps[F].y };
        fkek.normalize();
        if (fkek == fs) {
          kok = 0;
          break;
        }
      }

      if (!kok) continue;
      incompl[F].push_back(S);
    }
  }

  unordered_map<long long, int> cnt;
  
  for (int S : incompl[F]) {
    Point fs{ ps[S].x - ps[F].x, ps[S].y - ps[F].y };
    fs.normalize();
    
    if (n == 2) {
      for (int d = -2; d < 4; ++d) {
        Point t = ps[F];
        t = t + fs * d;
        if (t == ps[F] || t == ps[S] || abs(t.x) > BOUND || abs(t.y) > BOUND) continue;
        cout << "YES" << '\n' << t.x << ' ' << t.y << endl;
        return 0;
      }
      return 0;
    }

    Line L(ps[F], ps[S]);

    int T = S == 1 ? 2 : 1;
    for (int P : incompl[T]) {
      if (P == T || P == S) continue;

      Point tp{ ps[P].x - ps[T].x, ps[P].y - ps[T].y };
      tp.normalize();

      Point M = ps[T] + tp;

      dbl C = L(ps[T]);
      if (C == 0) continue;

      dbl CM = L(M);

      dbl dC = CM - C;

      if (dC == 0 || C % dC != 0) continue;

      dbl D = -C / dC;

      M = ps[T] + tp * D;

      bool ok = abs(M.x) <= BOUND && abs(M.y) <= BOUND;

      if (!ok) continue;

      for (auto p : ps)
        if (p == M) {
          ok = false;
          break;
        }

      if (!ok) continue;

      cnt.clear();
      for (auto p : ps) {
        Point v{ p.x - M.x, p.y - M.y };
        v.normalize();
        cnt[v.x * 10000000ll + v.y]++;
      }

      if (cnt.size() != n / 2) continue;

      for (auto p : cnt)
        if (p.second != 2) {
          ok = false;
          break;
        }

      if (ok) {
        cout << "Yes" << '\n' << M.x << ' ' << M.y << '\n';
        return 0;
      }

    }
  }

  cout << "No" << '\n';

  return 0;
}