#include <iostream>
#include <vector>
#include <bitset>
#include <cassert>
#include <algorithm>
#include <set>
#include <climits>

using namespace std;
typedef unsigned int index;

pair<long long, multiset<int>*> dfs(index v, const vector<vector<index>> &g, const vector<int> &a, long long &ans)
{
    vector<pair<long long, multiset<int>*>> cur;
    for (auto i: g[v])
        cur.push_back(dfs(i, g, a, ans));
    if (cur.size() == 0)
    {
        auto x = new multiset<int>;
        x->insert(a[v]);
        return {a[v], x};
    }
    sort(cur.begin(), cur.end(), [](const pair<long long, multiset<int>*> &a, const pair<long long, multiset<int>*> &b)
    {
       return a.second->size() > b.second->size();
    });
    size_t sz_sum = 0;
    int minl = INT_MAX;
    long long all_sum = 0;
    for (index i = 1; i < cur.size(); i++)
    {
        sz_sum += cur[i].second->size();
        minl = min(*cur[i].second->begin(), minl);
        all_sum += cur[i].first;
    }
    if (cur[0].second->size() > sz_sum)
    {
        ans += all_sum + cur[0].first + minl * (long long)(cur[0].second->size() - sz_sum);
    }
    else
    {
        if ((cur[0].second->size() + sz_sum) % 2 == 0)
        {
            ans += all_sum + cur[0].first;
        }
        else
        {
            ans += all_sum + cur[0].first + min(minl, *cur[0].second->begin());
        }
    }
    for (index i = 1; i < cur.size(); i++)
    {
        for (auto j: (*cur[i].second))
        {
            cur[0].second->insert(j);
        }
    }
    cur[0].first += all_sum;
    cur[0].first += a[v];
    cur[0].second->insert(a[v]);
    return cur[0];
}

int main()
{
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.in", "r", stdin));
    //assert(freopen("C:\\Users\\olymp\\Olymp\\a.out", "w", stdout));
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    size_t n;
    cin >> n;
    vector<vector<index>> g(n);
    for (index i = 1; i < n; i++)
    {
        index x;
        cin >> x;
        x--;
        g[x].push_back(i);
    }
    vector<int> a(n);
    for (index i = 1; i < n; i++)
        cin >> a[i];
    long long ans = 0;
    dfs(0, g, a, ans);
    cout << ans << endl;
}
