#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>
#include <queue>
#include <string>
#include <random>
#include <chrono>

using namespace std;

mt19937 twister(chrono::steady_clock().now().time_since_epoch().count());

const int maxn = 5e6 + 88;
const int inf = 1e9 + 88;

string s;
vector<int> v;
int cnt[26], curcnt[26], used[26], c[26];
long long pref[maxn];
int n;

bool check(int d)
{
    long long curhash = pref[d - 1];
    for (int i = d + d - 1; i < n; i += d)
        if (pref[i] - pref[i - d] != curhash)
            return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ifstream cin("input.txt");
    ofstream cout("output.txt");
    int i, j;
    cin >> s;
    n = s.length();
    for (i = 0; i < n; i++)
        used[s[i] - 'a'] = 1;
    for (i = 1; i < 26; i++)
        used[i] += used[i - 1];
    for (i = 0; i < used[25]; i++)
        c[i] = twister();
    for (i = 0; i < n; i++)
        s[i] = 'a' + used[s[i] - 'a'] - 1;
    for (i = 1; i*i <= n; i++)
        if (n%i == 0)
        {
            v.push_back(i);
            if (i*i != n)
                v.push_back(n/i);
        }
    for (i = 0; i < n; i++)
        cnt[s[i] - 'a']++;
    for (i = 0; i < v.size(); i++)
        for (j = 0; j < used[25]; j++)
            if (cnt[j]%(n/v[i]) != 0)
            {
                swap(v[i], v[v.size() - 1]);
                v.pop_back();
                i--;
                break;
            }
    pref[0] = c[s[0] - 'a'];
    for (i = 0; i < n; i++)
        pref[i] = pref[i - 1] + c[s[i] - 'a'];
    sort(v.begin(), v.end());
    for (i = 0; i < v.size(); i++)
        if (check(v[i]))
        {
            cout << n/v[i];
            return 0;
        }
    return 0;
}
