//
// Created by olymp on 09.03.2018.
//
#include <iostream>
#include <string>
#include <vector>

const int SIZE = 'z' - 'a' + 1;

struct Sum{
    int cnt[SIZE];
    Sum() {
        for (int i = 0; i < SIZE; ++i) {
            cnt[i] = 0;
        }
    }
    Sum operator-(const Sum &other) {
        Sum ans;
        for (int i = 0; i < SIZE; ++i) {
            ans.cnt[i] = cnt[i] - other.cnt[i];
        }
        return ans;
    }
    Sum operator+(const Sum &other) {
        Sum ans;
        for (int i = 0; i < SIZE; ++i) {
            ans.cnt[i] = cnt[i] + other.cnt[i];
        }
        return ans;
    }
    bool operator==(const Sum &other) {
        for (int i = 0; i < SIZE; ++i) {
            if (cnt[i] != other.cnt[i]) {
                return false;
            }
        }
        return true;
    }
};

std::string s;
std::vector<Sum> pref;
int GCD(int a, int b) {
    return (b ? GCD(b, a % b) : a);
}

int ch[SIZE];

bool check(int len) {
    Sum val = pref[len] - pref[0];
    for (int i = 2 * len; i <= s.size(); i += len) {
        if (!(pref[i] - pref[i - len] == val)) {
            return false;
        }
    }
    return true;
}

int main() {
    std::cin >> s;
    pref.resize(s.size() + 1);
    for (int i = 0; i < s.size(); ++i) {
        ch[s[i] - 'a'] += 1;
        pref[i + 1].cnt[s[i] - 'a'] += 1;
        pref[i + 1] = pref[i] + pref[i + 1];
    }
    int gcd = 0;
    for (int i = 0; i < SIZE; ++i) {
        gcd = GCD(gcd, ch[i]);
    }
    for (int i = 1; i <= s.size(); ++i) {
        if (s.size() % i == 0) {
            if (check(i)) {
                std::cout << s.size() / i;
                return 0;
            }
        }
    }
    return 0;
}
