#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>

using namespace std;
const int max_num = 1000000000;

void make_sz(vector <vector <int> > &graph, vector <int> &sz, vector <long long> &costs, vector <int> &perf, int u) {
    int w, maximum, tmp, max_id;
    sz[u] = 1;
    costs[u] = perf[u];
    maximum = -1;
    max_id = -1;
    for (int i = 0; i < int(graph[u].size()); i++) {
        w = graph[u][i];
        make_sz(graph, sz, costs, perf, w);
        sz[u] += sz[w];
        costs[u] += costs[w];
        if (sz[w] > maximum) {
            maximum = sz[w];
            max_id = i;
        }
    }
    if (max_id != -1) {
        tmp = graph[u][max_id];
        graph[u][max_id] = graph[u][0];
        graph[u][0] = tmp;
    }
}

void make_euler(vector <vector <int> > &graph, vector <int> &euler, vector <long long> &minimums, vector <long long> &real_minimums, vector <int> &perf, vector <long long> &costs, vector <int> &sz, vector <bool> &heavy, int u) {
    int w;
    euler.push_back(u);
    costs[u] -= perf[u];
    sz[u]--;
    real_minimums[u] = perf[u];
    minimums[u] = max_num;
    for (int i = 0; i < int(graph[u].size()); i++) {
        w = graph[u][i];
        if (sz[w] * 2 > sz[u]) {
            heavy[w] = true;
        }
        make_euler(graph, euler, minimums, real_minimums, perf, costs, sz, heavy, w);
        real_minimums[u] = min(real_minimums[u], real_minimums[w]);
        if (!heavy[w]) {
            minimums[u] = min(minimums[u], real_minimums[w]);
        }
    }
}

int main() {
    ifstream fin("input.txt");
    int n, p;
    long long res, rest;
    fin >> n;
    vector <vector <int> > graph(n);
    for (int i = 1; i < n; i++) {
        fin >> p;
        p--;
        graph[p].push_back(i);
    }
    vector <int> perf(n);
    perf[0] = 0;
    for (int i = 1; i < n; i++) {
        fin >> perf[i];
    }
    vector <int> sz(n);
    vector <bool> heavy(n, false);
    vector <long long> costs(n);
    vector <long long> minimums(n);
    vector <long long> real_minimums(n);
    vector <int> euler;
    euler.reserve(n);
    make_sz(graph, sz, costs, perf, 0);
    make_euler(graph, euler, minimums, real_minimums, perf, costs, sz, heavy, 0);
/*
    cout << "graph:\n";
    for (int i = 0; i < n; i++) {
        cout << i << ": ";
        for (int j = 0; j < int(graph[i].size()); j++) {
            cout << graph[i][j] << ' ';
        }
        cout << '\n';
    }
    cout << '\n';
*/
    res = 0;
    for (int i = 0; i < n; i++) {
        if (graph[i].size() != 0) {
            res += costs[i];
            if (heavy[graph[i][0]]) {
                rest = (sz[graph[i][0]] + 1) * 2 - sz[i];
                res += rest * minimums[i];
            }
            else if (sz[i] % 2 == 1) {
                res += min(minimums[i], real_minimums[graph[i][0]]);
            }
        }
    }
    cout << res << '\n';
    return 0;
}
