#include <iostream>
#include <vector>
#include <fstream>
#include <algorithm>
#include <set>
#include <random>

using namespace std;
const long long max_coor = 1000000;

struct point{
    long long x, y;
};

//point sort_point;

bool operator < (point p1, point p2) {
    if (p1.x < p2.x) {
        return true;
    }
    if (p1.x == p2.x && p1.y < p2.y) {
        return true;
    }
    return false;
}

long long cross_prod(point p1, point p2) {
    return p1.x * p2.y - p1.y * p2.x;
}

point operator - (point p1, point p2) {
    point res;
    res.x = p1.x - p2.x;
    res.y = p1.y - p2.y;
    return res;
}

bool operator != (point p1, point p2) {
    if (p1.x == p2.x && p1.y == p2.y) {
        return false;
    }
    return true;
}

bool operator == (point p1, point p2) {
    if (p1.x == p2.x && p1.y == p2.y) {
        return true;
    }
    return false;
}

bool cmp(point p1, point p2) {
    return cross_prod(p1, p2) < 0;
}

pair <point, bool> cross(point p1, point p2, point p3, point p4) {
    point res;
    bool flag;
    flag = true;
    if (cross_prod(p2 - p1, p3 - p4) == 0) {
        res.x = 0;
        res.y = 0;
        flag = false;
    }
    else {
        if ((cross_prod(p3, p4) * (p2.x - p1.x) - cross_prod(p1, p2) * (p4.x - p3.x)) % cross_prod(p3 - p4, p2 - p1)) {
            flag = false;
        }
        res.x = (cross_prod(p3, p4) * (p2.x - p1.x) - cross_prod(p1, p2) * (p4.x - p3.x)) / cross_prod(p3 - p4, p2 - p1);
        if ((cross_prod(p4, p3) * (p2.y - p1.y) - cross_prod(p2, p1) * (p4.y - p3.y)) % cross_prod(p2 - p1, p3 - p4)) {
            flag = false;
        }
        res.y = (cross_prod(p4, p3) * (p2.y - p1.y) - cross_prod(p2, p1) * (p4.y - p3.y)) / cross_prod(p2 - p1, p3 - p4);
    }
    if (abs(res.x) > max_coor || abs(res.y) > max_coor) {
        res.x = 0;
        res.y = 0;
        flag = false;
    }
    return make_pair(res, flag);
}

bool check(vector <point> &v, point p, int len) {
    for (int i = 0; i < len; i++) {
        if (v[i] == p) {
            return false;
        }
    }
    return true;
}

bool my_try(vector <point> v, point p, int n, int len) {
    if (!check(v, p, len)) {
        return false;
    }
    for (int i = 0; i < len; i++) {
        v[i] = v[i] - p;
        if (v[i].y < 0 || (v[i].y == 0 && v[i].x < 0)) {
            v[i].x = -v[i].x;
            v[i].y = -v[i].y;
        }
    }
    //sort_point = p;
    sort(v.begin(), v.end(), cmp);
    for (int i = 0; i < n; i++) {
        if (cross_prod(v[i * 2], v[i * 2 + 1]) != 0) {
            return false;
        }
    }
    for (int i = 0; i < n - 1; i++) {
        if (cross_prod(v[i * 2 + 1], v[i * 2 + 2]) == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    ifstream fin("input.txt");
    int n, len;
    pair <point, bool> p;
    fin >> n;
    len = n * 2;
    vector <point> v(len);
    for (int i = 0; i < len; i++) {
        fin >> v[i].x >> v[i].y;
    }
    //random_shuffle(v.begin(), v.end());
    set <point> s;
    point tmp;

    for (int i = 3; i < len; i++) {
        p = cross(v[0], v[1], v[2], v[i]);
        if (p.second) {
            s.insert(p.first);
        }
    }
    for (int i = 2; i < len; i++) {
        for (int j = 2; j < len; j++) {
                p = cross(v[0], v[i], v[1], v[j]);
            if (i != j) {
                if (p.second) {
                    s.insert(p.first);
                }
            }
        }
    }

    tmp = v[0];
    v[0] = v[2];
    v[2] = tmp;
    tmp = v[1];
    v[1] = v[3];
    v[3] = tmp;
    for (int i = 3; i < len; i++) {
        p = cross(v[0], v[1], v[2], v[i]);
        if (p.second && (s.find(p.first) != s.end()) && my_try(v, p.first, n, len)) {
            cout << "Yes\n";
            cout << p.first.x << ' ' << p.first.y << '\n';
            return 0;
        }
    }
    for (int i = 2; i < len; i++) {
        for (int j = 2; j < len; j++) {
            if (i != j) {
                p = cross(v[0], v[i], v[1], v[j]);
                if (p.second && (s.find(p.first) != s.end()) && my_try(v, p.first, n, len)) {
                    cout << "Yes\n";
                    cout << p.first.x << ' ' << p.first.y << '\n';
                    return 0;
                }
            }
        }
    }
    cout << "No\n";
    return 0;
}
