#include <bits/stdc++.h>

using namespace std;

//#define int int64_t

template<typename _T>
inline void _DBG(const char *s, _T x);

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a);

#ifdef LOCAL
#define DBG(...) _DBG(#__VA_ARGS__, __VA_ARGS__)
#else
#define endl "\n"
#define DBG(...) (true)
#define cerr if(0) cout
#endif

template<typename type>
istream &operator>>(istream &in, vector<type> &a);

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a);

ostream &operator<<(ostream &out, const vector<int> &a);

ostream &operator<<(ostream &out, const vector<double> &a);

ostream &operator<<(ostream &out, const vector<bool> &a);

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a);

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a);

template<typename T, typename... args>
T max(const T &, args...);

template<typename T>
T max(const T &, const T &, const T &);

template<typename T>
T pow2(const T &);

template<typename T>
T Power(const T &, int, const T &);


// ********************** CODE ********************** //

const int MAXN = 5000000 + 10;

int cnt[MAXN];
int Div[40];
bool possible[40];

void initCnt(const string &s, char currc) {
    cnt[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        cnt[i + 1] = cnt[i] + (s[i] == currc);
    }
}

int getCnt(int l, int r) {
    return cnt[r] - cnt[l];
}

bool check(const string &s, int k) {
    int x = getCnt(0, k);
    for (int i = k; i < (int) s.size(); i += k) {
        if (x != getCnt(i, i + k)) {
            return false;
        }
    }
    return true;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    for (int i = 0; i < 40; ++i) {
        possible[i] = true;
    }
    string s;
    cin >> s;
    int n = s.size();
    int divk = 0;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            Div[divk++] = i;
            Div[divk++] = n / i;
        }
    }
    sort(Div, Div + divk);
    for (int i = 0; i < 26; ++i) {
        initCnt(s, 'a' + i);
        for (int j = 0; j < divk; ++j) {
            if (!check(s, Div[j])) {
                possible[j] = false;
            }
        }
    }
    int ind = 0;
    while (possible[ind] == 0) {
        assert(ind < divk);
        ++ind;
    }
    cout << n / Div[ind] << endl;
    return 0;
}


// ********************* END OF CODE ********************* //


template<typename T>
T Power(const T &a, int n, const T &mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2) {
        return (a * Power(a, n - 1, mod)) % mod;
    }
    T res = Power(a, n / 2, mod);
    return (res * res) % mod;
}

template<typename T>
T pow2(const T &a) {
    return a * a;
}

template<typename _T>
inline void _DBG(const char *s, _T x) {
    cerr << s << " = " << x << "\n";
}

template<typename _T, typename... args>
void _DBG(const char *s, _T x, args... a) {
    int b = 0;
    while (*s != ',' || b != 0) {
        b += (*s) == '(';
        b -= (*s) == ')';
        cerr << *s++;
    }
    cerr << " = " << x << ',';
    _DBG(s + 1, a...);
}

template<typename T>
T max(const T &a) {
    return a;
}


template<typename T>
T max(const T &a, const T &b, const T &c) {
    return max(max(a, b), c);
}


template<typename T, typename... args>
T max(const T &a, args... b) {
    T res = ::max(b...);
    return a > res ? a : res;
}

ostream &operator<<(ostream &out, const vector<bool> &a) {
    for (auto x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type1, typename type2>
istream &operator>>(istream &in, pair<type1, type2> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename type1, typename type2>
ostream &operator<<(ostream &out, const pair<type1, type2> &a) {
    out << a.first << " " << a.second;
    return out;
}

ostream &operator<<(ostream &out, const vector<double> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

ostream &operator<<(ostream &out, const vector<int> &a) {
    for (auto &x : a) {
        out << x << " ";
    }
    return out;
}

template<typename type>
ostream &operator<<(ostream &out, const vector<type> &a) {
    for (auto &x : a) {
        out << x << endl;
    }
    return out;
}

template<typename type>
istream &operator>>(istream &in, vector<type> &a) {
    for (auto &x : a) {
        in >> x;
    }
    return in;
}

