#include <bits/stdc++.h>

using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

typedef long long ll;

#define mp make_pair
#define pob pop_back
#define pub push_back
#define S second
#define F first
#define PI acos(-1)

const int N = 1000000;
const int MAXN = 1e9 + 7;
const ll L = 1e12;
const ll MAXL = 1e18 + 9;
const double eps = 1e-12;

int n;

struct Point{
    ll x = 0, y = 0;
    bool integer = true;
    Point() = default;
    Point(ll a, ll b) {
        x = a;
        y = b;
        integer = true;
    }
};

vector<Point> v;
Point o(0, 0);

struct line{
    ll A = 0, B = 0, C = 0;
    line() = default;
    line(Point a, Point b) {
        A = a.y - b.y;
        B = b.x - a.x;
        C = a.x * b.y - a.y * b.x;
        if (A < 0 || (A == 0 && B < 0) || (A == 0 && B == 0 && C < 0)) {
            A = -A;
            B = -B;
            C = -C;
        }
        ll div = __gcd(abs(A), __gcd(abs(B), abs(C)));
        A /= div;
        B /= div;
        C /= div;
    }
};

Point line_cross(line a, line b) {
    Point ans;
    if (b.A == 0) {
        swap(b, a);
    }
    ans.integer = false;
    if (a.A == b.A && a.B == b.B) {
        return ans;
    }
    if ((a.A == 0 && b.A == 0) || (a.B == 0 && b.B == 0)) {
        return ans;
    }
    if (a.A == 0) {
        if ((-a.C) % a.B) {
            return ans;
        }
        ans.y = (-a.C) / a.B;
        if ((-b.C - b.B * ans.y) % b.A) {
            return ans;
        }
        ans.x = (-b.C - b.B * ans.y) / b.A;
        ans.integer = true;
        return ans;
    }
    ll up = (b.C * a.A - a.C * b.A);
    ll down = (a.B * b.A - b.B * a.A);
    if (up % down) {
        return ans;
    }
    ans.y = up / down;
    up = (-a.C - a.B * ans.y);
    down = a.A;
    if (up % down) {
        return ans;
    }
    ans.x = up / down;
    ans.integer = true;
    return ans;
}

bool solve() {
    Point a = v[0], b = v[1];
    line line_a, line_b, line_c;
    wstring wstr;
    unordered_map<wstring, int> m;
    for (int i = 2; i < 2 * n; ++i) {
        if (clock() / CLOCKS_PER_SEC >= 4.15) return false;
        for (int j = 2; j < 2 * n; ++j) {
            if (i == j) continue;
            line_a = line(a, v[i]);
            line_b = line(b, v[j]);
            o = line_cross(line_a, line_b);
            if (!o.integer) {
                continue;
            }
            if (abs(o.x) > N || abs(o.y) > N) continue;
            m.clear();
            bool ok  = true;
            for (int k = 0; k < 2 * n; ++k) {
                if (o.x == v[k].x && o.y == v[k].y) {
                    ok = false;
                    break;
                }
                line_c = line(o, v[k]);
                wstr.clear();
                wstr += line_c.A;
                wstr += line_c.B;
                wstr += line_c.C;
                ++m[wstr];
            }
            if (!ok) {
                continue;
            }
            for (auto k : m) {
                if (k.second != 2) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(nullptr));
    cin >> n;
    v.resize(2 * n);
    ll x, y;
    for (int i = 0; i < 2 * n; ++i) {
        cin >> x >> y;
        v[i] = Point(x, y);
    }
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    random_shuffle(v.begin(), v.end());
    if (solve()) {
        cout << "Yes\n" << o.x << " " << o.y;
        return 0;
    }
    if (clock() / CLOCKS_PER_SEC >= 4.999) {
        cout << "No";
        return 0;
    }
    swap(v[1], v[2]);
    if (solve()) {
        cout << "Yes\n" << o.x << " " << o.y;
        return 0;
    }
    cout << "No";
    return 0;
}
/*
*/
