#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll SZ = 2e5 + 10;

ll n;
ll p[SZ];
ll c[SZ];
vector<ll> graph[SZ];

ll min_son[SZ];
ll size_of[SZ];
ll sum[SZ];

ll dfs(ll v)
{
    ll res = 0;
    ll max_son = 0;
    size_of[v] = 1;
    min_son[v] = c[v];
    for (auto to : graph[v]) {
        res += dfs(to);
        min_son[v] = min(min_son[v], min_son[to]);
        size_of[v] += size_of[to];
        sum[v] += sum[to];
        if (max_son == 0 || size_of[to] > size_of[max_son])
            max_son = to;
    }
    res += sum[v];
    if (size_of[max_son] > size_of[v] - 1 - size_of[max_son]) {
        ll min_now = 0;
        for (auto to : graph[v]) {
            if (min_now == 0 || min_son[to] < min_son[min_now])
                min_now = to;
        }
        res += min_son[min_now] * (2 * size_of[max_son] - size_of[v] + 1);
    }
    sum[v] += c[v];
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (ll i = 2; i <= n; i++) {
        cin >> p[i];
        graph[p[i]].push_back(i);
    }
    for (ll i = 2; i <= n; i++)
        cin >> c[i];
    cout << dfs(1);
    return 0;
}
