#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

struct point {
    int x, y;

    point operator +(point other)
    {
        return {x + other.x, y + other.y};
    }
    point operator -(point other)
    {
        return {x - other.x, y - other.y};
    }
    point operator /(int d)
    {
        return {x / d, y / d};
    }
};

int gcd(int a, int b)
{
    if (a == 0)
        return b;
    return gcd(b % a, a);
}

int get_det(int a, int b, int c, int d)
{
    return a * d - b * c;
}

point straight_and_straight(point A, point B, point C, point D)
{
    int a1 = B.y - A.y;
    int b1 = A.x - B.x;
    int c1 = A.y * B.x - A.x * B.y;
    int a2 = D.y - C.y;
    int b2 = C.x - D.x;
    int c2 = C.y * D.x - C.x * D.y;
    if (get_det(a1, b1, a2, b2) == 0)
        return {INF, INF};
    int X = get_det(b1, c1, b2, c2) / get_det(a1, b1, a2, b2);
    int Y = get_det(c1, a1, c2, a2) / get_det(a1, b1, a2, b2);
    if (a1 * X + b1 * Y + c1 != 0 || a2 * X + b2 * Y + c2 != 0)
        return {INF, INF};
    return {X, Y};
}

int n;
vector<point> vect;

bool is_clear(point M)
{
    for (int i = 0; i < vect.size(); i++) {
        if (M.x == vect[i].x && M.y == vect[i].y)
            return false;
    }
    return true;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    cin >> n;
    if (n == 1) {
        point A, B;
        int g = gcd(abs(B.x - A.x), abs(B.y - A.y));
        point V = B - A;
        V = V / g;
        if (g != 1) {
            point M = A + V;
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        point M = A + V + V;
        if (abs(M.x) <= 1e6 && abs(M.y) <= 1e6) {
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        M = A - V - V;
        if (abs(M.x) <= 1e6 && abs(M.y) <= 1e6) {
            cout << "Yes\n" << M.x << ' ' << M.y;
            return 0;
        }
        cout << "No";
        return 0;
    }
    for (int i = 0; i < 2 * n; i++) {
        point now;
        cin >> now.x >> now.y;
        vect.push_back(now);
    }
    for (int a = 0; a < vect.size(); a++) {
        for (int b = 0; b < vect.size(); b++) {
            for (int c = 0; c < vect.size(); c++) {
                for (int d = 0; d < vect.size(); d++) {
                    if (a == b || a == c || a == d || b == c || b == d || c == d)
                        continue;
                    point A = vect[a];
                    point B = vect[b];
                    point C = vect[c];
                    point D = vect[d];
                    point M = straight_and_straight(A, B, C, D);
                    if (is_clear(M) && abs(M.x) <= 1e6 && abs(M.y) <= 1e6) {
                        cout << "Yes\n" << M.x << ' ' << M.y;
                        return 0;
                    }
                }
            }
        }
    }
    cout << "No";
    return 0;
}
