#include <iostream>
#include <algorithm>
#include <set>
#include <tuple>
using namespace std;

int n;
pair<int, int> pt[5200];
bool used[5200];
struct line { double a, b, c; };
bool operator<(line a, line b)
{
    return tie(a.a, a.b, a.c) < tie(b.a, b.b, b.c);
}
set<line> lines;
set<pair<int, int>> s;
pair<int, int> ans;
line find(pair<int, int> p1, pair<int, int> p2)
{
    double denom = p1.first * p2.second - p2.first * p1.second;
    if (denom)
        return { (p2.second - p1.second) / denom, (p1.first - p2.first) / denom, 1 };
    return { 1, -1. * p1.first / p1.second, 0 };
}
pair<double, double> inter(line p1, line p2)
{
    double denom = p1.a * p2.b - p2.a * p1.b;
    return { (p1.c * p2.b - p2.c * p1.b) / denom, (p1.a * p2.c - p2.a * p1.c) / denom };
}
bool rec(int i, int cnt)
{
    if (i == 2 * n)
    {
        if (lines.size() < n)
            return false;
        auto it = lines.begin();
        auto p1 = *it;
        ++it;
        auto p2 = *it;
        auto p = inter(p1, p2);
        auto pi = make_pair((int)p.first, (int)p.second);
        for (int i = 0; i < 2 * n; ++i)
            if (pi == pt[i])
                return false;
        ans = pi;
        return cnt == n;
    }
    if (!used[i])
    {
        used[i] = true;
        for (int j = i + 1; j < 2 * n; ++j)
        {
            if (!used[j])
            {
                used[j] = true;
                auto p1 = find(pt[i], pt[j]);
                bool ok = false;
                for (auto p2 : lines)
                {
                    auto p = inter(p1, p2);
                    if (p.first == (int)p.first && p.second == (int)p.second)
                        s.insert(p);
                }
                if (cnt == 0 || s.size() == 1)
                {
                    lines.insert(p1);
                    bool res = rec(i + 1, cnt + 1);
                    used[j] = false;
                    if (res)
                        return true;
                    lines.erase(p1);
                }
                used[j] = false;
            }
        }
        used[i] = false;
    }
    return rec(i + 1, cnt);
}
int main()
{
    cin >> n;
    for (int i = 0; i < 2 * n; ++i)
        cin >> pt[i].first >> pt[i].second;
    sort(pt, pt + 2 * n);
    if (n == 1)
    {
        for (int x = -1000000; x <= 1000000; ++x)
        {
            double y = pt[0].second + 1. * (pt[1].second - pt[0].second) / (pt[1].first - pt[0].first) * (x - pt[0].first);
            if (y == (int)y && y >= -1000000 && y <= 1000000)
            {
                cout << "Yes\n" << x << ' ' << (int)y;
                return 0;
            }
        }
    }
    if (!rec(0, 0))
    {
        cout << "No";
        return 0;
    }
    cout << "Yes\n" << ans.first << ' ' << ans.second;
}