#include <bits/stdc++.h>

#define int long long

using namespace std;

const int max_c = 1e6;

struct vect{
    int x, y;
    vect(int x1 = 0, int y1 = 0) {
        x = x1;
        y = y1;
    }
    vect operator+(const vect& b) {
        return vect(x + b.x, y + b.y);
    }
    vect operator-(const vect& b) {
        return vect(x - b.x, y - b.y);
    }
    vect operator*(const int& b) {
        return vect(x * b, y * b);
    }
    vect operator*(const vect& b) {
        return x * b.x + y * b.y;
    }
    vect operator%(const vect& b) {
        return x * b.y - y * b.x;
    }
};

struct line{
    int a, b, c;
    line(int a1 = 0, int b1 = 0, int c1 = 0) {
        a = a1;
        b = b1;
        c = c1;
    }
    line(vect p1, vect p2) {
        a = p2.y - p1.y;
        b = p1.x - p2.x;
        c = p2.x * p1.y - p1.x * p2.y;
    }
    pair <vect, bool> cross(line l) {
        int k1 = b * l.c - c * l.b;
        int k2 = a * l.b - l.a * b;
        if (k2 == 0 || k1 % k2 != 0) {
            return {vect(0, 0), false};
        }
        vect res;
        res.x = k1 / k2;
        int a1 = a, b1 = b, c1 = c;
        if (b1 == 0) {
            a1 = l.a; b1 = l.b; c1 = l.c;
        }
        if ((c1 + a1 * res.x) % b1 != 0) {
            return {vect(0, 0), false};
        }
        res.y = -(c1 + a1 * res.x) / b1;
        return {res, true};
    }
};

int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        if (a > b) swap(a, b);
        b = b % a;
    }
    return a + b;
}

vect norm(vect v) {
    vect v1 = v;
    if (v1.x == 0 && v1.y == 0) return v1;
    if (v1.x < 0 || v1.x == 0 && v1.y < 0) {
        v1.x *= -1;
        v1.y *= -1;
    }
    int g = gcd(abs(v1.x), abs(v1.y));
    v1.x = v1.x / g;
    v1.y = v1.y / g;
    return v1;
}

vector <vect> a;

bool check(vect point) {
    if (abs(point.x) > max_c || abs(point.y) > max_c) return false;
    map <pair <int, int>, int> q;
    int cnt = 0;
    for (int i = 0; i < a.size(); i++) {
        vect v = norm(a[i] - point);
        if (v.x == 0 && v.y == 0) return false;
        q[{v.x, v.y}]++;
        if (q[{v.x, v.y}] == 2) cnt++;
    }
    if (cnt * 2 == a.size()) {
        return true;
    } else {
        return false;
    }
}

signed main()
{
    int n;
    cin >> n;
    a.resize(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    vect p1 = a[0], p2 = a[1];
    for (int i = 2; i < 2 * n; i++) {
        for (int j = 2; j < 2 * n; j++) {
            if (i == j) continue;
            line l1 = line(p1, a[i]);
            line l2 = line(p2, a[j]);
            auto temp = l1.cross(l2);
            if (!temp.second) continue;
            vect point = temp.first;
            //cout << i << " " << j << endl;
            //cout << point.x << " " << point.y << " " << endl;
            if (check(point)) {
                cout << "Yes" << endl;
                cout << point.x << " " << point.y << endl;
                return 0;
            }
        }
    }
    vect p3 = a[2];
    for (int i = 3; i < 2 * n; i++) {
        line l1 = line(p1, p2);
        line l2 = line(p3, a[i]);
        auto temp = l1.cross(l2);
        if (!temp.second) continue;
        vect point = temp.first;
        if (check(point)) {
            cout << "Yes" << endl;
            cout << point.x << " " << point.y << endl;
            return 0;
        }
    }
    cout << "No" << endl;
    return 0;
}

/*
4
-1 5
1 2
2 1
3 1
3 2
5 2
5 4
4 5
*/
