#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <string>
#include <bitset>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

int szblock = 26;

vector<ll> gen_del(ll n) {
	vector<ll> del;
	for (ll i = 2; i <= n; ++i)
		if (n % i == 0)
			del.push_back(i);
	return del;
}

struct block {
	vector<vector<int> > cnt;
	block() {};
	block(int n) {
		cnt.resize(n, vector<int>(szblock, 0));
	}
};

bool is_cool(block& v) {
	for (int i = 1; i < v.cnt.size(); ++i)
		for (int j = 0; j < szblock; ++j)
			if (v.cnt[i][j] != v.cnt[0][j])
				return false;
	return true;
}

block vgen(vector<int>& s, int v) {
	block a(s.size() / v);
	int k = 0;
	for (int i = 0; i < s.size(); ++i) {
		a.cnt[k][s[i]]++;
		if ((k + 1) * v - 1 == i)
			k++;
	}
	return a;
}

block un_block(block& a, int v) {
	block res(a.cnt.size() / v);
	for (int i = 0; i < a.cnt.size(); ++i)
		for (int j = 0; j < szblock; ++j)
			res.cnt[i / v][j] += a.cnt[i][j];
	return res;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	string s;
	cin >> s;
	if (s.length() > 1000)
		szblock = 2;
	int start = 1;
	for (; start < s.length(); ++start)
		if (s[start] != s[start - 1])
			break;
	if (start == s.length()) {
		cout << s.length();
		return 0;
	}
	vector<int> ints(s.length());
	map<int, ll> mp;
	for (int i = 0; i < s.length(); ++i)
		ints[i] = s[i] - 'a';
	ll n = s.length();
	vector<ll> del = gen_del(n);
	for (int i = 0; i < del.size(); ++i)
		mp[del[i]] = i;
	vector<vector<ll> > ddel;
	for (int i = 0; i < del.size(); ++i)
		ddel.push_back(gen_del(del[i]));
	vector<block> v;
	for (int i = 0; i < del.size(); ++i) {
		if (ddel[i].size() <= 1) {
			v.push_back(vgen(ints, del[i]));
		} else {
			ll val = ddel[i][ddel[i].size() - 2];
			int k = mp[val];
			v.push_back(un_block(v[k], del[i] / val));
		}
		if (is_cool(v.back())) {
			cout << s.length() / del[i];
			return 0;
		}
	}

#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

