#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <random>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

#define forn(n) for(int i = 0; i < (n); ++i)
#define fornm(n, m) for(int i = 0; i < (n); ++i) for (int j = 0; j < m; ++j)
#define sqr(a) ((a)*(a))

typedef long long ll;
typedef short int sint;
typedef pair<int, int> pii;
typedef vector<int> vint;
typedef vector<ll> vll;
typedef vector<pair<int, int> > vpint;

mt19937 rnd;

vector<vector<int> > g;
vector<ll> sum, mn, cnt, c;

const ll INF = 1e18;

ll build_cnt(int v) {
	cnt[v] = 1;
	for (int to : g[v])
		cnt[v] += build_cnt(to);
	return cnt[v];
}

ll build_sum(int v) {
	sum[v] = c[v];
	for (int to : g[v])
		sum[v] += build_sum(to);
	return sum[v];
}

ll build_mn(int v) {
	mn[v] = c[v];
	for (int to : g[v])
		mn[v] = min(build_mn(to), mn[v]);
	return mn[v];
}

ll res = 0;

void dfs(int v) {
	if (g[v].size() == 0)
		return;
	ll mx = g[v][0];
	for (int to : g[v]) {
		dfs(to);
		if (cnt[to] > cnt[mx])
			mx = to;
	}
	if (cnt[mx] >= cnt[v] - 1 - cnt[mx]) {
		ll curmn = INF;
		for (int to : g[v])
			if (mx != to)
				curmn = min(curmn, mn[to]);
		res += sum[v] - c[v] + (2 * cnt[mx] - cnt[v] + 1) * curmn;
	}
	else {
		ll curmn = INF;
		for (int to : g[v])
			curmn = min(curmn, mn[to]);
		res += (sum[v] - c[v]);
		if (cnt[v] % 2 == 0)
			res += curmn;
	}
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n;
	cin >> n;
	g.resize(n);
	sum.resize(n, 0), mn.resize(n, 0), cnt.resize(n, 0), c.resize(n, 0);
	for (int i = 0; i < n - 1; ++i) {
		int p;
		cin >> p;
		g[p - 1].push_back(i + 1);
	}
	for (int i = 1; i < n; ++i)
		cin >> c[i];
	build_cnt(0);
	build_sum(0);
	build_mn(0);
	dfs(0);
	cout << res;
#ifndef ONLINE_JUDGE
	//cout << '\n';
	//cout << fixed << setprecision(6) << (double)clock() / CLOCKS_PER_SEC << '\n';
#endif
	return 0;
}

