#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


int gcd(int a, int b) {
    int temp;

    while (b) {
        temp = a;
        a = b;
        b = temp % b;
    }

    return a;
}


int ALP = 26;


#define left(v) 2 * v + 1
#define right(v) 2 * v + 2
#define parent(v) (v - 1) / 2

class LST {
private:
    int **data;
    int head_size;

    void update(int v) {
        int l = left(v), r = right(v);

        for (int i = 0; i < ALP; ++i) {
            data[v][i] = data[l][i] + data[r][i];
        }
    }

public:
    LST(string &s) {
        int n = s.length();

        int m = 1;
        for (; m < n; m <<= 1);

        head_size = m - 1;

        data = new int*[head_size + m];
        for (int i = 0; i < head_size + m; ++i) {
            data[i] = new int[ALP];
        }

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < ALP; ++j) {
                data[head_size + i][j] = 0;
            }

            data[head_size + i][s[i] - 'a'] = 1;
        }

        for (int i = head_size - 1; i >= 0; --i) {
            update(i);
        }
    }

    int query(int L, int R, int c) {
        L += head_size;
        R += head_size - 1;

        int left_res = 0, right_res = 0;

        while (L < R) {
            if (L % 2 == 0) {
                left_res += data[L++][c];
            }

            L = parent(L);

            if (R % 2) {
                right_res += data[R--][c];
            }

            R = parent(R);
        }

        if (L == R) {
            left_res += data[L][c];
        }

        return left_res + right_res;
    }
};

#undef left
#undef right
#undef parent


int main() {
    string s;
    cin >> s;

    int n = s.length();

    vector<int> cnt(26, 0);
    for (int i = 0; i < n; ++i) {
        ++cnt[s[i] - 'a'];
    }

    if (cnt[0] + cnt[1] == n) {
        ALP = 2;
    }

    vector<int> alp;
    for (int i = 0; i < ALP; ++i) {
        if (cnt[i]) {
            alp.push_back(i);
        }
    }

    int cd = n;
    for (int i = 0; i < ALP; ++i) {
        cd = gcd(cd, cnt[i]);
    }

    if (cd == 1) {
        cout << 1;

        return 0;
    }

    vector<int> divisors;
    for (int i = 2; i * i <= cd; ++i) {
        if (cd % i == 0) {
            divisors.push_back(i);
            divisors.push_back(cd / i);
        }
    }

    divisors.push_back(cd);

    sort(divisors.rbegin(), divisors.rend());

    LST tree(s);

    for (int d : divisors) {
        bool can_we = true;
        int cn = n / d;

        for (int c : alp) {
            int needed = cnt[c] / d;
            for (int i = 0; i < n; i += cn) {
                if (tree.query(i, i + cn, c) != needed) {
                    can_we = false;
                    break;
                }
            }
            
            if (!can_we) {
                break;
            }
        }

        if (can_we) {
            cout << d;

            return 0;
        }
    }

    cout << 1;

    return 0;
}