#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


using lint = long long int;


const lint INF = (lint)1e9;


vector<vector<int>> graph;
vector<lint> c;


lint dfs(int n, lint &size, lint &sum, lint &minc) {
    if (graph[n].empty()) {
        size = 1;
        sum = c[n];
        minc = c[n];

        return 0;
    }

    int cn = graph[n].size();
    vector<lint> sizes(cn), mins(cn);

    lint res = 0;
    size = 1;
    sum = 0;
    lint sum_add;
    for (int i = 0; i < cn; ++i) {
        res += dfs(graph[n][i], sizes[i], sum_add, mins[i]);
        size += sizes[i];
        sum += sum_add;
    }

    lint first_min = INF;
    int fmin_ind;

    for (int i = 0; i < cn; ++i) {
        if (mins[i] < first_min) {
            first_min = mins[i];
            fmin_ind = i;
        }
    }

    lint second_min = INF;
    int smin_ind;

    for (int i = 0; i < fmin_ind; ++i) {
        if (mins[i] < second_min) {
            second_min = mins[i];
            smin_ind = i;
        }
    }

    for (int i = fmin_ind + 1; i < cn; ++i) {
        if (mins[i] < second_min) {
            second_min = mins[i];
            smin_ind = i;
        }
    }

    minc = first_min;

    lint max_size = 0;
    lint size_sum = 0;
    int msize_ind;

    for (int i = 0; i < cn; ++i) {
        size_sum += sizes[i];
        if (sizes[i] > max_size) {
            max_size = sizes[i];
            msize_ind = i;
        }
    }

    if (max_size > size_sum - max_size) {
        lint left = 2 * max_size - size_sum;

        if (fmin_ind == msize_ind) {
            res += left * second_min;
        } else {
            res += left * first_min;
        }
    } else if (size_sum % 2) {
        res += first_min;
    }

    res += sum;

    sum += c[n];

    return res;
}


int main() {
    int n;
    cin >> n;

    graph.resize(n);
    c.resize(n);
    
    int p;
    for (int i = 1; i < n; ++i) {
        cin >> p;

        graph[p - 1].push_back(i);
    }

    for (int i = 1; i < n; ++i) {
        cin >> c[i];
    }

    lint d1, d2, d3;
    cout << dfs(0, d1, d2, d3);

    return 0;
}