#include <iostream>
#include <fstream>
#include <vector>
#include <math.h>
#include <stdlib.h>
using namespace std;

#define pb push_back
#define pii pair<int, int>
#define mp make_pair
#define fi first
#define se second
#define llong long long
#define ullong unsigned long long
#define dlong long double
#define endl '\n'

const double EPS = 1e-9;

struct point{
    double x, y;
    point(double a=0.0, double b=0.0): x(a), y(b) {}
};

vector<point> dot;
struct seg{
    point a, b;
    seg(point a_, point b_): a(a_), b(b_) {}
};

bool cross(seg seg1, seg seg2, point &res) {
    double a1 = seg1.a.x - seg1.b.x;
    double b1 = seg1.b.y - seg1.a.y;
    double c1 = -a1*b1;

    double a2 = seg2.a.x - seg2.b.x;
    double b2 = seg2.b.y - seg2.a.y;
    double c2 = -a2*b2;

    double zn = a1*b2 - a2*b1;
    double det1 = c1*a2 - c2*a1;
    double det2 = c2*b1 - c1*b2;

    if (zn == 0) return 0;

    res.x = det1 / zn;
    res.y = det2 / zn;
    return 1;
}

int gcd(int a, int b) {
    if (a==0 || b==0) return a+b;
    return gcd(b%a, a);
}

int main()
{
    ios_base::sync_with_stdio(false);
    ifstream fin("input.txt");
    ofstream fout("output.txt");

    int n; fin >> n;
    int a, b;
    for (int i=0; i<2*n; i++) {
        fin >> a >> b;
        dot.pb(point(a, b));
    }

    if (n<=2) {
        if (n==1) {
            double move_x = dot[1].x - dot[0].x;
            double move_y = dot[1].y - dot[0].y;
            fout << "Yes\n" << dot[1].x + move_x << ' ' << dot[1].y + move_y;
        } else {
            point p;
            if (cross(seg(dot[0], dot[1]), seg(dot[2], dot[3]), p)) {
                if (fabs(p.x - int(p.x)) <= EPS && fabs(p.y - int(p.y)) <= EPS) {
                    fout << "Yes\n" << int(p.x) << ' ' << int(p.y);
                    return 0;
                }
            }
            if (cross(seg(dot[0], dot[2]), seg(dot[1], dot[3]), p)) {
                if (fabs(p.x - int(p.x)) <= EPS && fabs(p.y - int(p.y)) <= EPS) {
                    fout << "Yes\n" << int(p.x) << ' ' << int(p.y);
                    return 0;
                }
            }
            if (cross(seg(dot[0], dot[3]), seg(dot[1], dot[2]), p)) {
                if (fabs(p.x - int(p.x)) <= EPS && fabs(p.y - int(p.y)) <= EPS) {
                    fout << "Yes\n" << int(p.x) << ' ' << int(p.y);
                    return 0;
                }
            }
            fout << "No";
        }
        return 0;
    }



    fin.close();
    fout.close();
    return 0;
}
