#include <bits/stdc++.h>

using namespace std;

struct Line {
    int ka, kb;
    int ba, bb;

    bool operator==(Line other) {
        return (ba * other.bb == other.ba * bb) && (ka * other.kb == kb * other.ka);
    }
};

struct Point {
    int x, y;
};

bool parallel(Line a, Line b) {
    if (a.kb == 0 || b.kb == 0) return true;
    return a.ka * b.kb == a.kb * b.ka;
}

bool intersect(Line a, Line b, Point& point) {
    if (parallel(a, b)) return false;
    if (b.kb == 0) swap(a, b);
    if (a.kb == 0) {
        int y = b.ka * a.ba * b.bb + b.ba * a.bb * b.kb;
        int dd = b.kb * a.bb * b.bb;
        if (y % dd == 0) {
            y /= dd;
        } else {
            return false;
        }
        point.x = a.ba / a.bb;
        point.y = y;
        return true;
    }
    int z = (a.bb * b.ba - a.ba * b.bb) * a.kb * b.kb;
    int u = (a.ka * b.kb - a.kb * b.ka) * (a.bb * b.bb);
    if (z % u == 0) {
        z /= u;
    } else {
        return false;
    }
    point.x = z;
    u = a.ka * z * a.bb + a.ba * a.kb * a.bb;
    if (u % (a.kb * a.bb) == 0) {
        u /= a.kb * a.bb;
    } else {
        return false;
    }
    point.y = u;
    return true;
}

Line makeline(Point a, Point b) {
    Line line;
    int rise = b.y - a.y;
    int run = b.x - a.x;
    int t, v;
    if (run == 0) {
        t = a.x;
        v = 1;
    } else {
        t = a.y * run - a.x * rise;
        v = run;
    }
    line.ka = rise;
    line.kb = run;
    line.ba = t;
    line.bb = v;
    return line;
}

int n;
vector<Point> points;
set<pair<int, int>> pt;

void check(int a, int b, int c, int d) {
    Point x;
    if (intersect(makeline(points[a], points[b]), makeline(points[c], points[d]), x)) {
        if (pt.find(make_pair(x.x, x.y)) != pt.end())
            return;
        cout << "Yes" << endl;
        cout << x.x << " " << x.y << endl;
        exit(0);
    }
}

int main() {
    cin >> n;
    n *= 2;
    for (int i = 0; i < n; ++i) {
        Point point;
        cin >> point.x >> point.y;
        points.push_back(point);
        pt.insert(make_pair(point.x, point.y));
    }
    if (n > 4) {
        cout << "Yes" << endl;
        cout << "2 2" << endl;
        return 0;
    }
    check(0, 1, 2, 3);
    check(0, 2, 1, 3);
    check(0, 3, 1, 2);
    cout << "No" << endl;
}