// #pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

#define int long long
#define all(v) v.begin(), v.end()
#define len(v) ((int)v.size())
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return false;
	}
	return true;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return false;
	}
	return true;
}

void run();

signed main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

struct Vector
{
	int x, y;

	Vector() : x(0), y(0) {}
	Vector(int x, int y) : x(x), y(y) {}

	bool operator==(const Vector &v) const
	{
		return x == v.x && y == v.y;
	}
} bad(-13371488, 14881337);

struct Line
{
	int a, b, c;

	Line(int a, int b, int c) : a(a), b(b), c(c) { normalize(); }
	Line() : a(1), b(0), c(0) {}
	Line(const Vector &p1, const Vector &p2)
	{
		Vector v = Vector(p1.x - p2.x, p1.y - p2.y);
		a = -v.y;
		b = v.x;
		c = -(a * p1.x + b * p1.y);
		normalize();
	}

	void normalize()
	{
		if (a < 0 || (a == 0 && b < 0))
		{
			a *= -1;
			b *= -1;
			c *= -1;
		}
		int g = __gcd(__gcd(abs(a), abs(b)), abs(c));
		a /= g;
		b /= g;
		c /= g;
	}

	bool operator==(const Line &l) const
	{
		return l.a == a && l.b == b && l.c == c;
	}

	bool operator<(const Line &l) const
	{
		return vector<int>({a, b, c}) < vector<int>({l.a, l.b, l.c});
	}
};

istream& operator>>(istream& in, Vector &v)
{
	in >> v.x >> v.y;
	return in;
}

bool check_point(Vector p, vector<Vector> arr)
{
	if (p == bad)
		return 0;
	if (abs(p.x) > 1000000 || abs(p.y) > 1000000)
		return 0;
	for (auto &x : arr)
		if (x == p)
			return 0;
	set<Line> l;
	for (auto &x : arr)
		l.insert(Line(x, p));
	if (len(l) != len(arr) / 2)
		return 0;
	return 1;
}

Vector interesct_lines(const Line &l1, const Line &l2)
{
	int x1 = l1.b * l2.c - l2.b * l1.c;
	int x2 = l1.a * l2.b - l2.a * l1.b;
	int y1 = l1.a * l2.c - l2.a * l1.c;
	int y2 = -x2;
	if (x2 == 0 || y2 == 0)
		return bad;
	if (x1 % x2 != 0 || y1 % y2 != 0)
		return bad;
	return Vector(x1 / x2, y1 / y2);
}

void run()
{
	int n;
	cin >> n;
	n *= 2;
	vector<Vector> points(n);
	for (auto &x : points)
		cin >> x;
	for (int a = 0; a < n - 1; ++a)
		for (int b = a + 1; b < n; ++b)
			for (int c = 0; c < n - 1; ++c)
				for (int d = c + 1; d < n; ++d)
				{
					Line l1(points[a], points[b]), l2(points[c], points[d]);
					if (check_point(interesct_lines(l1, l2), points))
					{
						Vector v = interesct_lines(l1, l2);
						cout << "Yes" << endl << v.x << " " << v.y << endl;
						return;
					}
				}
	cout << "No" << endl;
}