import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;

public class D {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
              neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while(i < n) {
            int c = r.read();
            if(c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        String s = r.readLine();
        int[] charCount = new int['z' - 'a'];
        Set<Integer> presentChars = new HashSet<>();
        for(char c : s.toCharArray()) {
            charCount[c - 'a']++;
            presentChars.add(c - 'a');
        }
        int frac = getFrac(presentChars, charCount);
        if(frac == -1 || frac == 1) {
            System.out.println(1);
            return;
        }
        int partLen = 0;
        for(int c : presentChars) {
            partLen += charCount[c] / frac;
        }
        System.out.println(s.length() / partLen);
    }

    private static int getFrac(Set<Integer> presentChars, int[] charCount) {
        int frac = -1;
        for(int i : presentChars) {
            for(int j : presentChars) {
                if(i == j) continue;
                int ic = charCount[i], jc = charCount[j];
                switch (Integer.compare(ic, jc)) {
                    case 1: {
                        int curFrac = ic / (ic / jc);
                        if(frac == -1) {
                            frac = curFrac;
                        } else if(frac != curFrac) {
                            return -1;
                        }
                        break;
                    }
                    case 0: {
                        if(frac == -1) {
                            frac = 1;
                        } else if (frac != 1) {
                            return -1;
                        }
                        break;
                    }
                    case -1: {
                        int curFrac = jc / (jc / ic);
                        if(frac == -1) {
                            frac = curFrac;
                        } else if(frac != curFrac) {
                            return -1;
                        }
                        break;
                    }
                }
            }
        }
        return frac;
    }

}
