import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class B {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static class Node {
        Node parent;
        List<Node> children = new LinkedList<>();
        int id;
        int c;

        Node(int id, int c, Node parent) {
            this.id = id;
            this.parent = parent;
            this.c = c;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStreamReader rd = new InputStreamReader(System.in);
        int n = readArgsInt(rd, 1)[0];
        int[] p = readArgsInt(rd, n - 1);
        int[] c = readArgsInt(rd, n - 1);
        Node[] nodes = new Node[n];
        nodes[0] = new Node(0, 0, null);
        for (int i = 0; i < n - 1; i++) {
            Node parent = nodes[p[i] - 1];
            Node child = new Node(i + 1, c[i], parent);
            parent.children.add(child);
            nodes[i + 1] = child;
        }
        int minC = 0;
        for (Node nd : nodes) {
            List<Node> ns = new ArrayList<>();
            Queue<Node> nq = new LinkedList<>();
            nq.add(nd);
            Node cur;
            while ((cur = nq.poll()) != null) {
                ns.addAll(cur.children);
                nq.addAll(cur.children);
            }
            int localMin = Integer.MAX_VALUE;
            Queue<Node> lateCheck = new LinkedList<>();
            int l = 0, r = ns.size() - 1;
            while(l < r) {
                Node ln = ns.get(l), rn = ns.get(r);
                if(isParent(ln, rn)) {
                    lateCheck.add(ln);
                    l++;
                } else if(isParent(rn, ln)) {
                    lateCheck.add(rn);
                    r--;
                } else {
                    minC += ln.c + rn.c;
                    l++;
                    r--;
                }
            }
            if(ns.size() % 2 != 0) {
                lateCheck.add(ns.get(l));
            }
            ns.sort(Comparator.comparingInt(x -> x.c));
            while((cur = lateCheck.poll()) != null) {
                int ix = 0;
                Node minNode;
                while(isParent(cur, minNode = ns.get(ix))) {
                    ix++;
                }
                minC += minNode.c + cur.c;
            }
        }
        System.out.println(minC);
    }

    private static boolean isParent(Node child, Node parent) {
        do {
            if(child.id < parent.id) {
                return false;
            }
            if(child.parent == parent) {
                return true;
            }
        } while((child = child.parent) != null);
        return false;
    }

}
