import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class C {


    private static long[] readArgs(InputStreamReader r, int n) throws IOException {
        long[] ret = new long[n];
        int i = 0;
        long curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static int[] readArgsInt(InputStreamReader r, int n) throws IOException {
        int[] ret = new int[n];
        int i = 0;
        int curNum = 0;
        boolean neg = false;
        while (i < n) {
            int c = r.read();
            if (c == ' ' || c == '\n') {
                ret[i++] = neg ? -curNum : curNum;
                curNum = 0;
                neg = false;
            } else if (c == '-') {
                neg = true;
            } else {
                curNum *= 10;
                curNum += (c - 48);
            }
        }
        return ret;
    }

    private static class Node {
        Node parent;
        List<Node> children = new LinkedList<>();
        int id;
        int c;
        boolean[] argue;

        Node(int id, int c, Node parent) {
            this.id = id;
            argue = new boolean[id];
            this.parent = parent;
            this.c = c;
        }

        @Override
        public String toString() {
            return "N(" + (id + 1) + ")";
        }
    }

    public static void main(String[] args) throws IOException {
        InputStreamReader rd = new InputStreamReader(System.in);
        int n = readArgsInt(rd, 1)[0];
        int[] p = readArgsInt(rd, n - 1);
        int[] c = readArgsInt(rd, n - 1);
        Node[] nodes = new Node[n];
        nodes[0] = new Node(0, 0, null);
        for (int i = 0; i < n - 1; i++) {
            Node parent = nodes[p[i] - 1];
            Node child = new Node(i + 1, c[i], parent);
            parent.children.add(child);
            nodes[i + 1] = child;
        }
        int minC = 0;
        for(Node nd : nodes) {
            Node par = nd.parent;
            while(par != null) {
                    Queue<Node> aq = new LinkedList<>();
                    aq.addAll(par.children);
                    Node cur;
                    while((cur = aq.poll()) != null) {
                        if(cur == nd) continue;
                        Node closestPar = findClosestParent(nd, cur);
                        if(!nd.argue[closestPar.id] && !cur.argue[closestPar.id]) {
                            minC += 2;
                            nd.argue[closestPar.id] = true;
                            cur.argue[closestPar.id] = true;
                        }
                    }
                if(!nd.argue[par.id]) {
                    minC += 2;
                }
                par = par.parent;
            }

        }
        System.out.println(minC);
    }

    private static boolean isParent(Node child, Node parent) {
        do {
            if(child.id < parent.id) {
                return false;
            }
            if(child.parent == parent) {
                return true;
            }
        } while((child = child.parent) != null);
        return false;
    }

    private static Node findClosestParent(Node n1, Node n2) {
        Node parent = n1.parent;
        Node parent2 = n2.parent;
        while(parent != parent2) {
            if(parent.id > parent2.id) {
                parent = parent.parent;
            } else {
                parent2 = parent2.parent;
            }
        }
        return parent;
    }
}
