#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<string>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

string s;
vector < int > perebor;
vector < vector < int > > psum;

int get_sum(int l, int r,	vector < int > sum) {
	if (l == 0) {
		return sum[r];
	}
	return sum[r] - sum[l - 1];
}

bool check(int len) {
	if (len == s.size()) {
		return true;
	}
	vector < int > cnt(26, 0);
	for (int i = 0; i < 26; i++) {
		cnt[i] = get_sum(0, len - 1, psum[i]);
	}
	for (int i = 0; i < s.size() / len; i++) {
		for (int j = 0; j < 26; j++) {
			int temp = get_sum(len * i, len*i + len - 1, psum[j]);
			if (temp != cnt[j]) return false;
		}
	}
	return true;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	cin >> s;
	
	vector < int > cnt(26, 0);

	for (int i = 0; i < s.size(); i++) {
		cnt[s[i] - 'a']++;
	}

	for (int i = 1; i <= sqrt(s.size()); i++) {
		if (s.size() % i == 0) {
			int count = s.size() / i;
			bool ok = true;
			for (int j = 0; j < 26; j++) {
				if (cnt[j] % count != 0) {
					ok = false;
					break;
				}
			}
			if (ok) {
				perebor.push_back(i);
			}



			count = i;
			ok = true;
			for (int j = 0; j < 26; j++) {
				if (cnt[j] % count != 0) {
					ok = false;
					break;
				}
			}
			if (ok) {
				perebor.push_back(s.size() / i);
			}

		}
	}
	

	sort(perebor.begin(), perebor.end());
	psum.assign(26, vector < int >(s.size(), 0));
	
	psum[s[0] - 'a'][0] = 1;
	for (int i = 1; i < s.size(); i++) {
		for (int j = 0; j < 26; j++) {
			psum[j][i] = psum[j][i - 1];
		}
		psum[s[i] - 'a'][i]++;
	}

	for (int i = 0; i < perebor.size(); i++) {
		int len = perebor[i];
		bool ok = true;
		for (int j = 0; j < 26; j++) {
			int temp = get_sum(0, len - 1, psum[j]);
			int cnt_now = s.size() / len;
			if (temp * cnt_now != cnt[j]) {
				ok = false;
				continue;
			}
		}

		if (!ok) continue;

		if (check(len)) {
			cout << s.size() / len;
			system("pause");
			return 0;
		}
	}




	system("pause");
	return 0;
}