#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<string>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

const long long inf = 1e9;

vector < vector  <long long > > g;
vector < long long > dp;
vector < long long > min1;
vector < long long > sum;
vector < long long > cnt;
vector < long long > c;
long long n;

void calc_dfs(long long v) {
	dp[v] = sum[v] = c[v];
	cnt[v] = 1;
	for (auto to : g[v]) {
		calc_dfs(to);
		dp[v] = min(dp[v], dp[to]);
		sum[v] += sum[to];
		cnt[v] += cnt[to];
	}
	return;
}

long long ans = 0;

void dfs(long long v) {
	if (g[v].size() == 0) {
		return;
	}
	
	set < pair < int, int > > temp;
	long long now_ans = inf;

	pair < int, int > good = { -1, -1 };


	for (auto to : g[v]) {
		if (good.second == -1 && dp[to] == min1[v]) {
			good = { cnt[to], to };
			continue;
		}
		temp.insert({ -1 * cnt[to], to });
	}

	while (good.first > 0) {
		if (temp.size() == 0) {
			break;
		}
		auto one = *temp.begin();
		temp.erase(temp.begin());
		one.first++;
		if (one.first != 0) {
			temp.insert(one);
		}
		good.first--;
	}

	if (good.first != 0) {
		for (auto to : g[v]) {
			ans += sum[to];
		}

		int u = good.second;
		int delta = good.first;

		long long mins = inf;

		for (auto to : g[v]) {
			if (u == to) continue;
			mins = min(mins, dp[to]);
		}
		ans += delta * mins;
		return;
	}




	while (temp.size() > 1) {
		auto one = *temp.begin();
		temp.erase(temp.begin());
		auto two = *temp.begin();
		temp.erase(temp.begin());
		one.first++;
		two.first++;
		if (one.first != 0)
			temp.insert(one);
		if (two.first != 0)
			temp.insert(two);
	}
	for (auto to : g[v]) {
		ans += sum[to];
	}
	if (temp.size() == 1) {
		auto now = *temp.begin();
		
		int u = now.second;
		int delta = -1 * now.first;

		long long mins = inf;

		for (auto to : g[v]) {
			if (u == to) continue;
			mins = min(mins, dp[to]);
		}

		ans += delta * mins;
	}
	return;
	
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	g.assign(n, vector < long long >());
	c.assign(n, 0);
	dp.assign(n, inf);
	cnt.assign(n, 0);
	sum.assign(n, 0);
	min1.assign(n, inf);

	for (int i = 1; i < n; i++) {
		long long val;
		cin >> val;
		val--;
		g[val].push_back(i);
	}

	for (int i = 1; i < n; i++) {
		cin >> c[i];
	}

	calc_dfs(0);

	for (int i = 0; i < n; i++) {
		min1[i] = inf;
		for (auto to : g[i]) {
			min1[i] = min(min1[i], dp[to]);
		}
	}

	for (int i = 0; i < n; i++) {
		dfs(i);
	}

	cout << ans;

	system("pause");
	return 0;
}