#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<string>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

const int inf = 1e9;

vector < vector  <int > > g;
vector < int > dp;
vector < int > min1, min2;
vector < int > sum;
vector < int > cnt;
vector < int > c;
long long n;

void calc_dfs(int v) {
	dp[v] = c[v];
	cnt[v] = 1;
	sum[v] = c[v];
	for (auto to : g[v]) {
		calc_dfs(to);
		dp[v] = min(dp[v], dp[to]);
		sum[v] += sum[to];
		cnt[v] += cnt[to];
	}
	return;
}

long long ans = 0;

void dfs(int v) {
	if (g[v].size() == 0) {
		return;
	}
	vector < pair < int, int > > q;
	long long delta = 0;
	for (auto to : g[v]) {
		delta += cnt[to];
		q.push_back({ cnt[to], to });
	}

	sort(q.rbegin(), q.rend()); 

	long long now = 0;
	long long id = 0;
	for (int i = 0; i < q.size(); i++) {
		if (now <= q[i].first) {
			delta -= now * 2;
			now = q[i].first - now;
			id = i;
		}
		else {
			delta -= q[i].first * 2;
			now -= q[i].first;
		}
	}

	for (auto to : g[v]) {
		ans += sum[to];
	}
	long long u = q[id].second;
	if (dp[u] == min1[v]) {
		long long mins = c[u];
		for (auto to : g[v]) {
			if (u == to)
				continue;
			mins = min(mins, (long long) dp[to]);
		}
		ans += delta * mins;
	}
	else {
		ans += delta * min1[v];
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	g.assign(n, vector < int >());
	c.assign(n, 0);
	dp.assign(n, 1e9);
	cnt.assign(n, 0);
	sum.assign(n, 0);
	min1.assign(n, inf);
	min2.assign(n, inf);

	for (int i = 1; i < n; i++) {
		int val;
		cin >> val;
		val--;
		g[val].push_back(i);
	}

	for (int i = 1; i < n; i++) {
		cin >> c[i];
	}
	calc_dfs(0);

	for (int i = 0; i < n; i++) {
		if (g[i].size() == 0) {
			continue;
		}
		long long m1 = inf;
		long long m2 = inf;
		for (auto to : g[i]) {
			if (m1 >= dp[to]) {
				m2 = m1;
				m1 = dp[to];
				continue;
			}
			if (m2 > dp[to]) {
				m2 = dp[to];
			}
		}
		min1[i] = m1;
		min2[i] = m2;
	}
	for (int i = 0; i < n; i++) {
		dfs(i);
	}

	cout << ans;

//	system("pause");
	return 0;
}