#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

long long max_n = (1ll << 62) - 1 + (1ll << 62);

struct point
{
    long long x, y;
    point() {}
    point(long long a, long long b): x(a), y(b) {};

    bool operator<(point b)
    {
        if (x == b.x)
            return y < b.y;
        return x < b.x;
    }

    bool operator==(point b)
    {
        return (x == b.x) && (y == b.y);
    }

    bool operator>(point b)
    {
        if (x == b.x)
            return y > b.y;
        return x > b.x;
    }

    void operator-=(point b)
    {
        x -= b.x;
        y -= b.y;
    }

    void operator+=(point b)
    {
        x += b.x;
        y += b.y;
    }
};

bool cmp(point a, point b)
{
    if (a.x == 0 && b.x == 0)
        return a.y > b.y;
    if (a.x == 0)
        return true;
    if (b.x == 0)
        return false;
    if (a.x * b.x > 0)
        return a.y * b.x >= a.x * b.y;
    return a.y * b.x <= a.x * b.y;
}

bool cmp1(point a, point b)
{
    if (a.x == b.x)
        return a.y < b.y;
    return a.x < b.x;
}

long long gcd(long long a, long long b)
{
    a = abs(a);
    b = abs(b);
    if (b > a)
        swap(b, a);
    while (b > 0)
    {
        long long c = a % b;
        a = b;
        b = c;
    }
    return a;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    point p[2 * n];
    for (int i = 0; i < 2 * n; i++)
    {
        cin >> p[i].x >> p[i].y;
    }
    sort(p, p + 2 * n, cmp1);
    for (int i = 2; i <= 2 * n; i++)
    {
        long long a1, b1, c1;
        if (i == 2 * n)
        {
            a1 = p[0].y - p[1].y;
            b1 = p[1].x - p[0].x;
            c1 = -(a1 * p[0].x + b1 * p[0].y);
        }
        else
        {
            a1 = p[0].y - p[i].y;
            b1 = p[i].x - p[0].x;
            c1 = -(a1 * p[0].x + b1 * p[0].y);
        }
        if (b1 < 0)
        {
            a1 *= -1;
            b1 *= -1;
            c1 *= -1;
        }
        long long f = gcd(c1, gcd(a1, b1));
        a1 /= f;
        b1 /= f;
        c1 /= f;
        for (int e = 2; e < 2 * n; e++)
        {
            long long a2, b2, c2;
            if (i == 2 * n)
            {
                if (e == 2)
                    continue;
                a2 = p[2].y - p[e].y;
                b2 = p[e].x - p[2].x;
                c2 = -(a2 * p[2].x + b2 * p[2].y);
            }
            else
            {
                if (e == i)
                    continue;
                a2 = p[1].y - p[e].y;
                b2 = p[e].x - p[1].x;
                c2 = -(a2 * p[1].x + b2 * p[1].y);
            }
            if (b2 < 0)
            {
                a2 *= -1;
                b2 *= -1;
                c2 *= -1;
            }
            long long f = gcd(c2, gcd(a2, b2));
            a2 /= f;
            b2 /= f;
            c2 /= f;
            //cout << a1 << " " << b1 << " " << c1 << " " << a2 << " " << b2 << " " << c2 << "\n";
            if (a1 * b2 == b1 * a2)
                continue;
            long long lx = -1000002;
            long long rx = 1000002;
            long long ly;
            if (b1 == 0)
            {
                if (c1 % a1 == 0)
                    lx = -c1 / a1;
                else
                    continue;
                if (abs(lx) > 1000000)
                    continue;
                if ((a2 * lx + c2) % b2 == 0)
                    ly = -(a2 * lx + c2) / b2;
                else
                    continue;
            }
            else if (b2 == 0)
            {
                if (c2 % a2 == 0)
                    lx = -c2 / a2;
                else
                    continue;
                if (abs(lx) > 1000000)
                    continue;
                if ((a1 * lx + c1) % b1 == 0)
                    ly = -(a1 * lx + c1) / b1;
                else
                    continue;
            }
            else if ((a1 * lx + c1) * b2 <= (a2 * lx + c2) * b1)
            {
                while (rx - lx > 1)
                {
                    long long m = (rx + lx) / 2;
                    if ((a1 * m + c1) * b2 <= (a2 * m + c2) * b1)
                        lx = m;
                    else
                        rx = m;
                }
                if ((a1 * lx + c1) * b2 != (a2 * lx + c2) * b1 || (a1 * lx + c1) % b1 != 0)
                    continue;
                ly = -(a1 * lx + c1) / b1;
            }
            else
            {
                while (rx - lx > 1)
                {
                    long long m = (rx + lx) / 2;
                    if ((a1 * m + c1) * b2 >= (a2 * m + c2) * b1)
                        lx = m;
                    else
                        rx = m;
                }
                if ((a1 * lx + c1) * b2 != (a2 * lx + c2) * b1 || (a1 * lx + c1) % b1 != 0)
                    continue;
                ly = -(a1 * lx + c1) / b1;
            }
            point q(lx, ly);
                if (abs(q.y) > 1000000)
                    continue;
                if (abs(q.x) > 1000000)
                    continue;
                int pos = lower_bound(p, p + 2 * n, q) - p;
                if ((pos < 2 * n) && (p[pos] == q))
                    continue;
                for (int i = 0; i < 2 * n; i++)
                {
                    p[i] -= q;
                }
                sort(p, p + 2 * n, cmp);
                int c = 1;
                int pc = 0;
                bool j = true;
                for (int i = 1; i < 2 * n; i++)
                {
                    if (p[i].x == 0)
                        c++;
                    else if (p[i - 1].x == 0)
                        c = 1;
                    else if (p[i].x * p[i - 1].y == p[i - 1].x * p[i].y)
                        c++;
                    else
                        c = 1;
                    if (c > 2 || (c == 1 && pc == 1))
                    {
                        j = false;
                        break;
                    }
                    pc = c;
                }
                for (int i = 0; i < 2 * n; i++)
                {
                    p[i] += q;
                }
                if (j)
                {
                    cout << "Yes\n";
                    cout << q.x << " " << q.y;
                    return 0;
                }
        }
    }
    cout << "No";
}
