#include <iostream>
#include <vector>
#define ff first
#define ss second

using namespace std;

const int INF = 1e9;

struct Segment {
    vector<pair<int, int>> body;
    Segment(vector<int> arr) {
        int N = 1;
        while (N < arr.size()) {
            N *= 2;
        }
        arr.resize(N, INF);
        body.resize(2 * N);
        for (int i = 0; i < N; i++) {
            body[i + N] = {arr[i], i};
        }
        for (int i = N - 1; i > 0; i--) {
            body[i] = max(body[2 * i], body[2 * i + 1]);
        }
    }

    void change(int pos, int val) {
        pos += body.size() / 2;
        body[pos].ff = val;
        pos /= 2;
        while (pos > 0) {
            body[pos] = max(body[2 * pos], body[2 * pos + 1]);
            pos /= 2;
        }
    }

    pair<int, int> find_mx(int l, int r) {
        l += body.size() / 2;
        r += body.size() / 2;
        pair<int, int> ans = {-1, -1};
        while (l <= r) {
            if (l % 2 == 1) {
                ans = max(ans, body[l]);
                l++;
            }
            if (r % 2 == 0) {
                ans = max(ans, body[r]);
                r--;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

int main() {
    int n, q;
    cin >> n >> q;
    vector<int> arr;
    arr.resize(3 * n, INF);
    vector<int> ans(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        arr[2 * i - 1] = i;
        ans[i] = 2 * i - 1;
    }
    Segment T = Segment(arr);
    int last = 2 * n - 1;
    while (1) {
        if (T.body[T.body.size() / 2 + last].ff == INF) {
            last--;
            continue;
        }
        /*
        for (int i = 0; i <= last; i++) {
            cout << T.body[T.body.size() / 2 + i].ff << " ";
        }
        cout << endl;*/
        auto res = T.find_mx(1, last);
        //cout << "! " << res.ff << " " << res.ss << " " << last << endl;
        if (res.ff != INF) break;
        //cout << T.body[T.body.size() / 2 + last].ff << endl;
        ans[T.body[T.body.size() / 2 + last].ff] = res.ss;
        /*for (auto el: ans) cout << el << " ";
        cout << endl;*/
        T.change(res.ss, T.body[T.body.size() / 2 + last].ff);
        T.change(last, INF);
        last--;
    }
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << T.body[T.body / 2 + x - 1].ff << endl;
    }
    return 0;
}
